import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core/ES2015/type";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { TrendLineType } from "igniteui-angular-core/ES2015/TrendLineType";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { PenLineCap } from "igniteui-angular-core/ES2015/PenLineCap";
import { DoubleCollection } from "igniteui-angular-core/ES2015/DoubleCollection";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
import { PointCollection } from "igniteui-angular-core/ES2015/PointCollection";
import { Clipper } from "igniteui-angular-core/ES2015/Clipper";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderingContext } from "igniteui-angular-core/ES2015/RenderingContext";
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    private ok;
    readonly ol: IAnchoredCategorySeriesInteractionManager;
    og: AnchoredCategorySeriesView;
    protected bf(): SeriesView;
    ib(a: SeriesView): void;
    oo: boolean;
    constructor();
    ov: string;
    valueColumn: IFastItemColumn$1<number>;
    private om;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    pc: Brush;
    static readonly o1: DependencyProperty;
    trendLineThickness: number;
    pe: PenLineCap;
    pd: DoubleCollection;
    trendLinePeriod: number;
    oq: number;
    c6(a: any): boolean;
    protected od(a: number, b: number, c: Axis): any[];
    protected ih(a: any, b: string, c: any, d: any): void;
    an(a: Axis): AxisRange;
    protected hi(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected nn(): number;
    op(a: CategorySeriesView): number;
    o0(a: PointCollection, b: number, c: CategorySeriesView): void;
    oe(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    of(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    hf(a: boolean, b: SeriesView): void;
    n1(a: CategoryFrame, b: CategorySeriesView): void;
    n4(a: CategoryFrame, b: CategorySeriesView): void;
    oh: CategoryFrame;
    iu(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ox(a: CategoryFrame, b: CategorySeriesView): void;
    protected i6(): void;
    fi(a: any, b: Point): any;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly trendlinePreparer: IPreparesCategoryTrendline;
    protected or: string;
    abstract oy(a: Axis): void;
    abstract oz(a: Axis): void;
    protected ho(a: any): void;
    oi: CategorySeriesMarkerCollisionAvoidance;
    ff(a: Point): any;
    oj: ConsolidatedItemHitTestBehavior;
    readonly mayContainUnknowns: boolean;
    d9(): number;
    ao(): AxisRange;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    cu: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private cv;
    cw: ITrendLineManager;
    readonly cx: boolean;
    c1(): void;
    cz(): void;
    cy(): void;
    cm(): CategoryBucketCalculator;
    c0(): void;
    c2(): void;
    c3(a: number): Rect;
    protected a2(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
    static $t: Type;
}
