import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { Base, Type, Point } from "igniteui-angular-core/ES2015/type";
import { CategoryMode } from "./CategoryMode";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Marker } from "./Marker";
import { Pool$1 } from "igniteui-angular-core/ES2015/Pool$1";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "igniteui-angular-core/ES2015/Clipper";
import { MarkerSeriesView } from "./MarkerSeriesView";
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i(a);
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s(a);
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected readonly q: List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
    static $t: Type;
}
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    protected aa: IHasCategoryTrendline;
    protected ab: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
    static $t: Type;
}
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    ms: CategoryFramePreparer;
    protected bf(): SeriesView;
    mw: CategorySeriesView;
    private m5;
    readonly m6: ICategorySeriesInteractionManager;
    ib(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    readonly categoryAxis: CategoryAxisBase;
    mn(): CategoryAxisBase;
    m7(): NumericAxisBase;
    protected get_ck(): boolean;
    readonly ck: boolean;
    constructor();
    ac(): void;
    ne: boolean;
    nd: boolean;
    protected m9: boolean;
    protected m8: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    protected ng(): boolean;
    protected nh(): boolean;
    protected n3(a: AssigningCategoryStyleEventArgs): void;
    protected n2(a: AssigningCategoryMarkerStyleEventArgs): void;
    mh(a: number, b: number): any[];
    hf(a: boolean, b: SeriesView): void;
    a8(): SeriesComponentsForView;
    hu(): void;
    nj: boolean;
    protected ja(a: Rect, b: Rect): void;
    my: CategoryTransitionInMode;
    nf: boolean;
    protected i9(a: Rect, b: Rect): void;
    protected ih(a: any, b: string, c: any, d: any): void;
    protected nb(): boolean;
    protected na(): boolean;
    nm(a: Point): number;
    protected get_c0(): boolean;
    readonly c0: boolean;
    ap(): CategoryAxisBase;
    e0(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    ff(a: Point): any;
    ey(a: Point): number;
    d3(a: Point): number;
    private m3;
    private m4;
    protected get_nc(): boolean;
    protected readonly nc: boolean;
    au(a: any, b: Point): HighlightingInfo;
    protected get_cu(): boolean;
    protected readonly cu: boolean;
    at(a: any, b: Point): HighlightingInfo;
    protected nl(): List$1<Marker>;
    protected m2(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected m1(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected m0(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    mp: CategoryFrame;
    mr: CategoryFrame;
    mo: CategoryFrame;
    mq: CategoryFrame;
    protected mv: CategorySeriesRenderManager;
    protected nz(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    protected n0(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    private nk(a);
    protected c9(): boolean;
    protected mx(): CategoryTransitionInMode;
    mz: CategoryTransitionSourceFramePreparer;
    protected hg(): void;
    iw(a: boolean): void;
    protected bo(): TransitionInSpeedType;
    protected nn(): number;
    nq(): number;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    ny(a: CategorySeriesView, b: CategoryFrame): void;
    n4(a: CategoryFrame, b: CategorySeriesView): void;
    private ob;
    protected readonly oc: Rect;
    n1(a: CategoryFrame, b: CategorySeriesView): void;
    no(a: SeriesView): number;
    np(a: SeriesView): number;
    nx(a: SeriesView): void;
    ix(a: Rect, b: RenderSurface): void;
    n5(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract ni(): boolean;
    mt(a: CategorySeriesView): CategoryFramePreparer;
    am(a: Axis): Axis;
    ag(): Axis[];
    static mi(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
    static $t: Type;
}
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    cn: CategorySeries;
    cq: number;
    cp(a: CategoryFrame): boolean;
    cs(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cl: CategoryBucketCalculator;
    cm(): CategoryBucketCalculator;
    co: Pool$1<Marker>;
    readonly shouldDisplayMarkers: boolean;
    updateMarkerCount(a: number): void;
    ca(a: (arg1: Marker) => void): void;
    cr(): void;
    static $t: Type;
}
