import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-angular-core/ES2015/type";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Dictionary$2 } from "igniteui-angular-core/ES2015/Dictionary$2";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
export declare class FinancialEventArgs extends EventArgs {
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    position: number;
    private _count;
    count: number;
    private _dataSource;
    dataSource: FinancialCalculationDataSource;
    private _supportingCalculations;
    supportingCalculations: FinancialCalculationSupportingCalculations;
    private _basedOn;
    basedOn: IList$1<string>;
    static $t: Type;
}
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    ib(a: SeriesView): void;
    l5: FinancialSeriesView;
    protected get_cq(): boolean;
    readonly cq: boolean;
    ag(): Axis[];
    protected nm(): number;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    or: Brush;
    kq(): Brush;
    hd(): void;
    lp: CategoryAxisBase;
    l9: NumericYAxis;
    n2: string;
    mh: IFastItemColumn$1<number>;
    private mg;
    nt: string;
    md: IFastItemColumn$1<number>;
    private mc;
    ny: string;
    mf: IFastItemColumn$1<number>;
    private me;
    nq: string;
    mb: IFastItemColumn$1<number>;
    private ma;
    n6: string;
    mk: IFastItemColumn$1<number>;
    private mj;
    mt: boolean;
    protected mn: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    protected mv(): boolean;
    protected oe(a: AssigningCategoryStyleEventArgs): void;
    protected lx: CategorySeriesRenderManager;
    protected oc(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    nd(a: Point): number;
    e4(a: Point, b: boolean): number;
    e2(a: Point, b: boolean): number;
    d1(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    k2(a: Point, b: boolean, c: boolean): Point;
    ee(a: Point, b: boolean, c: boolean): number;
    ea(a: Point, b: boolean, c: boolean): number;
    ec(a: Point, b: boolean, c: boolean): number;
    nf(a: Point, b: boolean, c: boolean): number;
    ng(a: Point, b: boolean, c: boolean): number;
    nh(a: Point, b: boolean, c: boolean): number;
    ky(a: Point, b: boolean, c: boolean): Point;
    k0(a: Point, b: boolean, c: boolean): Point;
    ot(a: Point, b: boolean, c: boolean): Point;
    os(a: Point, b: boolean, c: boolean): Point;
    ou(a: Point, b: boolean, c: boolean): Point;
    hu(): void;
    protected ja(a: Rect, b: Rect): void;
    protected i9(a: Rect, b: Rect): void;
    protected my: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected mz: Dictionary$2<string, string>;
    private mi(a, b, c);
    private ob(a, b);
    private mm;
    protected ih(a: any, b: string, c: any, d: any): void;
    mp(a: any): boolean;
    mo(a: any): boolean;
    protected li(a: number, b: number, c: Axis): any[];
    protected nk(a: SeriesView): number;
    protected nl(a: SeriesView): number;
    lh(a: number, b: number): any[];
    private l8;
    protected get_mr(): boolean;
    protected readonly mr: boolean;
    protected get_cu(): boolean;
    protected readonly cu: boolean;
    at(a: any, b: Point): HighlightingInfo;
    nn(a: Point): number;
    protected l7(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected l6(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected mq(): boolean;
    d3(a: Point): number;
    ey(a: Point): number;
    protected get_c0(): boolean;
    readonly c0: boolean;
    ap(): CategoryAxisBase;
    e0(a: Point): number;
    ff(a: Point): any;
    ls: CategoryFrame;
    lu: CategoryFrame;
    lr: CategoryFrame;
    protected ne(a: Rect, b: Rect, c: Rect): number;
    lz: CategoryTransitionInMode;
    mu: boolean;
    protected c9(): boolean;
    protected ly(): CategoryTransitionInMode;
    protected bo(): TransitionInSpeedType;
    of(a: CategoryFrame, b: FinancialSeriesView): void;
    private ov;
    protected readonly ow: Rect;
    od(a: CategoryFrame, b: FinancialSeriesView): void;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    l0: CategoryTransitionSourceFramePreparer;
    ni(a: FinancialSeriesView): number;
    protected hg(): void;
    iw(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected mw(a: IList$1<string>): boolean;
    readonly mx: boolean;
    protected ms(): boolean;
    protected oa(a: FinancialEventArgs): void;
    protected readonly m5: IEnumerable$1<number>;
    private _m2();
    private m2();
    protected readonly m4: IEnumerable$1<number>;
    private _m1();
    private m1();
    protected readonly m3: IEnumerable$1<number>;
    private _m0();
    private m0();
    m7(a: IList$1<number>): IList$1<number>;
    private ml;
    protected m6(): IList$1<string>;
    private nb;
    getOpenColumnAsArray(): number[];
    private m9;
    getHighColumnAsArray(): number[];
    private na;
    getLowColumnAsArray(): number[];
    private m8;
    getCloseColumnAsArray(): number[];
    private nc;
    getVolumeColumnAsArray(): number[];
    protected hi(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected l1(a: number, b: number): FinancialCalculationDataSource;
    nj(a: number): number;
    protected l2(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    readonly categoryAxis: CategoryAxisBase;
    private lt;
    ix(a: Rect, b: RenderSurface): void;
    private lq;
    iu(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    am(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private lv;
    lw: CategoryMode;
    protected get_cy(): boolean;
    readonly cy: boolean;
    i0(a: Brush, b: Brush): void;
    static $$p: string[];
    static $t: Type;
}
export declare class FinancialCalculationSupportingCalculations extends Base {
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
    static $t: Type;
}
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
    static $t: Type;
}
export declare class FinancialCalculationDataSource extends Base {
    private _openColumn;
    openColumn: IList$1<number>;
    private _closeColumn;
    closeColumn: IList$1<number>;
    private _highColumn;
    highColumn: IList$1<number>;
    private _lowColumn;
    lowColumn: IList$1<number>;
    private _volumeColumn;
    volumeColumn: IList$1<number>;
    private _indicatorColumn;
    indicatorColumn: IList$1<number>;
    private _typicalColumn;
    typicalColumn: CalculatedColumn;
    private _trueRange;
    trueRange: CalculatedColumn;
    private _trueLow;
    trueLow: CalculatedColumn;
    private _period;
    period: number;
    private _shortPeriod;
    shortPeriod: number;
    private _longPeriod;
    longPeriod: number;
    private _count;
    count: number;
    private _calculateFrom;
    calculateFrom: number;
    private _calculateCount;
    calculateCount: number;
    private _multiplier;
    multiplier: number;
    private _minimumValue;
    minimumValue: number;
    private _maximumValue;
    maximumValue: number;
    private _specifiesRange;
    specifiesRange: boolean;
    private _series;
    series: FinancialSeries;
    static $t: Type;
}
export declare abstract class FinancialSeriesView extends SeriesView {
    bu: FinancialSeries;
    bs: FinancialBucketCalculator;
    bw: number;
    bv(a: CategoryFrame): boolean;
    bx(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract bt(): FinancialBucketCalculator;
    ap(): void;
    getDefaultTooltipTemplate(): string;
    protected ac(): void;
    static $t: Type;
}
