/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventArgs, Base, Type, markType, typeCast, Point_$type, String_$type, runOn, Number_$type, enumGetBox, fromEnum, toEnum, Delegate_$type } from "igniteui-angular-core/ES2015/type";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-angular-core/ES2015/ArgumentNullException";
import { IFastItemColumn$1_$type } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { Series } from "./Series";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "igniteui-angular-core/ES2015/number";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { Dictionary$2 } from "igniteui-angular-core/ES2015/Dictionary$2";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "igniteui-angular-core/ES2015/IFastItemsSource";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "igniteui-angular-core/ES2015/TrendCalculators";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { Color } from "igniteui-angular-core/ES2015/Color";
import { stringIsNullOrEmpty } from "igniteui-angular-core/ES2015/string";
export class FinancialEventArgs extends EventArgs {
    constructor(a, b, c, d, e) {
        super();
        this._position = 0;
        this._count = 0;
        this._dataSource = null;
        this._supportingCalculations = null;
        this._basedOn = null;
        this.position = a;
        this.count = b;
        this.dataSource = c;
        this.supportingCalculations = d;
        if (c != null) {
            c.series = e;
        }
    }
    get position() {
        return this._position;
    }
    set position(a) {
        this._position = a;
    }
    get count() {
        return this._count;
    }
    set count(a) {
        this._count = a;
    }
    get dataSource() {
        return this._dataSource;
    }
    set dataSource(a) {
        this._dataSource = a;
    }
    get supportingCalculations() {
        return this._supportingCalculations;
    }
    set supportingCalculations(a) {
        this._supportingCalculations = a;
    }
    get basedOn() {
        return this._basedOn;
    }
    set basedOn(a) {
        this._basedOn = a;
    }
}
FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
export class FinancialBucketCalculator extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.c = 0;
        this.d = 0;
        this.b = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        this.a = a;
        this.c = -1;
        this.d = this.d;
        this.b = 0;
    }
    getBucket(a) {
        return null;
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getErrorBucket(a, b) {
        return NaN;
    }
    getBucketInfo(a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.bu.ek;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    }
    e(a) {
        let b = this.a.bq;
        let c = this.a.bp;
        let d = this.a.bp;
        if (this.a.bu != null) {
            d = this.a.bu.getEffectiveViewport1(this.a);
        }
        if (b.isEmpty || c.isEmpty || this.a.bu.lp == null) {
            this.b = 0;
            return;
        }
        let e = (this.a.bu.lp != null) ? this.a.bu.lp.b8 : false;
        let f = new ScalerParams(0, b, c, e, d);
        let g = this.a.bu.k7(this.a);
        let h = typeCast(ISortingAxis_$type, this.a.bu.lp);
        if (h == null || h.i$b == null) {
            let i = Math.floor(this.a.bu.lp.dw(g.left, f));
            let j = Math.ceil(this.a.bu.lp.dw(g.right, f));
            if (this.a.bu.lp.b8) {
                j = Math.ceil(this.a.bu.lp.dw(g.left, f));
                i = Math.floor(this.a.bu.lp.dw(g.right, f));
            }
            let k = Math.floor((j - i + 1) * a / g.width);
            this.b = truncate(Math.max(1, k));
            this.c = truncate(Math.floor(i / this.b));
            this.d = truncate(Math.ceil(j / this.b));
        }
        else {
            this.c = h.i$e(b, c, d, g);
            this.d = h.i$g(b, c, d, g);
            this.b = 1;
        }
    }
    cacheValues() {
    }
    unCacheValues() {
    }
}
FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
export class FinancialSeries extends Series {
    constructor() {
        super();
        this.mg = null;
        this.mc = null;
        this.me = null;
        this.ma = null;
        this.mj = null;
        this.mn = false;
        this.assigningCategoryStyle = null;
        this.lx = null;
        this.my = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
        this.mz = new Dictionary$2(String_$type, String_$type, 0);
        this.mm = false;
        this.l8 = null;
        this.ls = null;
        this.lu = null;
        this.lr = null;
        this.ov = null;
        this.l0 = null;
        this.typical = null;
        this.typicalBasedOn = null;
        this.ml = false;
        this.nb = null;
        this.m9 = null;
        this.na = null;
        this.m8 = null;
        this.nc = null;
        this.lt = null;
        this.lq = null;
        this.lv = 0;
        this.lx = new CategorySeriesRenderManager();
        this.mn = false;
        this.l0 = new CategoryTransitionSourceFramePreparer();
        this.lt = new CategoryFrame(3);
        this.ab = FinancialSeries.$;
        this.lw = 0;
    }
    ib(a) {
        super.ib(a);
        this.l5 = a;
    }
    get_cq() {
        return true;
    }
    get cq() {
        return this.get_cq();
    }
    ag() {
        return [this.lp, this.l9];
    }
    nm() {
        return 2;
    }
    ah(a) {
        let b = this.aj(this.lp, this.lr.f, this.nk(this.bi), this.nl(this.bi), this.k5(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        let g = this.nm();
        f[0] = { $type: Point_$type, x: c[0], y: c[g] };
        f[1] = { $type: Point_$type, x: d[0], y: d[g] };
        e[0] = f;
        return e;
    }
    ai(a) {
        let b = this.aj(this.lp, this.lr.f, this.nk(this.bi), this.nl(this.bi), this.k5(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    }
    kq() {
        return this.or;
    }
    hd() {
        super.hd();
        this.lp = null;
        this.l9 = null;
    }
    get mh() {
        return this.mg;
    }
    set mh(a) {
        if (this.mg != a) {
            let b = this.mg;
            this.mg = a;
            this.raisePropertyChanged("OpenColumn", b, this.mg);
        }
    }
    get md() {
        return this.mc;
    }
    set md(a) {
        if (this.mc != a) {
            let b = this.mc;
            this.mc = a;
            this.raisePropertyChanged("HighColumn", b, this.mc);
        }
    }
    get mf() {
        return this.me;
    }
    set mf(a) {
        if (this.me != a) {
            let b = this.me;
            this.me = a;
            this.raisePropertyChanged("LowColumn", b, this.me);
        }
    }
    get mb() {
        return this.ma;
    }
    set mb(a) {
        if (this.ma != a) {
            let b = this.ma;
            this.ma = a;
            this.raisePropertyChanged("CloseColumn", b, this.ma);
        }
    }
    get mk() {
        return this.mj;
    }
    set mk(a) {
        if (this.mj != a) {
            let b = this.mj;
            this.mj = a;
            this.raisePropertyChanged("VolumeColumn", b, this.mj);
        }
    }
    mv() {
        return (this.assigningCategoryStyle != null && this.mn) || this.ct;
    }
    oe(a) {
        if (this.assigningCategoryStyle != null && this.mn) {
            this.assigningCategoryStyle(this, a);
        }
    }
    oc(a, b, c, d, e, f) {
        let g = this.b9;
        this.lx.ac(a, b, c, d, e, f, g);
        let h = this.lx.c;
        let i = null;
        let j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.oe(h);
        this.lx.aa(i, f, g);
    }
    nd(a) {
        return this.d5(a, this.lp);
    }
    e4(a, b) {
        return this.e5(a, b, this.lp, runOn(this, this.nd), new FinancialValueList(this.mh, this.md, this.mf, this.mb, this.mk));
    }
    e2(a, b) {
        return this.e3(a, b, this.lp, runOn(this, this.nd), new FinancialValueList(this.mh, this.md, this.mf, this.mb, this.mk));
    }
    d1(a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        let f = this.lp.jq;
        return this.d2(a, b, this.lp, d, e, f, runOn(this, this.nd));
    }
    getOffsetValue() {
        return this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.lp.getCategorySize(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    }
    k2(a, b, c) {
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, null, null, null);
    }
    ee(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.ne(this.bi.bq, this.bi.bp, d);
        let f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(new FinancialValueList(this.mh, this.md, this.mf, this.mb, this.mk), a, this.lp, f, e, runOn(this, this.nd), b, c);
    }
    ea(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.ne(this.bi.bq, this.bi.bp, d);
        let f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.md, a, this.lp, f, e, runOn(this, this.nd), b, c);
    }
    ec(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.ne(this.bi.bq, this.bi.bp, d);
        let f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.mf, a, this.lp, f, e, runOn(this, this.nd), b, c);
    }
    nf(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.ne(this.bi.bq, this.bi.bp, d);
        let f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.mb, a, this.lp, f, e, runOn(this, this.nd), b, c);
    }
    ng(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.ne(this.bi.bq, this.bi.bp, d);
        let f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.mh, a, this.lp, f, e, runOn(this, this.nd), b, c);
    }
    nh(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.ne(this.bi.bq, this.bi.bp, d);
        let f = new ScalerParams(0, this.bi.bq, this.bi.bp, this.lp.b8, d);
        return this.eg(this.mk, a, this.lp, f, e, runOn(this, this.nd), b, c);
    }
    ky(a, b, c) {
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.ea), (d, e) => this.e5(d, e, this.lp, runOn(this, this.nd), this.md), (d, e) => this.e3(d, e, this.lp, runOn(this, this.nd), this.md));
    }
    k0(a, b, c) {
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.ec), (d, e) => this.e5(d, e, this.lp, runOn(this, this.nd), this.mf), (d, e) => this.e3(d, e, this.lp, runOn(this, this.nd), this.mf));
    }
    ot(a, b, c) {
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.ng), (d, e) => this.e5(d, e, this.lp, runOn(this, this.nd), this.mh), (d, e) => this.e3(d, e, this.lp, runOn(this, this.nd), this.mh));
    }
    os(a, b, c) {
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.nf), (d, e) => this.e5(d, e, this.lp, runOn(this, this.nd), this.mb), (d, e) => this.e3(d, e, this.lp, runOn(this, this.nd), this.mb));
    }
    ou(a, b, c) {
        return this.k4(a, b, c, this.ne(this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.l9, this.lp, runOn(this, this.nh), (d, e) => this.e5(d, e, this.lp, runOn(this, this.nd), this.mk), (d, e) => this.e3(d, e, this.lp, runOn(this, this.nd), this.mk));
    }
    hu() {
        super.hu();
        if (this.lp != null) {
            this.lp.gz(false);
        }
        if (this.l9 != null) {
            this.l9.gz(false);
        }
    }
    ja(a, b) {
        this.l5.bs.e(this.ek);
        this.iv(false);
    }
    i9(a, b) {
        if (this.dj && this.ep < 0.05) {
            this.dk = true;
        }
        this.l5.bs.e(this.ek);
        this.iv(false);
    }
    mi(a, b, c) {
        let d = this.bw(b);
        this.my.addItem(d, b);
        this.mz.addItem(b, c);
        return d;
    }
    ob(a, b) {
        if (b == null) {
            return;
        }
        a.deregisterColumn(b);
        let c = this.my.item(b);
        this.mz.removeItem(c);
        this.my.removeItem(b);
    }
    ih(a, b, c, d) {
        super.ih(a, b, c, d);
        switch (b) {
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.lp != null) {
                        this.lp.bv(this);
                    }
                    if (this.l9 != null) {
                        this.l9.bv(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.lp != null) {
                        this.lp.ch(this);
                    }
                    if (this.l9 != null) {
                        this.l9.ch(this);
                    }
                }
                this.l5.bs.e(this.ek);
                this.iv(false);
                break;
            case "FastItemsSource":
                this.mm = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    this.ob(typeCast(IFastItemsSource_$type, c), this.mh);
                    this.ob(typeCast(IFastItemsSource_$type, c), this.md);
                    this.ob(typeCast(IFastItemsSource_$type, c), this.mf);
                    this.ob(typeCast(IFastItemsSource_$type, c), this.mb);
                    this.ob(typeCast(IFastItemsSource_$type, c), this.mk);
                    this.mh = null;
                    this.md = null;
                    this.mf = null;
                    this.mb = null;
                    this.mk = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    if (this.n2 != null) {
                        this.mh = this.mi(typeCast(IFastItemsSource_$type, d), this.n2, "OpenColumn");
                    }
                    if (this.nt != null) {
                        this.md = this.mi(typeCast(IFastItemsSource_$type, d), this.nt, "HighColumn");
                    }
                    if (this.ny != null) {
                        this.mf = this.mi(typeCast(IFastItemsSource_$type, d), this.ny, "LowColumn");
                    }
                    if (this.nq != null) {
                        this.mb = this.mi(typeCast(IFastItemsSource_$type, d), this.nq, "CloseColumn");
                    }
                    if (this.n6 != null) {
                        this.mk = this.mi(typeCast(IFastItemsSource_$type, d), this.n6, "VolumeColumn");
                    }
                }
                this.mm = false;
                if (this.l9 != null && !this.l9.ck()) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[6]:
                if (this.bz != null) {
                    this.ob(this.bz, this.mh);
                    this.mh = this.mi(this.bz, this.n2, "OpenColumn");
                }
                break;
            case "OpenColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[1]:
                if (this.bz != null) {
                    this.ob(this.bz, this.md);
                    this.md = this.mi(this.bz, this.nt, "HighColumn");
                }
                break;
            case "HighColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[4]:
                if (this.bz != null) {
                    this.ob(this.bz, this.mf);
                    this.mf = this.mi(this.bz, this.ny, "LowColumn");
                }
                break;
            case "LowColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[0]:
                if (this.bz != null) {
                    this.ob(this.bz, this.mb);
                    this.mb = this.mi(this.bz, this.nq, "CloseColumn");
                }
                break;
            case "CloseColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[8]:
                if (this.bz != null) {
                    this.ob(this.bz, this.mk);
                    this.mk = this.mi(this.bz, this.n6, "VolumeColumn");
                }
                break;
            case "VolumeColumn":
                if (this.l9 != null && !this.l9.ck() && !this.mm) {
                    this.l5.bs.e(this.ek);
                    this.iv(false);
                }
                break;
            case FinancialSeries.$$p[9]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                this.l5.bs.e(this.ek);
                this.iv(false);
                this.h2();
                break;
            case FinancialSeries.$$p[10]:
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                this.l5.bs.e(this.ek);
                if (this.l9 != null) {
                    this.l9.ck();
                }
                {
                    this.iv(false);
                }
                this.h2();
                break;
            case "TransitionProgress":
                this.lu.c(this.ep, this.ls, this.lr);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ep == 1) {
                    this.lr.v();
                    this.of(this.lr, this.l5);
                    if (this.dj) {
                        this.dj = false;
                        this.hg();
                        this.bt.r = truncate(this.eh());
                        this.bt.b = this.bu;
                    }
                }
                else {
                    this.of(this.lu, this.l5);
                }
                break;
            case FinancialSeries.$$p[5]:
                this.iv(false);
                break;
            case "IsCustomCategoryStyleAllowed":
                this.mn = this.mq();
                this.iv(false);
                break;
            case "CategoryMode":
                if (this.lp != null) {
                    this.lp.kf(true);
                }
                break;
        }
    }
    mp(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    mo(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    }
    li(a, b, c) {
        if (b < a || a < 0 || a > this.bz.count || b < 0 || b > this.bz.count || c == null) {
            return null;
        }
        let d = new Array((b - a) + 1);
        let e = c.cc;
        let f = null;
        if (e) {
            f = c.i$b;
        }
        for (let g = a; g <= b; g++) {
            let h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.bz.item(g);
        }
        return d;
    }
    nk(a) {
        return a.bs.b;
    }
    nl(a) {
        return a.bs.c;
    }
    lh(a, b) {
        return this.li(a, b, this.l9);
    }
    get_mr() {
        return false;
    }
    get mr() {
        return this.get_mr();
    }
    get_cu() {
        return true;
    }
    get cu() {
        return this.get_cu();
    }
    at(a, b) {
        if (this.mr) {
            let c = this.l7(a, b, this.l8);
            this.l8 = c;
            return c;
        }
        else {
            let d = this.l6(a, b, this.l8);
            this.l8 = d;
            return d;
        }
    }
    nn(a) {
        let b = this.lr;
        if (this.ca()) {
            b = this.lu;
        }
        let c = this.bi.bp;
        let d = this.bi.bq;
        let e = this.lp;
        let f = 0;
        if (e.ce) {
            let g = (a.y - d.top) / d.height;
            f = g * c.height + c.top;
        }
        else {
            let h = (a.x - d.left) / d.width;
            f = h * c.width + c.left;
        }
        let i = b.f.count;
        let j = 0;
        for (j = 0; j < i; j++) {
            let k = b.f._inner[j];
            let l = null;
            if (j < i - 1) {
                l = b.f._inner[j + 1];
            }
            if (k[0] <= f && l == null || l[0] >= f) {
                if (l != null) {
                    if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                        return j;
                    }
                    else {
                        return j + 1;
                    }
                }
                else {
                    return j;
                }
            }
        }
        return j;
    }
    l7(a, b, c) {
        let d = this.bz.count;
        let e = this.l5.bs.c;
        let f = this.l5.bs.d;
        let g = this.l5.bs.b;
        let h = this.lp;
        let i = -1;
        let j = -1;
        if (h.cc) {
            let k = this.lr;
            if (this.ca()) {
                k = this.lu;
            }
            let l = this.nn(b);
            i = l;
            j = l;
        }
        else {
            let m = this.ey(b);
            i = truncate(Math.floor((intDivide(m, g)))) * g;
            j = i + (g - 1);
        }
        if (c != null && c.f == i && c.e == j) {
            return c;
        }
        let n = new HighlightingInfo();
        n.b = this;
        n.f = i;
        n.e = j;
        return n;
    }
    l6(a, b, c) {
        let d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.bz.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    }
    mq() {
        return this.mt;
    }
    d3(a) {
        let b = this.bi.bq;
        let c = this.bi.bp;
        let d = -1;
        if (!b.isEmpty && !c.isEmpty && this.lp != null) {
            let e = this.getEffectiveViewport1(this.bi);
            let f = new ScalerParams(0, b, c, this.lp.b8, e);
            let g = this.k7(this.bi);
            let h = this.lp.dw(g.left, f);
            let i = this.lp.dw(g.right, f);
            let j = (a.x - b.left) / b.width;
            let k = h + (j * (i - h));
            if (this.lp.categoryMode != 0) {
                k -= 0.5;
            }
            d = k;
        }
        return d;
    }
    ey(a) {
        return truncate(Math.round(this.d3(a)));
    }
    get_c0() {
        return typeCast(ISortingAxis_$type, this.lp) !== null;
    }
    get c0() {
        return this.get_c0();
    }
    ap() {
        return this.lp;
    }
    e0(a) {
        let b = this.bi.bq;
        let c = this.bi.bp;
        let d = this.getEffectiveViewport1(this.bi);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        let e = new Rect(0, 0, 0, 1, 1);
        let f = new ScalerParams(0, b, c, this.lp.b8, d);
        let g = typeCast(ISortingAxis_$type, this.lp);
        let h = this.k7(this.bi);
        let i = h.left;
        let j = h.right;
        let k = this.kx(a).x;
        let l = this.lp.dw(k, f);
        let m = this.lp.dw(i, f);
        let n = this.lp.dw(j, f);
        l = Math.max(m, Math.min(n, l));
        let o = g.i$f(l);
        return o;
    }
    ff(a) {
        let b = 0;
        if (typeCast(ISortingAxis_$type, this.lp) !== null) {
            b = this.e0(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.ey(a);
        }
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    }
    ne(a, b, c) {
        if (this.lp == null) {
            return 0;
        }
        return this.lp.getOffset(a, b, c, this.e7);
    }
    c9() {
        return this.mu;
    }
    ly() {
        return 11;
    }
    bo() {
        return 3;
    }
    of(a, b) {
        this.k6 = a.aa;
        b.ar();
    }
    get ow() {
        return this.ov;
    }
    od(a, b) {
        a.u();
    }
    dt(a, b, c) {
        let d = super.dt(a, b, c);
        let e = c;
        if (this.bz == null || this.bz.count == 0 || !c.l() || b.isEmpty || a.isEmpty || this.lp == null || this.l9 == null || e.bs.b < 1 || this.lp.bf == null || this.l9.bf == null || this.l9.jw == this.l9.jv || this.lp.itemsSource == null || this.lp.jq < 1) {
            e.bs.b = 0;
            d = false;
        }
        return d;
    }
    getViewInfo(a, b) {
        b = this.bi.bq;
        a = this.bi.bp;
        return {
            p0: a,
            p1: b
        };
    }
    ni(a) {
        let b = 0;
        let c = a.bq;
        let d = a.bp;
        let e = this.getEffectiveViewport1(this.bi);
        if (!c.isEmpty && !d.isEmpty && this.l9 != null) {
            let f = new ScalerParams(0, c, d, this.l9.b8, e);
            b = this.l9.dt(this.l9.j6, f);
        }
        return b;
    }
    hg() {
        super.hg();
        this.ls.v();
        this.lr.v();
        this.lu.v();
    }
    iw(a) {
        super.iw(a);
        this.l5.bs.e(this.ek);
        if (this.cc(this.bi)) {
            return;
        }
        if (this.db) {
            if (this.ca()) {
                this.of(this.lu, this.l5);
            }
            else {
                this.of(this.lr, this.l5);
            }
            return;
        }
        if (this.c7(a)) {
            let b = this.ls;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.ls = this.lu;
                this.lu = b;
            }
            else {
                this.ls = this.lr;
                this.lr = b;
            }
            this.od(this.lr, this.l5);
            if (this.dl) {
                this.bt.w();
                this.bt.r = truncate(this.ei());
                this.bt.b = this.bv != null ? this.bv : this.bu;
                this.l0.p(this.ls, this.lr, this.isVertical, this.lp, this.l9, this.lz, this.ly(), this.bp, this.bo(), () => this.ni(this.l5), this.l5.bp);
            }
            this.hc();
            this.i3();
            if (this.dl) {
                this.dk = false;
                this.dj = true;
            }
        }
        else {
            this.od(this.lr, this.l5);
            this.of(this.lr, this.l5);
        }
    }
    mw(a) {
        for (let b of fromEnum(a)) {
            switch (b) {
                case "HighColumn":
                    if (this.md == null) {
                        return false;
                    }
                    break;
                case "LowColumn":
                    if (this.mf == null) {
                        return false;
                    }
                    break;
                case "OpenColumn":
                    if (this.mh == null) {
                        return false;
                    }
                    break;
                case "CloseColumn":
                    if (this.mb == null) {
                        return false;
                    }
                    break;
                case "VolumeColumn":
                    if (this.mk == null) {
                        return false;
                    }
                    break;
            }
        }
        return true;
    }
    get mx() {
        return this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null;
    }
    ms() {
        return this.typical != null;
    }
    oa(a) {
        this.typical(this, a);
    }
    get m5() {
        return this.m2();
    }
    *_m2() {
        let a = false;
        if (this.ms()) {
            let b = this.l1(0, this.bz.count);
            this.oa(new FinancialEventArgs(0, this.bz.count, b, this.l2(b), this));
            if (b.typicalColumn != null) {
                a = true;
                for (let c of fromEnum(b.typicalColumn)) {
                    yield c;
                }
            }
        }
        if (!a) {
            if (this.mx && this.lp.i$b != null) {
                let d = this.bz.count;
                let e = this.lp.i$b;
                for (let f = 0; f < d; ++f) {
                    yield (this.md.item(e.item(f)) + this.mf.item(e.item(f)) + this.mb.item(e.item(f))) / 3;
                }
            }
            else {
                let g = this.bz.count;
                for (let h = 0; h < g; ++h) {
                    yield (this.md.item(h) + this.mf.item(h) + this.mb.item(h)) / 3;
                }
            }
        }
    }
    m2() {
        return toEnum(() => this._m2());
    }
    get m4() {
        return this.m1();
    }
    *_m1() {
        if (this.mx && this.lp.i$b != null) {
            let a = this.md.count;
            let b = this.lp.i$b;
            if (a > 0) {
                yield this.nj(this.md.item(b.item(0)) - this.mf.item(b.item(0)));
            }
            for (let c = 1; c < a; ++c) {
                yield Math.max(this.nj(this.md.item(b.item(c)) - this.mf.item(b.item(c))), Math.max(this.nj(Math.abs(this.md.item(b.item(c)) - this.mb.item(b.item(c - 1)))), this.nj(Math.abs(this.mf.item(b.item(c)) - this.mb.item(b.item(c - 1))))));
            }
        }
        else {
            let d = this.md.count;
            if (d > 0) {
                yield this.nj(this.md.item(0) - this.mf.item(0));
            }
            for (let e = 1; e < d; ++e) {
                yield Math.max(this.nj(this.md.item(e) - this.mf.item(e)), Math.max(this.nj(Math.abs(this.md.item(e) - this.mb.item(e - 1))), this.nj(Math.abs(this.mf.item(e) - this.mb.item(e - 1)))));
            }
        }
    }
    m1() {
        return toEnum(() => this._m1());
    }
    get m3() {
        return this.m0();
    }
    *_m0() {
        if (this.mx && this.lp.i$b != null) {
            let a = this.mf.count;
            let b = this.lp.i$b;
            if (a > 0) {
                yield this.nj(this.mf.item(b.item(0)));
            }
            for (let c = 1; c < a; c++) {
                yield Math.min(this.nj(this.mf.item(b.item(c))), this.nj(this.mb.item(b.item(c - 1))));
            }
        }
        else {
            let d = this.mf.count;
            if (d > 0) {
                yield this.nj(this.mf.item(0));
            }
            for (let e = 1; e < d; e++) {
                yield Math.min(this.nj(this.mf.item(e)), this.nj(this.mb.item(e - 1)));
            }
        }
    }
    m0() {
        return toEnum(() => this._m0());
    }
    m7(a) {
        if (a == null) {
            return null;
        }
        if (this.mx && this.lp.i$b != null) {
            return new SafeSortedReadOnlyDoubleCollection(0, a, this.lp.i$b);
        }
        return new SafeReadOnlyDoubleCollection(0, a);
    }
    m6() {
        let a = new List$1(String_$type, 0);
        a.add("HighColumn");
        a.add("LowColumn");
        a.add("CloseColumn");
        if (this.typicalBasedOn != null && this.bz != null && !this.ml) {
            this.ml = true;
            let b = this.l1(0, this.bz.count);
            this.ml = false;
            let c = new FinancialEventArgs(0, this.bz.count, b, this.l2(b), this);
            this.typicalBasedOn(this, c);
            if (c.basedOn != null && c.basedOn.count > 0) {
                return c.basedOn;
            }
        }
        return a;
    }
    getOpenColumnAsArray() {
        if (this.mh == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.nb != null) {
                return this.nb.asArray();
            }
            let a = new List$1(Number_$type, 2, this.mh.count);
            let b = this.lp.i$b;
            let c = this.mh.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.nb = a;
            return this.nb.asArray();
        }
        else {
            return this.mh.asArray();
        }
    }
    getHighColumnAsArray() {
        if (this.md == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.m9 != null) {
                return this.m9.asArray();
            }
            let a = new List$1(Number_$type, 2, this.md.count);
            let b = this.lp.i$b;
            let c = this.md.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m9 = a;
            return this.m9.asArray();
        }
        else {
            return this.md.asArray();
        }
    }
    getLowColumnAsArray() {
        if (this.mf == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.na != null) {
                return this.na.asArray();
            }
            let a = new List$1(Number_$type, 2, this.mf.count);
            let b = this.lp.i$b;
            let c = this.mf.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.na = a;
            return this.na.asArray();
        }
        else {
            return this.mf.asArray();
        }
    }
    getCloseColumnAsArray() {
        if (this.mb == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.m8 != null) {
                return this.m8.asArray();
            }
            let a = new List$1(Number_$type, 2, this.mb.count);
            let b = this.lp.i$b;
            let c = this.mb.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m8 = a;
            return this.m8.asArray();
        }
        else {
            return this.mb.asArray();
        }
    }
    getVolumeColumnAsArray() {
        if (this.mk == null) {
            return null;
        }
        if (this.lp != null && typeCast(ISortingAxis_$type, this.lp) !== null) {
            if (this.nc != null) {
                return this.nc.asArray();
            }
            let a = new List$1(Number_$type, 2, this.mk.count);
            let b = this.lp.i$b;
            let c = this.mk.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.nc = a;
            return this.nc.asArray();
        }
        else {
            return this.mk.asArray();
        }
    }
    hi(a, b, c, d) {
        super.hi(a, b, c, d);
        if (this.lp == null || !(typeCast(ISortingAxis_$type, this.lp) !== null)) {
            return;
        }
        let e = this.lp.i$b;
        switch (a) {
            case 1:
                for (let f = b; f < c; f++) {
                    let g = e._inner[f];
                    if (this.nb != null) {
                        this.nb.insert(f, this.mh.item(g));
                    }
                    if (this.m9 != null) {
                        this.m9.insert(f, this.md.item(g));
                    }
                    if (this.na != null) {
                        this.na.insert(f, this.mf.item(g));
                    }
                    if (this.m8 != null) {
                        this.m8.insert(f, this.mb.item(g));
                    }
                    if (this.nc != null) {
                        this.nc.insert(f, this.mk.item(g));
                    }
                }
                break;
            case 0:
                if (this.nb != null) {
                    this.nb.v(b, c);
                }
                if (this.m9 != null) {
                    this.m9.v(b, c);
                }
                if (this.na != null) {
                    this.na.v(b, c);
                }
                if (this.m8 != null) {
                    this.m8.v(b, c);
                }
                if (this.nc != null) {
                    this.nc.v(b, c);
                }
                break;
            case 4:
                if (this.nb != null) {
                    this.nb = new List$1(Number_$type, 0);
                }
                if (this.m9 != null) {
                    this.m9 = new List$1(Number_$type, 0);
                }
                if (this.na != null) {
                    this.na = new List$1(Number_$type, 0);
                }
                if (this.m8 != null) {
                    this.m8 = new List$1(Number_$type, 0);
                }
                if (this.nc != null) {
                    this.nc = new List$1(Number_$type, 0);
                }
                break;
            case 3:
            case 2:
                for (let h = b; h < c; h++) {
                    let i = e._inner[h];
                    if (this.nb != null) {
                        this.nb._inner[h] = this.mh.item(i);
                    }
                    if (this.m9 != null) {
                        this.m9._inner[h] = this.md.item(i);
                    }
                    if (this.na != null) {
                        this.na._inner[h] = this.mf.item(i);
                    }
                    if (this.m8 != null) {
                        this.m8._inner[h] = this.mb.item(i);
                    }
                    if (this.nc != null) {
                        this.nc._inner[h] = this.mk.item(i);
                    }
                }
                break;
        }
    }
    l1(a, b) {
        let c = this.m7(this.mh);
        let d = this.m7(this.mb);
        let e = this.m7(this.md);
        let f = this.m7(this.mf);
        let g = this.m7(this.mk);
        let h = ((() => {
            let $ret = new FinancialCalculationDataSource();
            $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(this.m5), this.m6());
            $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(this.m4), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("HighColumn");
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(this.m3), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.openColumn = c;
            $ret.closeColumn = d;
            $ret.highColumn = e;
            $ret.lowColumn = f;
            $ret.volumeColumn = g;
            $ret.calculateFrom = a;
            $ret.calculateCount = b;
            $ret.minimumValue = NaN;
            $ret.maximumValue = NaN;
            $ret.count = this.bz != null ? this.bz.count : 0;
            return $ret;
        })());
        return h;
    }
    nj(a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    }
    l2(a) {
        return ((() => {
            let $ret = new FinancialCalculationSupportingCalculations();
            $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
            $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
            $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
            $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
            $ret.h = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.shortPeriod), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.f = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.longPeriod), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.g = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.shortPeriod), a.typicalColumn.basedOn);
            $ret.e = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.longPeriod), a.typicalColumn.basedOn);
            $ret.k = Series.dw;
            $ret.j = Series.dv;
            $ret.i = runOn(this, this.nj);
            return $ret;
        })());
    }
    get categoryAxis() {
        return this.lp;
    }
    ix(a, b) {
        super.ix(a, b);
        if (!this.di) {
            this.bi.az(b);
            return;
        }
        let c = typeCast(FinancialSeriesView.$, this.bh);
        this.bi.az(b);
        c.bs.e(this.ek);
        if (this.cc(this.bh)) {
            return;
        }
        if (!this.dc) {
            this.od(this.lt, c);
        }
        this.dc = false;
        this.of(this.lt, c);
        this.di = false;
    }
    iu(a, b, c, d, e) {
        super.iu(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        g.bs.e(this.ek);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.lq == null) {
            this.lq = new CategoryFrame(3);
        }
        this.lq.u();
        this.od(this.lq, g);
        this.of(this.lq, g);
    }
    am(a) {
        if (this.lp == a) {
            return this.l9;
        }
        if (this.l9 == a) {
            return this.lp;
        }
        return null;
    }
    preferredCategoryMode(a) {
        let b = typeCast(IDateTimeAxis_$type, this.lp);
        return b != null ? b.preferredCategoryMode(this) : this.lw;
    }
    get lw() {
        return this.lv;
    }
    set lw(a) {
        let b = this.lw;
        if (a != b) {
            this.lv = a;
            this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.lw));
        }
    }
    get_cy() {
        return true;
    }
    get cy() {
        return this.get_cy();
    }
    i0(a, b) {
        super.i0(a, b);
        this.or = a;
    }
}
FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
Type.dep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:nq:og', [2, null], 'HighMemberPath:nt:oh', [2, null], 'IsCustomCategoryStyleAllowed:mt:oi', [0, false], 'IsTransitionInEnabled:mu:oj', [0, false], 'LowMemberPath:ny:ok', [2, null], 'NegativeBrush:or:ol', [Brush.$, null], 'OpenMemberPath:n2:om', [2, null], 'TransitionInMode:lz:on', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:n6:oo', [2, null], 'XAxis:lp:op', [CategoryAxisBase.$, null], 'YAxis:l9:oq', [NumericYAxis.$, null]]);
export class FinancialCalculationSupportingCalculations extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.c = null;
        this.d = null;
        this.b = null;
        this.h = null;
        this.f = null;
        this.g = null;
        this.e = null;
        this.k = null;
        this.j = null;
        this.i = null;
    }
}
FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
export class DataSourceSupportingCalculation extends SupportingCalculation$1 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    super(Delegate_$type, 0, c);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    super(Delegate_$type, 1, c, d);
                }
                break;
        }
    }
}
DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
export class FinancialCalculationDataSource extends Base {
    constructor() {
        super(...arguments);
        this._openColumn = null;
        this._closeColumn = null;
        this._highColumn = null;
        this._lowColumn = null;
        this._volumeColumn = null;
        this._indicatorColumn = null;
        this._typicalColumn = null;
        this._trueRange = null;
        this._trueLow = null;
        this._period = 0;
        this._shortPeriod = 0;
        this._longPeriod = 0;
        this._count = 0;
        this._calculateFrom = 0;
        this._calculateCount = 0;
        this._multiplier = 0;
        this._minimumValue = 0;
        this._maximumValue = 0;
        this._specifiesRange = false;
        this._series = null;
    }
    get openColumn() {
        return this._openColumn;
    }
    set openColumn(a) {
        this._openColumn = a;
    }
    get closeColumn() {
        return this._closeColumn;
    }
    set closeColumn(a) {
        this._closeColumn = a;
    }
    get highColumn() {
        return this._highColumn;
    }
    set highColumn(a) {
        this._highColumn = a;
    }
    get lowColumn() {
        return this._lowColumn;
    }
    set lowColumn(a) {
        this._lowColumn = a;
    }
    get volumeColumn() {
        return this._volumeColumn;
    }
    set volumeColumn(a) {
        this._volumeColumn = a;
    }
    get indicatorColumn() {
        return this._indicatorColumn;
    }
    set indicatorColumn(a) {
        this._indicatorColumn = a;
    }
    get typicalColumn() {
        return this._typicalColumn;
    }
    set typicalColumn(a) {
        this._typicalColumn = a;
    }
    get trueRange() {
        return this._trueRange;
    }
    set trueRange(a) {
        this._trueRange = a;
    }
    get trueLow() {
        return this._trueLow;
    }
    set trueLow(a) {
        this._trueLow = a;
    }
    get period() {
        return this._period;
    }
    set period(a) {
        this._period = a;
    }
    get shortPeriod() {
        return this._shortPeriod;
    }
    set shortPeriod(a) {
        this._shortPeriod = a;
    }
    get longPeriod() {
        return this._longPeriod;
    }
    set longPeriod(a) {
        this._longPeriod = a;
    }
    get count() {
        return this._count;
    }
    set count(a) {
        this._count = a;
    }
    get calculateFrom() {
        return this._calculateFrom;
    }
    set calculateFrom(a) {
        this._calculateFrom = a;
    }
    get calculateCount() {
        return this._calculateCount;
    }
    set calculateCount(a) {
        this._calculateCount = a;
    }
    get multiplier() {
        return this._multiplier;
    }
    set multiplier(a) {
        this._multiplier = a;
    }
    get minimumValue() {
        return this._minimumValue;
    }
    set minimumValue(a) {
        this._minimumValue = a;
    }
    get maximumValue() {
        return this._maximumValue;
    }
    set maximumValue(a) {
        this._maximumValue = a;
    }
    get specifiesRange() {
        return this._specifiesRange;
    }
    set specifiesRange(a) {
        this._specifiesRange = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
}
FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
export class FinancialSeriesView extends SeriesView {
    constructor(a) {
        super(a);
        this.bu = null;
        this.bs = null;
        this.bw = 0;
        this.bw = -1;
        this.bu = a;
        this.bs = this.bt();
    }
    bv(a) {
        if (this.bw != a.t) {
            return true;
        }
        return false;
    }
    bx(a) {
        this.bw = a.t;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 6;
        }
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.bu.lp.b5) {
            let b = this.bu.lp;
            a += "<span>${item." + b.dateTimeMemberPath + "}</span><br/>";
        }
        else if (this.bu.lp.e1 != null) {
            a += "<span>${item." + this.bu.lp.e1 + "}</span><br/>";
        }
        a += "<span class='ui-priority-primary'";
        let c = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(c)) {
            a += " style='color:" + c + "'";
        }
        a += ">" + this.bu.fk + "</span><table><tr><td>" + "Open:</td><td>" + "${item." + this.bu.n2 + "}</td></tr><tr><td>" + "High:</td><td>" + "${item." + this.bu.nt + "}</td></tr><tr><td>" + "Low:</td><td>" + "${item." + this.bu.ny + "}</td></tr><tr><td>" + "Close:</td><td>" + "${item." + this.bu.nq + "}</td></tr>";
        if (!stringIsNullOrEmpty(this.bu.n6)) {
            a += "<tr><td>" + "Volume:</td><td>" + "${item." + this.bu.n6 + "}</td></tr>";
        }
        a += "</table></div>";
        return a;
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kr = a;
        this.e.el = 5;
        this.e.em = 2;
        this.e.en = 2;
    }
}
FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.FinancialSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FinancialSeries" />*/
//# sourceMappingURL=FinancialEventArgs_combined.js.map