/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager_$type } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core/ES2015/DVContainer";
import { Type, runOn, Point_$type, typeCast, EnumUtil, enumGetBox, markType } from "igniteui-angular-core/ES2015/type";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core/ES2015/DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryMode_$type } from "./CategoryMode";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { ScalerParams } from "./ScalerParams";
import { Axis } from "./Axis";
import { TrendLineType_$type } from "igniteui-angular-core/ES2015/TrendLineType";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-angular-core/ES2015/PropertyMetadata";
export class HorizontalAnchoredCategorySeries extends AnchoredCategorySeries {
    constructor() {
        super(...arguments);
        this.pj = null;
        this.pf = null;
        this.pl = null;
        this.ph = 0;
    }
    get pk() {
        if (this.pj == null) {
            this.pj = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, () => this.b2.n);
        }
        return this.pj;
    }
    hd() {
        super.hd();
        this.xAxis = null;
        this.yAxis = null;
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    mn() {
        return this.pf;
    }
    m7() {
        return this.pl;
    }
    ld(a) {
        if (this.mo == null || this.mo.m.count == 0 || !this.hasMarkers || !this.lk()) {
            return Rect.empty;
        }
        return this.pk.d$d(this, this.mo.m, a, runOn(this, this.px));
    }
    px(a) {
        return this.og.c3(a);
    }
    pp(a, b, c) {
        return this.pk.d$c(this, this.m7(), a, b, c);
    }
    ah(a) {
        return this.pk.d$a(this, this.mo.f, this.no(this.bi), this.np(this.bi), a);
    }
    ai(a) {
        return this.pk.d$b(this, this.mo.f, this.no(this.bi), this.np(this.bi), a);
    }
    de(a, b) {
        if (this.dd(a, b)) {
            return true;
        }
        if (this.ll(a, b)) {
            return true;
        }
        return false;
    }
    getOffsetValue() {
        return this.ms.r(this.mn(), this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        let a = this.getEffectiveViewport1(this.bi);
        return this.mn().getCategorySize(this.bi.bq, this.bi.bp, a);
    }
    ee(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.mn();
        let f = new ScalerParams(0, this.bs.mk, this.bi.bp, e.b8, d);
        let g = this.ms.r(e, this.bs.mk, this.bi.bp, d);
        return this.eg(this.valueColumn, a, e, f, g, runOn(this, this.nm), b, c);
    }
    e4(a, b) {
        return this.e5(a, b, this.mn(), runOn(this, this.nm), this.valueColumn);
    }
    e2(a, b) {
        return this.e3(a, b, this.mn(), runOn(this, this.nm), this.valueColumn);
    }
    d1(a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.d2(a, b, this.mn(), d, e, this.valueColumn.count, runOn(this, this.nm));
    }
    k2(a, b, c) {
        if (this.mn() == null || this.m7() == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        return this.k4(a, b, c, this.ms.r(this.mn(), this.bi.bq, this.bi.bp, this.getEffectiveViewport1(this.bi)), this.m7(), this.mn(), null, null, null);
    }
    fetchXAxis() {
        return this.pf;
    }
    fetchYAxis() {
        return this.pl;
    }
    oy(a) {
        this.xAxis = typeCast(CategoryAxisBase.$, a);
    }
    oz(a) {
        this.yAxis = typeCast(NumericYAxis.$, a);
    }
    ni() {
        return this.pl != null && this.pl.ck();
    }
    pt(a) {
        this.pf = a;
    }
    pu(a) {
        this.pl = a;
    }
    mh(a, b) {
        return this.od(a, b, this.pf);
    }
    ih(a, b, c, d) {
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                this.pt(this.xAxis);
                if (this.og.cx) {
                    this.og.cw = CategoryTrendLineManagerFactory.a(this.og.cw, this.pf, this.je, this, this.b2);
                }
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.og.cw = CategoryTrendLineManagerFactory.a(this.og.cw, this.pf, this.je, this, this.b2);
                }
                break;
        }
        super.ih(a, b, c, d);
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.hj(typeCast(Axis.$, c));
                    this.im(typeCast(Axis.$, d));
                    this.pt(this.xAxis);
                    this.mw.cl.g(this.ek);
                    this.iv(false);
                    this.h2();
                }
                break;
            case HorizontalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.hj(typeCast(Axis.$, c));
                    this.im(typeCast(Axis.$, d));
                    this.pu(this.yAxis);
                    this.mw.cl.g(this.ek);
                    this.ni();
                    this.iv(false);
                    this.h2();
                }
                break;
            case "CategoryMode":
                if (this.xAxis != null) {
                    this.xAxis.kf(true);
                }
                break;
        }
    }
    hi(a, b, c, d) {
        super.hi(a, b, c, d);
        if (this.pf != null && typeCast(ISortingAxis_$type, this.pf) !== null) {
            this.pf.i$i();
        }
        switch (a) {
            case 4:
                if (this.pf != null) {
                    this.pf.ck();
                }
                if (this.pl != null && !this.pl.ck()) {
                    this.iv(true);
                }
                break;
            case 1:
                if (this.pf != null) {
                    this.pf.ck();
                }
                if (this.pl != null && !this.pl.ck()) {
                    this.iv(true);
                }
                break;
            case 0:
                if (this.pf != null) {
                    this.pf.ck();
                }
                if (this.pl != null && !this.pl.ck()) {
                    this.iv(true);
                }
                break;
            case 2:
                if (this.or != null && this.og.cl.d > 0 && this.pl != null && !this.pl.ck()) {
                    this.iv(true);
                }
                break;
            case 3:
                if (d == this.or) {
                    if (this.pf != null) {
                        this.pf.ck();
                    }
                    if (this.pl != null && !this.pl.ck()) {
                        this.iv(true);
                    }
                }
                break;
        }
    }
    pn(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b5) {
            return true;
        }
        return false;
    }
    po(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    get pi() {
        return this.ph;
    }
    set pi(a) {
        let b = this.pi;
        if (a != b) {
            this.ph = a;
            this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.pi));
        }
    }
    get useHighMarkerFidelity() {
        return this.nj;
    }
}
HorizontalAnchoredCategorySeries.$t = markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
Type.dep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::pv', [CategoryAxisBase.$, null], 'YAxis::pw', [NumericYAxis.$, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.HorizontalAnchoredCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.HorizontalAnchoredCategorySeries" />*/
//# sourceMappingURL=HorizontalAnchoredCategorySeries.js.map