import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { AccumulationDistributionIndicator } from "./AccumulationDistributionIndicator";
/**
 * Represents a IgxDataChartComponent Accumulation/Distribution indicator series.
 * Default required members: Close, Low, High, Volume
*/
export const IgxAccumulationDistributionIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }];
export class IgxAccumulationDistributionIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new AccumulationDistributionIndicator();
    }
    get i() {
        return this._implementation;
    }
}
IgxAccumulationDistributionIndicatorComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-accumulation-distribution-indicator',
                template: ``,
                providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxAccumulationDistributionIndicatorComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-accumulation-distribution-indicator-component.js.map