import { IgCollection } from "igniteui-angular-core/ES2015/IgCollection";
import { markType } from "igniteui-angular-core/ES2015/type";
import { SyncableObservableCollection$2 } from "igniteui-angular-core/ES2015/SyncableObservableCollection$2";
import { IAxisAnnotation_$type } from './IAxisAnnotation';
import { AxisAnnotation } from './igx-axis-annotation';
export class AxisAnnotationCollection extends IgCollection {
    constructor(list) {
        super();
        if (!AxisAnnotation.$type) {
            AxisAnnotation.$type = markType(AxisAnnotation, "AxisAnnotation");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!AxisAnnotation.$type) {
            AxisAnnotation.$type = markType(AxisAnnotation, "AxisAnnotation");
        }
        let coll = new SyncableObservableCollection$2(AxisAnnotation.$type, IAxisAnnotation_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new AxisAnnotation();
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-axis-annotation-collection.js.map