import { AxisRangeChangedEventArgs as AxisRangeChangedEventArgs_internal } from "./AxisRangeChangedEventArgs";
/**
 * Provides data for Axis RangeChanged events.
*/
export declare class AxisRangeChangedEventArgs {
    protected createImplementation(): AxisRangeChangedEventArgs_internal;
    protected _implementation: any;
    readonly i: AxisRangeChangedEventArgs_internal;
    private onImplementationCreated();
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the minimum value before the range changed. The reported minimum is the effective,
     * not the set value.
    */
    readonly oldMinimumValue: number;
    /**
     * Gets the minimum value after the range changed. The reported minimum is the effective,
     * not the set value.
    */
    readonly minimumValue: number;
    /**
     * Gets the maximum value before the range changed. The reported maximum is the effective,
     * not the set value.
    */
    readonly oldMaximumValue: number;
    /**
     * Gets the maximum value after the range changed. The reported maximum is the effective,
     * not the set value.
    */
    readonly maximumValue: number;
}
