import { Type } from '@angular/core';
import { IgxAnnotationLayerComponent } from "./igx-annotation-layer-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { CategoryToolTipLayer } from "./CategoryToolTipLayer";
/**
 * Represents an annotation layer that displays grouped tooltips for series that use a category axis.
*/
export declare const IgxCategoryToolTipLayerComponent_PROVIDERS: ({
    provide: typeof IgxAnnotationLayerComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxCategoryToolTipLayerComponent extends IgxAnnotationLayerComponent {
    protected createImplementation(): CategoryToolTipLayer;
    readonly i: CategoryToolTipLayer;
    constructor();
    /**
     * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
    */
    readonly isDefaultTooltipBehaviorDisabled: boolean;
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    useInterpolation: boolean;
}
