import { Type, EventEmitter } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from './igx-strategy-based-indicator-component';
import { IgxFinancialSeriesComponent } from './igx-financial-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { CustomIndicator } from "./CustomIndicator";
import { FinancialEventArgs } from "./igx-financial-event-args";
export declare const IgxCustomIndicatorComponent_PROVIDERS: ({
    provide: typeof IgxFinancialSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
/**
 * Represents a IgxDataChartComponent Custom Indicator series.
 * The indicator value is calculated in the user specified Indicator event handler.
*/
export declare class IgxCustomIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    protected createImplementation(): CustomIndicator;
    readonly i: CustomIndicator;
    constructor();
    private _indicator;
    /**
     * This event is raised when the indicator values need to be computed.
    */
    readonly indicator: EventEmitter<{
        sender: any;
        args: FinancialEventArgs;
    }>;
    private _basedOnColumns;
    /**
     * This event is raised when the based on columns to be specified.
    */
    readonly basedOnColumns: EventEmitter<{
        sender: any;
        args: FinancialEventArgs;
    }>;
}
