import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { EaseOfMovementIndicator } from "./EaseOfMovementIndicator";
/**
 * Represents a IgxDataChartComponent Ease of Movement indicator series.
 * The ease of movement indicator by Richard W. Arms, Jr relates the price change of an asset to
 * its volume. Normally smoothed with a moving average.
 * Default required members: Low, High, Volume
*/
export const IgxEaseOfMovementIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }];
export class IgxEaseOfMovementIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new EaseOfMovementIndicator();
    }
    get i() {
        return this._implementation;
    }
}
IgxEaseOfMovementIndicatorComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-ease-of-movement-indicator',
                template: ``,
                providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxEaseOfMovementIndicatorComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-ease-of-movement-indicator-component.js.map