/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Component, EventEmitter, Output, ViewChild, ChangeDetectionStrategy, TemplateRef, ChangeDetectorRef } from '@angular/core';
import { TypeRegistrar } from "igniteui-angular-core/ES2015/type";
export class IgxFinancialChartDefaultTemplatesComponent {
    constructor(_changeDetectorRef) {
        this._changeDetectorRef = _changeDetectorRef;
        this.onContentReady = new EventEmitter();
    }
    getSelection(ele) {
        let ret = [];
        for (let i = 0; i < ele.options.length; i++) {
            if (ele.options[i].selected) {
                ret.push(ele.options[i].value);
            }
        }
        return ret;
    }
    static register() {
        TypeRegistrar.registerCons("IgxFinancialChartDefaultTemplatesComponent", IgxFinancialChartDefaultTemplatesComponent);
    }
    ngAfterContentInit() {
        this.onContentReady.emit({});
    }
}
IgxFinancialChartDefaultTemplatesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-financial-chart-default-templates',
                changeDetection: ChangeDetectionStrategy.OnPush,
                template: `
    <ng-template #financialChartRangeSelectorTemplate let-vm="vm">
        <div class='financialChartRangeSelector'>
            <label class='rangeSelectorOneMonth'><input type='radio' value='1m' [checked]="vm.oneMonthChecked" (change)="vm.changeSelection($event.target.value)"><span>1m</span></label>
            <label class='rangeSelectorThreeMonths'><input type='radio' value='3m' [checked]="vm.threeMonthsChecked" (change)="vm.changeSelection($event.target.value)"/><span>3m</span></label>
            <label class='rangeSelectorSixMonths'><input type='radio' value='6m' [checked]="vm.sixMonthsChecked" (change)="vm.changeSelection($event.target.value)"/><span>6m</span></label>
            <label class='rangeSelectorYTD'><input type='radio' value='YTD' [checked]="vm.yearToDateChecked" (change)="vm.changeSelection($event.target.value)"/><span>YTD</span></label>
            <label class='rangeSelectorOneYear'><input type='radio' value='1y' [checked]="vm.oneYearChecked" (change)="vm.changeSelection($event.target.value)"/><span>1y</span></label>
            <label class='rangeSelectorAll'><input type='radio' value='all' [checked]="vm.allChecked" (change)="vm.changeSelection($event.target.value)"/><span>all</span></label>
        </div>
    </ng-template>
    <ng-template #financialChartTrendlinePickerTemplate let-vm="vm">
        <span   class='financialChartTrendLinePickerLabel'>Trendline</span>
        <select class='financialChartTrendLinePickerDropDownList'
        [value]="vm.selection"
        (change)="vm.selection = $event.target.value; vm.onSelectionChanged()">
            <option value='None'>None</option>
            <option value='LinearFit'>LinearFit</option>
            <option value='QuadraticFit'>QuadraticFit</option>
            <option value='CubicFit'>CubicFit</option>
            <option value='QuarticFit'>QuarticFit</option>
            <option value='QuinticFit'>QuinticFit</option>
            <option value='LogarithmicFit'>LogarithmicFit</option>
            <option value='ExponentialFit'>ExponentialFit</option>
            <option value='PowerLawFit'>PowerLawFit</option>
            <option value='SimpleAverage'>SimpleAverage</option>
            <option value='ExponentialAverage'>ExponentialAverage</option>
            <option value='ModifiedAverage'>ModifiedAverage</option>
            <option value='CumulativeAverage'>CumulativeAverage</option>
            <option value='WeightedAverage'>WeightedAverage</option>
        </select>
    </ng-template>
     <ng-template #financialChartOverlayPickerTemplate let-vm="vm">
        <!--<div class='financialChartOverlayPicker'>-->
            <button class='financialChartOverlayPickerDropDownButton' (click)="vm.onButtonPressed()">Overlay</button>
            <select class='financialChartOverlayPickerDropDownList' multiple='true'
                [style.display]="vm.isOpen ? 'block' : 'none'"
                (change)="vm.selection = getSelection($event.target); vm.onSelectionChanged()">
                <option value='BollingerBands' [selected]="vm.selection && vm.selection.indexOf('BollingerBands') >= 0">BollingerBands</option>
                <option value='PriceChannel' [selected]="vm.selection && vm.selection.indexOf('PriceChannel') >= 0">PriceChannel</option>
            </select>
        <!--</div>-->
    </ng-template>
    <ng-template #financialChartChartTypePickerTemplate let-vm="vm">
        <span   class="financialChartTypePickerLabel">Chart Type</span>
        <select class='financialChartTypePickerDropDownList' [value]="vm.selection" (change)="vm.selection = $event.target.value; vm.onSelectionChanged()">
            <option value='Auto'>Auto</option>
            <option value='Bar'>Bar</option>
            <option value='Line'>Line</option>
            <option value='Candle'>Candle</option>
            <option value='Column'>Column</option>
        </select>
    </ng-template>
    <ng-template #financialChartVolumeTypePickerTemplate let-vm="vm">
        <span   class="financialChartVolumeTypePickerLabel">Volume</span>
        <select class='financialChartVolumeTypePickerDropDownList' [value]="vm.selection" (change)="vm.selection = $event.target.value; vm.onSelectionChanged()">
            <option value='None'>None</option>
            <option value='Column'>Column</option>
            <option value='Line'>Line</option>
            <option value='Area'>Area</option>
        </select>
    </ng-template>
     <ng-template #financialChartIndicatorPickerTemplate let-vm="vm">
        <!--<div class='financialChartIndicatorPicker'>-->
            <button class='financialChartIndicatorPickerDropDownButton' (click)="vm.onButtonPressed()">Indicators</button>
            <select class='financialChartIndicatorPickerDropDownList'
                [style.display]="vm.isOpen ? 'block' : 'none'"
                multiple='true'
                (change)="vm.selection = getSelection($event.target); vm.onSelectionChanged()">
                <option value='AbsoluteVolumeOscillator' [selected]="vm.selection && vm.selection.indexOf('AbsoluteVolumeOscillator') >= 0">AbsoluteVolumeOscillator</option>
                <option value='AccumulationDistribution' [selected]="vm.selection && vm.selection.indexOf('AccumulationDistribution') >= 0">AccumulationDistribution</option>
                <option value='AverageDirectionalIndex' [selected]="vm.selection && vm.selection.indexOf('AverageDirectionalIndex') >= 0">AverageDirectionalIndex</option>
                <option value='AverageTrueRange' [selected]="vm.selection && vm.selection.indexOf('AverageTrueRange') >= 0">AverageTrueRange</option>
                <option value='BollingerBandWidth' [selected]="vm.selection && vm.selection.indexOf('BollingerBandWidth') >= 0">BollingerBandWidth</option>
                <option value='ChaikinOscillator' [selected]="vm.selection && vm.selection.indexOf('ChaikinOscillator') >= 0">ChaikinOscillator</option>
                <option value='ChaikinVolatility' [selected]="vm.selection && vm.selection.indexOf('ChaikinVolatility') >= 0">ChaikinVolatility</option>
                <option value='CommodityChannelIndex' [selected]="vm.selection && vm.selection.indexOf('CommodityChannelIndex') >= 0">CommodityChannelIndex</option>
                <option value='DetrendedPriceOscillator' [selected]="vm.selection && vm.selection.indexOf('DetrendedPriceOscillator') >= 0">DetrendedPriceOscillator</option>
                <option value='ForceIndex' [selected]="vm.selection && vm.selection.indexOf('ForceIndex') >= 0">ForceIndex</option>
                <option value='FullStochasticOscillator' [selected]="vm.selection && vm.selection.indexOf('FullStochasticOscillator') >= 0">FullStochasticOscillator</option>
                <option value='MarketFacilitationIndex' [selected]="vm.selection && vm.selection.indexOf('MarketFacilitationIndex') >= 0">MarketFacilitationIndex</option>
                <option value='MassIndex' [selected]="vm.selection && vm.selection.indexOf('MassIndex') >= 0">MassIndex</option>
                <option value='MedianPrice' [selected]="vm.selection && vm.selection.indexOf('MedianPrice') >= 0">MedianPrice</option>
                <option value='MoneyFlowIndex' [selected]="vm.selection && vm.selection.indexOf('MoneyFlowIndex') >= 0">MoneyFlowIndex</option>
                <option value='MovingAverageConvergenceDivergence' [selected]="vm.selection && vm.selection.indexOf('MovingAverageConvergenceDivergence') >= 0">MovingAverageConvergenceDivergence</option>
                <option value='NegativeVolumeIndex' [selected]="vm.selection && vm.selection.indexOf('NegativeVolumeIndex') >= 0">NegativeVolumeIndex</option>
                <option value='OnBalanceVolume' [selected]="vm.selection && vm.selection.indexOf('OnBalanceVolume') >= 0">OnBalanceVolume</option>
                <option value='PercentagePriceOscillator' [selected]="vm.selection && vm.selection.indexOf('PercentagePriceOscillator') >= 0">PercentagePriceOscillator</option>
                <option value='PercentageVolumeOscillator' [selected]="vm.selection && vm.selection.indexOf('PercentageVolumeOscillator') >= 0">PercentageVolumeOscillator</option>
                <option value='PositiveVolumeIndex' [selected]="vm.selection && vm.selection.indexOf('PositiveVolumeIndex') >= 0">PositiveVolumeIndex</option>
                <option value='PriceVolumeTrend' [selected]="vm.selection && vm.selection.indexOf('PriceVolumeTrend') >= 0">PriceVolumeTrend</option>
                <option value='RateOfChangeAndMomentum' [selected]="vm.selection && vm.selection.indexOf('RateOfChangeAndMomentum') >= 0">RateOfChangeAndMomentum</option>
                <option value='RelativeStrengthIndex' [selected]="vm.selection && vm.selection.indexOf('RelativeStrengthIndex') >= 0">RelativeStrengthIndex</option>
                <option value='SlowStochasticOscillator' [selected]="vm.selection && vm.selection.indexOf('SlowStochasticOscillator') >= 0">SlowStochasticOscillator</option>
                <option value='StandardDeviation' [selected]="vm.selection && vm.selection.indexOf('StandardDeviation') >= 0">StandardDeviation</option>
                <option value='StochRSI' [selected]="vm.selection && vm.selection.indexOf('StochRSI') >= 0">StochRSI</option>
                <option value='TRIX' [selected]="vm.selection && vm.selection.indexOf('TRIX') >= 0">TRIX</option>
                <option value='TypicalPrice' [selected]="vm.selection && vm.selection.indexOf('TypicalPrice') >= 0">TypicalPrice</option>
                <option value='UltimateOscillator' [selected]="vm.selection && vm.selection.indexOf('UltimateOscillator') >= 0">UltimateOscillator</option>
                <option value='WeightedClose' [selected]="vm.selection && vm.selection.indexOf('WeightedClose') >= 0">WeightedClose</option>
                <option value='WilliamsPercentR' [selected]="vm.selection && vm.selection.indexOf('WilliamsPercentR') >= 0">WilliamsPercentR</option>
            </select>
        <!--</div>-->
    </ng-template>

    <ng-template #financialChartToolbarTemplate let-vm="vm">
        <ng-template #defaultTemplate>
            <div></div>
        </ng-template>

        <div class='financialChartToolbar'>
            <div class='financialChartToolbar'>
                <div class='financialChartIndicatorPicker' *ngIf='vm.isIndicatorPickerVisible'>
                    <ng-container *ngTemplateOutlet="vm.financialChartIndicatorPicker.template ? vm.financialChartIndicatorPicker.template : defaultTemplate; context: vm.financialChartIndicatorPicker">
                    </ng-container>
                </div>
                <div class='financialChartOverlayPicker' *ngIf='vm.isOverlayPickerVisible'>
                    <ng-container *ngTemplateOutlet="vm.financialChartOverlayPicker.template ? vm.financialChartOverlayPicker.template : defaultTemplate; context: vm.financialChartOverlayPicker">
                    </ng-container>
                </div>
                <div class='financialChartTrendLineTypePicker'>
                    <ng-container *ngTemplateOutlet="vm.financialChartTrendLineTypePicker.template ? vm.financialChartTrendLineTypePicker.template : defaultTemplate; context: vm.financialChartTrendLineTypePicker">
                    </ng-container>
                </div>
                <div class='financialChartRangeSelector'>
                    <ng-container *ngTemplateOutlet="vm.financialChartRangeSelector.template ? vm.financialChartRangeSelector.template : defaultTemplate; context: vm.financialChartRangeSelector">
                    </ng-container>
                </div>
                <div class='financialChartChartTypePicker'>
                    <ng-container *ngTemplateOutlet="vm.financialChartChartTypePicker.template ? vm.financialChartChartTypePicker.template : defaultTemplate; context: vm.financialChartChartTypePicker">
                    </ng-container>
                </div>
                <div class='financialChartVolumeTypePicker'>
                    <ng-container *ngTemplateOutlet="vm.financialChartVolumeTypePicker.template ? vm.financialChartVolumeTypePicker.template : defaultTemplate; context: vm.financialChartVolumeTypePicker">
                    </ng-container>
                </div>
            </div>
        </div>
    </ng-template>
  `,
                styles: [`
.financialChartToolbar {
    font-family: "Verdana",Arial,sans-serif;
    font-family: var(--toolbar-font-family, "Verdana",Arial,sans-serif);
    font-size: 12px;
    font-size: var(--toolbar-font-size, 12px);
    border-width: 0px;
    width: 100%;
    height: 100%;
    -webkit-tap-highlight-color: rgba(0,0,0,0);
}
.financialChartToolbar {
	display: grid;
	display: -ms-grid;
	grid-row: 1;
	-ms-grid-rows: 100%;
	-ms-grid-row: 1;
	-ms-grid-columns: 100%;
}
/* scrollbar styles */
.financialChartToolbar select::-webkit-scrollbar
{
	width: 14px;
    width: var(--scrollbar-width, 14px);
	background-color: #eee;
    background-color: var(--scrollbar-background, #eee);
}
.financialChartToolbar select::-webkit-scrollbar-track
{
	border-radius: 1px;
    border-radius: var(--scrollbar-track-radius, 1px);
	background-color: #eee;
    background-color: var(--scrollbar-track-background, #eee);
	-webkit-box-shadow: inset 0 0 6px rgba(0,0,0,0.3);
}
.financialChartToolbar select::-webkit-scrollbar-thumb
{
	border-radius: 1px;
    border-radius: var(--scrollbar-thumb-radius, 1px);
	background-color: #838383;
    background-color: var(--scrollbar-thumb-background, #838383);
	-webkit-box-shadow: inset 0 0 6px rgba(0,0,0,.3);
}

.financialChartRangeSelector {
	flex: 1 0 auto;
    text-align: center;
	grid-column: 4;
	-ms-grid-column: 4;
}
.financialChartRangeSelector input {
	display: none;
}
.financialChartRangeSelector label {
	border-right: 1px solid #758696;
	padding: 0 10px;
}
.financialChartRangeSelectorLastOption {
	border: none !important;
	padding-right: 0;
}
.financialChartRangeSelector label:hover {
	color: #0090ff;
    color: var(--toolbar-checked-foreground, #0090ff);
	cursor: pointer;
}
.financialChartRangeSelector input:checked + span
{
	color: #0090ff;
    color: var(--toolbar-checked-foreground, #0090ff);
}

.financialChartTypePickerLabel,
.financialChartVolumeTypePickerLabel,
.financialChartTrendLinePickerLabel {
    font-family: "Verdana",Arial,sans-serif;
    font-family: var(--toolbar-font-family, "Verdana",Arial,sans-serif);
    font-size: 12px;
    font-size: var(--toolbar-font-size, 12px);
}

.financialChartChartTypePicker {
    flex: 1 0 auto;
	grid-column: 5;
    -ms-grid-column: 5;
    padding-left: 3px;
    padding-right: 3px;
}
.financialChartIndicatorPicker {
    flex: 1 0 auto;
	grid-column: 1;
	-ms-grid-column: 1;
}
.financialChartOverlayPicker {
    flex: 1 0 auto;
	grid-column: 2;
	-ms-grid-column: 2;
}
.financialChartTrendLineTypePicker {
    flex: 1 0 auto;
	grid-column: 3;
    -ms-grid-column: 3;
}
.financialChartVolumeTypePicker {
    flex: 1 0 auto;
	grid-column: 6;
    -ms-grid-column: 6;
    padding-left: 3px;
    padding-right: 3px;
}
.financialChartIndicatorPicker,
.financialChartOverlayPicker {
	position: relative;
	display: inline-block;
	margin-left: 5px;
}
.financialChartIndicatorPickerDropDownList,
.financialChartOverlayPickerDropDownList {
	position: relative;
	display: inline-block;
	z-index: 1;
}
.financialChartToolbar .financialChartToolbar {
    display: flex;
    display: -ms-flexbox;
	flex: 1 1 auto;
    align-items: center;
    justify-content: flex-start;
    flex-flow: row nowrap;
    -ms-flex-flow: row nowrap;
    background: #eee;
    background: var(--toolbar-background, #eee);
    border: 1px solid #ccc;
    border: var(--toolbar-border-thickness, 1px) solid var(--toolbar-border-color, #ccc);
    color: black;
    color: var(--toolbar-foreground, black);
}
.financialChartIndicatorPickerDropDownList,
.financialChartOverlayPickerDropDownList {
    position: absolute!important;
	top: 30px;
	left:0;
    -webkit-box-shadow: 0px 4px 10px 1px rgba(0,0,0,0.2);
	-webkit-box-shadow: var(--toolbar-dropdown-shadow, 0px 4px 10px 1px rgba(0,0,0,0.2));
	-moz-box-shadow: 0px 4px 10px 1px rgba(0,0,0,0.2);
	-moz-box-shadow: var(--toolbar-dropdown-shadow, 0px 4px 10px 1px rgba(0,0,0,0.2));
    box-shadow: 0px 4px 10px 1px rgba(0,0,0,0.2);
	box-shadow: var(--toolbar-dropdown-shadow, 0px 4px 10px 1px rgba(0,0,0,0.2));
    background: #eee;
    background: var(--toolbar-dropdown-background, #eee);
    color: black;
    color: var(--toolbar-dropdown-foreground, black);
    font-family: "Verdana",Arial,sans-serif;
    font-family: var(--toolbar-font-family, "Verdana",Arial,sans-serif);
    font-size: 12px;
    font-size: var(--toolbar-font-size, 12px);
}
.financialChartOverlayPickerDropDownList {
    height: 50px;
    overflow: hidden;
}
.financialChartIndicatorPickerDropDownList {
    height: 250px;
}

.financialChartOverlayPickerDropDownList option:checked {
    /* TODO figure out how to change background of checked option */
    /* background-color: red!important; */
    /* background-color: var(--toolbar-dropdown-checked, red); */
}

.financialChartTrendLinePickerDropDownList,
.financialChartTypePickerDropDownList,
.financialChartVolumeTypePickerDropDownList {
    color: black;
    color: var(--toolbar-dropdown-foreground, black);
    font-family: "Verdana",Arial,sans-serif;
    font-family: var(--toolbar-font-family, "Verdana",Arial,sans-serif);
    font-size: 12px;
    font-size: var(--toolbar-font-size, 12px);
}

.financialChartIndicatorPickerDropDownButton,
.financialChartOverlayPickerDropDownButton {
	background-color: transparent;
	background-color: var(--toolbar-background, transparent);
	border:none;
	outline:none;
	cursor:pointer;
    display: flex;
}

.financialChartIndicatorPickerDropDownButton:after,
.financialChartOverlayPickerDropDownButton:after {
	width: 0;
	height: 0;
	border-style: solid;
    border-width: 4px 4px 0 4px;
    border-color: #777 transparent transparent transparent;
	content:"";
	position:relative;
	top: calc(0.5em + 3px);
	margin-left: 5px;
}

.financialChartRangeSelector label {
	padding:0!important;
}

.financialChartRangeSelector label span {
	padding:2px 8px 4px;
}

.financialChartRangeSelector input:checked+span {
	color: #444!important;
    color: var(--toolbar-checked-foreground, #444)!important;
	background-color:#d5d5d5;
    background-color: var(--toolbar-checked-background, #d5d5d5);
}

.financialChartRangeSelector input:hover+span {
	color: #444!important;
    color: var(--toolbar-foreground, #444)!important;
	background-color: transparent;
    background-color: var(--toolbar-hover-background, transparent);
}

.financialChartRangeSelector label {
	border:none!important;
	background-color: #eee;
    background-color: var(--toolbar-background, #eee);
	color: black;
    color: var(--toolbar-foreground, black);
    font-family: "Verdana",Arial,sans-serif;
    font-family: var(--toolbar-font-family, "Verdana",Arial,sans-serif);
    font-size: 12px;
    font-size: var(--toolbar-font-size, 12px);
}

.financialChartPrice {
	margin-top:10px;
}

.financialChartRangeSelector {
	text-transform:uppercase;
}

.financialChartToolbar,.financialChartToolbar button {
	font: 400 13px "Verdana", Arial, sans-serif!important;
	font: 400 var(--toolbar-font-size, 13px) var(--toolbar-font-family, "Verdana",Arial,sans-serif)!important;
    color: black;
    color: var(--toolbar-foreground, black);
}

.financialChartIndicatorPicker {
	background: url("data:image/svg+xml,%3Csvg id='Layer_1' data-name='Layer 1' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 55 55'%3E%3Cdefs%3E%3Cstyle%3E.cls-1{fill:%23777;}%3C/style%3E%3C/defs%3E%3Ctitle%3EArtboard 2%3C/title%3E%3Crect class='cls-1' x='46.32' y='16.34' width='5.97' height='38.47'/%3E%3Cpolygon class='cls-1' points='36.73 54.8 42.7 54.8 42.7 20.71 40.34 20.71 36.73 23.92 36.73 54.8'/%3E%3Cpolygon class='cls-1' points='27.14 30.07 27.14 54.8 33.11 54.8 33.11 27.15 28.46 31.28 27.14 30.07'/%3E%3Cpolygon class='cls-1' points='30.74 20.71 29.62 20.71 30.12 21.22 30.74 20.71'/%3E%3Cpolygon class='cls-1' points='17.55 26.49 17.55 54.8 23.52 54.8 23.52 26.76 20.26 23.78 17.55 26.49'/%3E%3Cpolygon class='cls-1' points='7.96 24.97 7.96 26.49 9.48 24.97 7.96 24.97'/%3E%3Cpolygon class='cls-1' points='7.96 54.8 13.93 54.8 13.93 30.11 7.96 36.08 7.96 54.8'/%3E%3Cpolygon class='cls-1' points='37.29 0.2 43.23 6.14 30.12 16.96 21.68 8.51 2.5 27.69 7.29 32.48 20.26 19.52 28.46 27.02 47.33 10.23 52.5 15.4 52.5 14.57 52.5 0.2 37.29 0.2'/%3E%3C/svg%3E") no-repeat 0 0;
	padding-left:18px;
}

.financialChartIndicatorPicker:hover {
	background: url("data:image/svg+xml,%3Csvg id='Layer_1' data-name='Layer 1' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 55 55'%3E%3Cdefs%3E%3Cstyle%3E.cls-1{fill:%230090ff;}.cls-2{fill:%23777;}%3C/style%3E%3C/defs%3E%3Ctitle%3EArtboard 2%3C/title%3E%3Crect class='cls-1' x='46.32' y='16.34' width='5.97' height='38.47'/%3E%3Cpolygon class='cls-1' points='36.73 54.8 42.7 54.8 42.7 20.71 40.34 20.71 36.73 23.92 36.73 54.8'/%3E%3Cpolygon class='cls-1' points='27.14 30.07 27.14 54.8 33.11 54.8 33.11 27.15 28.46 31.28 27.14 30.07'/%3E%3Cpolygon class='cls-2' points='30.74 20.71 29.62 20.71 30.12 21.22 30.74 20.71'/%3E%3Cpolygon class='cls-1' points='17.55 26.49 17.55 54.8 23.52 54.8 23.52 26.76 20.26 23.78 17.55 26.49'/%3E%3Cpolygon class='cls-2' points='7.96 24.97 7.96 26.49 9.48 24.97 7.96 24.97'/%3E%3Cpolygon class='cls-1' points='7.96 54.8 13.93 54.8 13.93 30.11 7.96 36.08 7.96 54.8'/%3E%3Cpolygon class='cls-1' points='37.29 0.2 43.23 6.14 30.12 16.96 21.68 8.51 2.5 27.69 7.29 32.48 20.26 19.52 28.46 27.02 47.33 10.23 52.5 15.4 52.5 14.57 52.5 0.2 37.29 0.2'/%3E%3C/svg%3E") no-repeat 0 0;
}

.financialChartOverlayPicker {
	background: url("data:image/svg+xml,%3Csvg id='Layer_1' data-name='Layer 1' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 55 55'%3E%3Cdefs%3E%3Cstyle%3E.cls-1{fill:%23777;}%3C/style%3E%3C/defs%3E%3Ctitle%3EArtboard 2 copy%3C/title%3E%3Cpolygon class='cls-1' points='27.5 45.87 8.96 36.2 0.63 40.54 27.5 54.56 54.38 40.54 46.04 36.2 27.5 45.87'/%3E%3Cpolygon class='cls-1' points='27.5 32.83 8.96 23.15 0.63 27.5 27.5 41.52 54.38 27.5 46.04 23.15 27.5 32.83'/%3E%3Cpolygon class='cls-1' points='27.5 28.48 0.63 14.46 27.5 0.44 54.38 14.46 27.5 28.48'/%3E%3C/svg%3E") no-repeat 0 0;
	padding-left:18px;
}

.financialChartOverlayPicker:hover {
	background: url("data:image/svg+xml,%3Csvg id='Layer_1' data-name='Layer 1' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 55 55'%3E%3Cdefs%3E%3Cstyle%3E.cls-1{fill:%230090ff;}%3C/style%3E%3C/defs%3E%3Ctitle%3EArtboard 2 copy%3C/title%3E%3Cpolygon class='cls-1' points='27.5 45.87 8.96 36.2 0.63 40.54 27.5 54.56 54.38 40.54 46.04 36.2 27.5 45.87'/%3E%3Cpolygon class='cls-1' points='27.5 32.83 8.96 23.15 0.63 27.5 27.5 41.52 54.38 27.5 46.04 23.15 27.5 32.83'/%3E%3Cpolygon class='cls-1' points='27.5 28.48 0.63 14.46 27.5 0.44 54.38 14.46 27.5 28.48'/%3E%3C/svg%3E") no-repeat 0 0;
}

.financialChartIndicatorPicker:hover,
.financialChartOverlayPicker:hover {
    cursor:pointer;
    color: black;
    color: var(--toolbar-hover-foreground, black);
}
.financialChartIndicatorPicker:hover button,
.financialChartOverlayPicker:hover button {
	color: #0090ff;
    color: var(--toolbar-hover-foreground, #0090ff);
}
.financialChartIndicatorPicker:hover .financialChartIndicatorPickerDropDownButton:after,
.financialChartOverlayPicker:hover .financialChartOverlayPickerDropDownButton:after {
	border-color: #0090ff transparent transparent transparent;
}
`]
            },] },
];
/** @nocollapse */
IgxFinancialChartDefaultTemplatesComponent.ctorParameters = () => [
    { type: ChangeDetectorRef, },
];
IgxFinancialChartDefaultTemplatesComponent.propDecorators = {
    "financialChartRangeSelectorTemplate": [{ type: ViewChild, args: ["financialChartRangeSelectorTemplate",] },],
    "financialChartTrendlinePickerTemplate": [{ type: ViewChild, args: ["financialChartTrendlinePickerTemplate",] },],
    "financialChartOverlayPickerTemplate": [{ type: ViewChild, args: ["financialChartOverlayPickerTemplate",] },],
    "financialChartChartTypePickerTemplate": [{ type: ViewChild, args: ["financialChartChartTypePickerTemplate",] },],
    "financialChartVolumeTypePickerTemplate": [{ type: ViewChild, args: ["financialChartVolumeTypePickerTemplate",] },],
    "financialChartIndicatorPickerTemplate": [{ type: ViewChild, args: ["financialChartIndicatorPickerTemplate",] },],
    "financialChartToolbarTemplate": [{ type: ViewChild, args: ["financialChartToolbarTemplate",] },],
    "onContentReady": [{ type: Output },],
};
//# sourceMappingURL=igx-financial-chart-default-templates.js.map