import { forwardRef } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
/**
 * Financial indicator base class for doing calculating an itemwize indicator.
 * An itemwise indicator's individual values don't depend on any other values in the
 * collection so can always be independently recalculated. Also, because of this, the
 * base class handles all the looping logic and inheritors only need to provide the
 * actual calculation.
*/
export const IgxItemwiseStrategyBasedIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxItemwiseStrategyBasedIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxItemwiseStrategyBasedIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxItemwiseStrategyBasedIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxItemwiseStrategyBasedIndicatorComponent) }];
export class IgxItemwiseStrategyBasedIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}
//# sourceMappingURL=igx-itemwise-strategy-based-indicator-component.js.map