import { ensureBool } from "igniteui-angular-core/ES2015/componentUtil";
/**
 * Provides data for legend mouse button related events.
*/
export class LegendMouseButtonEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
         * Gets or sets a value that indicates the present state of the event handling for a routed
         * event as it travels the route.
         * ChartMouseButton events are not routed events; setting this property effects the underlying
         * MouseButtonEvent.
        */
    get handled() {
        return this.i.handled;
    }
    set handled(v) {
        this.i.handled = ensureBool(v);
    }
    /**
         * Gets a reference to the object that raised the event.
        */
    get originalSource() {
        return this.i.originalSource;
    }
    /**
         * Gets the ItemsSource item associated with the current event.
        */
    get item() {
        return this.i.item;
    }
    /**
         * Gets the series associated with the current event.
        */
    get series() {
        return this.i.series;
    }
    /**
         * Gets the Chart associated with the current event.
        */
    get chart() {
        return this.i.chart;
    }
    /**
         * The legend item that was the target of the mouse event.
        */
    get legendItem() {
        return this.i.legendItem;
    }
    /**
         * Provides a human readable description of the mouse button event.
        
        */
    toString() {
        let iv = this.i.toString();
        return (iv);
    }
}
//# sourceMappingURL=igx-legend-mouse-button-event-args.js.map