import { Type } from '@angular/core';
import { IgxAxisComponent } from "./igx-axis-component";
import { NumericAxisBase } from "./NumericAxisBase";
/**
 * Represents the base class for all IgxDataChartComponent numeric axes.
*/
export declare const IgxNumericAxisBaseComponent_PROVIDERS: {
    provide: typeof IgxAxisComponent;
    useExisting: Type<any>;
}[];
export declare abstract class IgxNumericAxisBaseComponent extends IgxAxisComponent {
    readonly i: NumericAxisBase;
    constructor();
    /**
     * Gets or sets if the current axis is of numeric axis type
    */
    readonly isNumeric: boolean;
    /**
     * Gets or sets the MinimumValue property.
    */
    minimumValue: number;
    /**
     * Gets the effective minimum value for the current numeric axis object.
    */
    readonly actualMinimumValue: number;
    /**
     * Gets the effective minimum value for the current numeric axis object.
    */
    readonly actualVisibleMinimumValue: number;
    /**
     * Gets or sets the MaximumValue property.
    */
    maximumValue: number;
    /**
     * Gets the effective maximum value for the current numeric axis object.
    */
    readonly actualMaximumValue: number;
    /**
     * Gets the effective visible maximum value for the current numeric axis object.
    */
    readonly actualVisibleMaximumValue: number;
    /**
     * Gets or sets the Interval property.
    */
    interval: number;
    /**
     * Gets the effective value for the current Interval.
    */
    readonly actualInterval: number;
    /**
     * Gets or sets the MinorInterval property.
    */
    minorInterval: number;
    /**
     * Gets the effective value for the current MinorInterval.
    */
    readonly actualMinorInterval: number;
    /**
     * Gets or sets the ReferenceValue property.
    */
    referenceValue: number;
    /**
     * Gets or sets the IsLogarithmic property.
    */
    isLogarithmic: boolean;
    /**
     * Determines if the axis has a valid logarithmic scale.
    */
    readonly actualIsLogarithmic: boolean;
    /**
     * Gets or sets the LogarithmBase property.
    */
    logarithmBase: number;
    /**
     * Determines if the axis has a user-defined minimum.
    */
    readonly hasUserMinimum: boolean;
    /**
     * Determines if the axis has a user-defined maximum.
    */
    readonly hasUserMaximum: boolean;
    abbreviateLargeNumbers: boolean;
    /**
     * Unscales a value from screen space into axis space.
    
    * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
    */
    unscaleValue(unscaledValue: number): number;
}
