import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStraightNumericAxisBaseComponent } from "./igx-straight-numeric-axis-base-component";
import { IgxNumericAxisBaseComponent } from "./igx-numeric-axis-base-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { NumericYAxis } from "./NumericYAxis";
/**
 * Represents a IgxDataChartComponent numeric Y axis.
*/
export const IgxNumericYAxisComponent_PROVIDERS = [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent) }];
export class IgxNumericYAxisComponent extends IgxStraightNumericAxisBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new NumericYAxis();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets if the current axis is of vertical axis
        */
    get isVertical() {
        return this.i.ce;
    }
    scrollRangeIntoView(minimum, maximum) {
        this.i.ln(minimum, maximum);
    }
}
IgxNumericYAxisComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-numeric-y-axis',
                template: ``,
                providers: [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxNumericYAxisComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-numeric-y-axis-component.js.map