import { Type, EventEmitter } from '@angular/core';
import { TimeAxisLabelFormatCollection } from "./igx-time-axis-label-format-collection";
import { AxisRangeChangedEventArgs } from "./igx-axis-range-changed-event-args";
import { IgxCategoryXAxisComponent } from "./igx-category-x-axis-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { OrdinalTimeXAxis } from "./OrdinalTimeXAxis";
/**
 * A horizontal axis that uses an ordinal DateTime scale.
 * On an ordinal time axis, datapoints are aligned according to their order in the ItemsSource, like a category axis.
*/
export declare const IgxOrdinalTimeXAxisComponent_PROVIDERS: {
    provide: typeof IgxAxisComponent;
    useExisting: Type<any>;
}[];
export declare class IgxOrdinalTimeXAxisComponent extends IgxCategoryXAxisComponent {
    protected createImplementation(): OrdinalTimeXAxis;
    readonly i: OrdinalTimeXAxis;
    constructor();
    dateTimeMemberPath: string;
    private _labelFormats;
    /**
     * A list of axis label formats to apply, which are selected according to the visible axis range.
     * The label format selected will be the one with the largest range smaller than the visible range of the axis.
    */
    labelFormats: TimeAxisLabelFormatCollection;
    private _actualRangeChanged;
    readonly actualRangeChanged: EventEmitter<{
        sender: any;
        args: AxisRangeChangedEventArgs;
    }>;
}
