import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxNumericYAxisComponent } from "./igx-numeric-y-axis-component";
import { IgxStraightNumericAxisBaseComponent } from "./igx-straight-numeric-axis-base-component";
import { IgxNumericAxisBaseComponent } from "./igx-numeric-axis-base-component";
import { IgxAxisComponent } from "./igx-axis-component";
import { PercentChangeYAxis } from "./PercentChangeYAxis";
/**
 * A horizontal axis that uses a DateTime scale.
*/
export const IgxPercentChangeYAxisComponent_PROVIDERS = [{ provide: IgxNumericYAxisComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }, { provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }];
export class IgxPercentChangeYAxisComponent extends IgxNumericYAxisComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PercentChangeYAxis();
    }
    get i() {
        return this._implementation;
    }
}
IgxPercentChangeYAxisComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-percent-change-y-axis',
                template: ``,
                providers: [{ provide: IgxNumericYAxisComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }, { provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxPercentChangeYAxisComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-percent-change-y-axis-component.js.map