import { DataContext } from "igniteui-angular-core/ES2015/igx-data-context";
import { PieSliceDataContext as PieSliceDataContext_internal } from "./PieSliceDataContext";
import { ensureBool } from "igniteui-angular-core/ES2015/componentUtil";
/**
 * DataContext for a pie slice.
*/
export class PieSliceDataContext extends DataContext {
    createImplementation() {
        return new PieSliceDataContext_internal();
    }
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
         * Gets or sets the value of this slice as a percentage of the total pie.
        */
    get percentValue() {
        return this.i.percentValue;
    }
    set percentValue(v) {
        this.i.percentValue = +v;
    }
    /**
         * Gets or sets whether this slice is an Others slice or not.
        */
    get isOthersSlice() {
        return this.i.isOthersSlice;
    }
    set isOthersSlice(v) {
        this.i.isOthersSlice = ensureBool(v);
    }
}
//# sourceMappingURL=igx-pie-slice-data-context.js.map