import { forwardRef, Input } from '@angular/core';
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
/**
 * Represents the base class for all IgxDataChartComponent ranged category/value series.
*/
export const IgxRangeCategorySeriesComponent_PROVIDERS = [{ provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeCategorySeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRangeCategorySeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRangeCategorySeriesComponent) }];
export class IgxRangeCategorySeriesComponent extends IgxCategorySeriesComponent {
    constructor() {
        super();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets or sets the value mapping property for the current series object.
        */
    get lowMemberPath() {
        return this.i.oo;
    }
    set lowMemberPath(v) {
        this.i.oo = v;
    }
    /**
         * Gets or sets the value mapping property for the current series object.
        */
    get highMemberPath() {
        return this.i.ol;
    }
    set highMemberPath(v) {
        this.i.ol = v;
    }
    /**
         * Scrolls the series to display the item for the specified data item.
         * The series is scrolled by the minimum amount required to place the specified data item within
         * the central 80% of the visible axis.
        
        * @param item  * The data item (item) to scroll to.
        */
    scrollIntoView(item) {
        let iv = this.i.c6(item);
        return (iv);
    }
}
IgxRangeCategorySeriesComponent.propDecorators = {
    "lowMemberPath": [{ type: Input },],
    "highMemberPath": [{ type: Input },],
};
//# sourceMappingURL=igx-range-category-series-component.js.map