import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxHorizontalRangeCategorySeriesComponent } from "./igx-horizontal-range-category-series-component";
import { IgxRangeCategorySeriesComponent } from "./igx-range-category-series-component";
import { IgxCategorySeriesComponent } from "./igx-category-series-component";
import { IgxMarkerSeriesComponent } from "./igx-marker-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { RangeColumnSeries } from "./RangeColumnSeries";
import { toPoint, fromRect } from "igniteui-angular-core/ES2015/componentUtil";
/**
 * Represents a IgxDataChartComponent range column series.
*/
export const IgxRangeColumnSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }];
export class IgxRangeColumnSeriesComponent extends IgxHorizontalRangeCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RangeColumnSeries();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
        */
    get radiusX() {
        return this.i.o2;
    }
    set radiusX(v) {
        this.i.o2 = +v;
    }
    /**
         * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
        */
    get radiusY() {
        return this.i.o3;
    }
    set radiusY(v) {
        this.i.o3 = +v;
    }
    /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.lb(toPoint(world));
        return fromRect(iv);
    }
    /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
    getItemSpan() {
        let iv = this.i.d8();
        return (iv);
    }
}
IgxRangeColumnSeriesComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-range-column-series',
                template: ``,
                providers: [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxRangeColumnSeriesComponent.ctorParameters = () => [];
IgxRangeColumnSeriesComponent.propDecorators = {
    "radiusX": [{ type: Input },],
    "radiusY": [{ type: Input },],
};
//# sourceMappingURL=igx-range-column-series-component.js.map