import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { RateOfChangeAndMomentumIndicator } from "./RateOfChangeAndMomentumIndicator";
/**
 * Represents a IgxDataChartComponent Rate of Change and Momentum indicator series.
 * Default required members: Close
*/
export const IgxRateOfChangeAndMomentumIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }];
export class IgxRateOfChangeAndMomentumIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RateOfChangeAndMomentumIndicator();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
         * The typical, and initial, value for AverageTrueRange periods is 14.
        */
    get period() {
        return this.i.qc;
    }
    set period(v) {
        this.i.qc = +v;
    }
}
IgxRateOfChangeAndMomentumIndicatorComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-rate-of-change-and-momentum-indicator',
                template: ``,
                providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxRateOfChangeAndMomentumIndicatorComponent.ctorParameters = () => [];
IgxRateOfChangeAndMomentumIndicatorComponent.propDecorators = {
    "period": [{ type: Input },],
};
//# sourceMappingURL=igx-rate-of-change-and-momentum-indicator-component.js.map