import { TimeAxisIntervalType } from "./TimeAxisIntervalType";
import { TimeAxisInterval as TimeAxisInterval_internal } from "./TimeAxisInterval";
/**
 * Settings for an interval on a time axis.
 * Label intervals can be applied to a time axis, which are dynamic, according to the visible range.  During zooming, the visible range of the axis can change, and so a different interval is selected.  The interval selected will be the one with the largest range smaller than the visible range of the axis.
*/
export declare class TimeAxisInterval {
    protected createImplementation(): TimeAxisInterval_internal;
    protected _implementation: any;
    readonly i: TimeAxisInterval_internal;
    private onImplementationCreated();
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The visible axis range at which to apply this interval.
    */
    range: number;
    /**
     * The interval, expressed as a multiple of IntervalType.
    */
    interval: number;
    /**
     * The unit of time for this interval.
    */
    intervalType: TimeAxisIntervalType;
}
