import { Type } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { TRIXIndicator } from "./TRIXIndicator";
/**
 * Represents a IgxDataChartComponent TRIX indicator series.
 * Default required members: Close
*/
export declare const IgxTRIXIndicatorComponent_PROVIDERS: ({
    provide: typeof IgxFinancialSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare class IgxTRIXIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    protected createImplementation(): TRIXIndicator;
    readonly i: TRIXIndicator;
    constructor();
    /**
     * Gets or sets the moving average period for the current TRIXIndicator object.
     * The typical, and initial, value for TRIX periods is 15.
    */
    period: number;
}
