import { EventEmitter, ViewContainerRef, Injector, ComponentFactoryResolver, AfterContentInit, Renderer2, NgZone } from '@angular/core';
import { IgRect } from "igniteui-angular-core/ES2015/IgRect";
import { ZoomSliderOrientation } from './ZoomSliderOrientation';
import { ZoomSliderResolvingAxisValueEventArgs } from './igx-zoom-slider-resolving-axis-value-event-args';
import { RectChangedEventArgs } from "igniteui-angular-core/ES2015/igx-rect-changed-event-args";
import { ZoomSlider } from "./ZoomSlider";
export declare const IgxZoomSliderComponent_PROVIDERS: any[];
export declare class IgxZoomSliderComponent implements AfterContentInit {
    private renderer;
    private _elRef;
    private document;
    private ngZone;
    private injector;
    private componentFactoryResolver;
    container: Element;
    private _height;
    private _width;
    height: string;
    width: string;
    _dynamicContent: ViewContainerRef;
    private _wrapper;
    constructor(renderer: Renderer2, _elRef: ViewContainerRef, document: any, ngZone: NgZone, injector: Injector, componentFactoryResolver: ComponentFactoryResolver);
    updateStyle(): void;
    ngOnDestroy(): void;
    private _implementation;
    ngAfterContentInit(): void;
    protected createImplementation(): ZoomSlider;
    readonly i: ZoomSlider;
    private _zoomSlider;
    panTransitionDuration: number;
    maxZoomWidth: number;
    pixelScalingRatio: number;
    actualPixelScalingRatio: number;
    windowRect: IgRect;
    minZoomWidth: number;
    startInset: number;
    endInset: number;
    trackStartInset: number;
    trackEndInset: number;
    barExtent: number;
    orientation: ZoomSliderOrientation;
    lowerThumbBrush: string;
    lowerThumbStrokeThickness: number;
    higherThumbStrokeThickness: number;
    higherThumbBrush: string;
    lowerThumbOutline: string;
    higherThumbOutline: string;
    lowerThumbRidgesBrush: string;
    higherThumbRidgesBrush: string;
    lowerThumbWidth: number;
    higherThumbWidth: number;
    lowerThumbHeight: number;
    higherThumbHeight: number;
    lowerShadeBrush: string;
    lowerShadeOutline: string;
    lowerShadeStrokeThickness: number;
    higherShadeBrush: string;
    higherShadeOutline: string;
    higherShadeStrokeThickness: number;
    barBrush: string;
    barOutline: string;
    barStrokeThickness: number;
    rangeThumbBrush: string;
    rangeThumbOutline: string;
    rangeThumbStrokeThickness: number;
    rangeThumbRidgesBrush: string;
    lowerCalloutBrush: string;
    lowerCalloutTextColor: string;
    lowerCalloutOutline: string;
    lowerCalloutStrokeThickness: number;
    higherCalloutBrush: string;
    higherCalloutTextColor: string;
    higherCalloutOutline: string;
    higherCalloutStrokeThickness: number;
    readonly isCustomThumbProvided: boolean;
    readonly isCustomRangeThumbProvided: boolean;
    readonly isCustomBarProvided: boolean;
    readonly isCustomShadeProvided: boolean;
    areThumbCalloutsEnabled: boolean;
    ThumbCalloutTextStyle: string;
    destroy(): void;
    provideContainer(container: any): void;
    flush(): void;
    trackDirty(): void;
    private _resolvingAxisValue;
    readonly resolvingAxisValue: EventEmitter<{
        sender: any;
        args: ZoomSliderResolvingAxisValueEventArgs;
    }>;
    private _windowRectChanged;
    readonly windowRectChanged: EventEmitter<{
        sender: any;
        args: RectChangedEventArgs;
    }>;
    protected _zoneRunner: (act: () => void) => void;
    protected _runInZone(act: () => void): void;
}
