/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "igniteui-angular-core/ES5/ArgumentNullException";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { ScalerParams } from "./ScalerParams";
import { Series } from "./Series";
import { Base, typeCast, Type, markType, Array_$type, Number_$type, Point_$type, enumGetBox, runOn, fromEnum } from "igniteui-angular-core/ES5/type";
import { truncate, intDivide, isNaN_, isInfinity } from "igniteui-angular-core/ES5/number";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { IProvidesViewport_$type } from "./IProvidesViewport";
import { ISupportsErrorBars_$type } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { PreparationParams } from "./PreparationParams";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { DefaultCategoryTrendlineHost } from "./DefaultCategoryTrendlineHost";
import { DefaultSingleValueProvider } from "./DefaultSingleValueProvider";
import { SingleValuesHolder } from "./SingleValuesHolder";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager_$type } from "./ICategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core/ES5/DVContainer";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { Marker } from "./Marker";
import { Pool$1 } from "igniteui-angular-core/ES5/Pool$1";
import { Clipper } from "igniteui-angular-core/ES5/Clipper";
import { PropertyMetadata } from "igniteui-angular-core/ES5/PropertyMetadata";
import { MarkerSeriesView } from "./MarkerSeriesView";
var CategoryBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryBucketCalculator, _super);
    function CategoryBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.c = null;
        _this.e = 0;
        _this.f = 0;
        _this.d = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.c = a;
        _this.e = -1;
        _this.d = 0;
        return _this;
    }
    CategoryBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    CategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    CategoryBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    CategoryBucketCalculator.prototype.g = function (a) {
        var b = this.c.bq;
        var c = this.c.bp;
        var d = this.c.cn;
        var e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
        var f = d.bz;
        if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
            this.d = 0;
            return;
        }
        var g = d.getEffectiveViewport1(this.c);
        var h = d.k7(this.c);
        var i = typeCast(ISortingAxis_$type, e);
        if (i == null || i.i$b == null) {
            var j = new ScalerParams(0, b, c, e.b8, g);
            var k = Math.floor(e.dx(h.left, j, 0));
            var l = Math.ceil(e.dx(h.right, j, 0));
            if (e.b8) {
                l = Math.ceil(e.dx(h.left, j, 0));
                k = Math.floor(e.dx(h.right, j, 0));
            }
            var m = Math.floor((l - k + 1) * a / h.width);
            this.d = truncate(Math.max(1, m));
            this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
            this.f = truncate(Math.ceil(l / this.d));
        }
        else {
            this.e = i.i$e(b, c, g, h);
            this.f = i.i$g(b, c, g, h);
            this.d = 1;
        }
    };
    CategoryBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.e;
        b = this.f;
        c = this.d;
        d = this.c.cn.ek;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    CategoryBucketCalculator.prototype.cacheValues = function () {
    };
    CategoryBucketCalculator.prototype.unCacheValues = function () {
    };
    CategoryBucketCalculator.$t = markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
    return CategoryBucketCalculator;
}(Base));
export { CategoryBucketCalculator };
var CategoryFramePreparerBase = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryFramePreparerBase, _super);
    function CategoryFramePreparerBase(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, g, h, i) || this;
                        _this.g = null;
                        _this.h = null;
                        _this.m = false;
                        _this.o = new List$1(Array_$type, 0);
                        _this.p = new List$1(Number_$type, 0);
                        _this.n = new List$1(Number_$type, 0);
                        _this.h = f;
                        _this.g = j;
                    }
                    _this.g = null;
                    _this.h = null;
                    _this.m = false;
                    _this.o = new List$1(Array_$type, 0);
                    _this.p = new List$1(Number_$type, 0);
                    _this.n = new List$1(Number_$type, 0);
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, d, e, f) || this;
                    _this.g = null;
                    _this.h = null;
                    _this.m = false;
                    _this.o = new List$1(Array_$type, 0);
                    _this.p = new List$1(Number_$type, 0);
                    _this.n = new List$1(Number_$type, 0);
                    _this.h = c;
                    _this.g = g;
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparerBase.prototype.i = function (a) {
        var b = new PreparationParams();
        b.f = this.h.useHighMarkerFidelity;
        b.b = this.h.scaler;
        b.c = this.h.yScaler;
        b.d = typeCast(ISortingAxis_$type, b.b);
        b.a = typeCast(CategoryFrame.$, a);
        if (b.a == null || b.b == null || b.c == null) {
            return null;
        }
        var c;
        var d;
        var e;
        var f;
        var g = this.g.getBucketInfo(c, d, e, f);
        c = g.p0;
        d = g.p1;
        e = g.p2;
        f = g.p3;
        b.i = c;
        b.j = d;
        b.h = e;
        b.g = f;
        if (b.j < b.i) {
            return null;
        }
        var h;
        var i;
        var j;
        var k = this.a.getViewInfo(i, h);
        i = k.p0;
        h = k.p1;
        j = this.a.getEffectiveViewport();
        b.m = h;
        b.l = i;
        b.k = j;
        if (Rect.l_op_Equality(b.m, Rect.empty) || Rect.l_op_Equality(b.l, Rect.empty)) {
            return null;
        }
        if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.cr) && this.g != null) {
            b.e = true;
        }
        return b;
    };
    CategoryFramePreparerBase.prototype.r = function (a, b, c, d) {
        return a.getOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
    };
    CategoryFramePreparerBase.prototype.s = function (a) {
        return this.r(a.b, a.m, a.l, a.k);
    };
    CategoryFramePreparerBase.prototype.d = function (a, b) {
        var c = this.i(a);
        if (c == null || this.g == null) {
            return;
        }
        c.a.f.clear();
        c.a.k.clear();
        c.a.m.clear();
        c.a.p.clear();
        c.a.i.clear();
        c.a.h.clear();
        c.a.g.clear();
        var d = this.c.shouldDisplayMarkers;
        var e = false;
        var f = this.s(c);
        var g = this.j(c);
        if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
            return;
        }
        if (c.d != null && c.d.i$a) {
            c.d.i$h();
        }
        this.g.cacheValues();
        if (this.m && c.d != null && c.d.i$b.count > 0) {
            var h = c.d.i$b._inner[c.i];
            this.z(g, h, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.i > 0) {
                c.i = c.i - 1;
                h = c.d.i$b._inner[c.i];
                this.z(g, h, true, c.e);
            }
            var i = c.d.i$b._inner[c.j];
            this.z(g, i, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.j < g.e - 1) {
                c.j = c.j + 1;
                i = c.d.i$b._inner[c.j];
                this.z(g, i, true, c.e);
            }
        }
        if (this.m && c.d == null) {
            var j = c.i;
            var k = this.g.getBucket(j);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.i > 0) {
                c.i = c.i - 1;
                j = c.i;
                k = this.g.getBucket(j);
            }
            var l = c.j;
            k = this.g.getBucket(l);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.j < (intDivide(g.e, c.h))) {
                c.j = c.j + 1;
                l = c.j;
                k = this.g.getBucket(l);
            }
        }
        this.w(c, g, f);
        var m = this.t(c, g, f, d, e);
        this.c.updateMarkerCount(m);
        this.v(typeCast(CategoryFrame.$, a), b);
        this.g.unCacheValues();
        return;
    };
    CategoryFramePreparerBase.prototype.v = function (a, b) {
    };
    Object.defineProperty(CategoryFramePreparerBase.prototype, "q", {
        get: function () {
            return this.o;
        },
        enumerable: true,
        configurable: true
    });
    CategoryFramePreparerBase.prototype.t = function (a, b, c, d, e) {
        var _this = this;
        var f = 0;
        var g = false;
        var h = null;
        var i = false;
        var j = a.d != null;
        var k = a.m;
        var l = a.l;
        var m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.jm;
        var n = a.f;
        var o = this.h.mayContainUnknowns;
        var p = this.o;
        var q = this.n;
        var r = this.p;
        p.clear();
        q.clear();
        r.clear();
        var s = this.g;
        var t = this.h.provideCollisionDetector();
        var u = 0;
        var v = a.k;
        var w = new ScalerParams(0, k, l, a.b.j$a, v);
        var x = ((function () {
            var $ret = new ScalerParams(0, k, l, a.c.j$a, v);
            $ret.b = typeCast(Series.$, _this.h) !== null ? _this.h.d9() : NaN;
            return $ret;
        })());
        if (j) {
            u = a.b.j$c(2, w) - a.b.j$c(1, w);
            i = this.k();
        }
        var y = a.i;
        var z = a.j;
        var aa = a.a.f;
        var ab = typeCast(IDateTimeAxis_$type, a.b);
        if (ab != null) {
            ab.StartTimeCursor();
        }
        var _loop_1 = function (ac) {
            var ad = void 0;
            if (!j) {
                if (!o) {
                    ad = s.getBucketWithoutUnknowns(ac);
                }
                else {
                    ad = s.getBucket(ac);
                }
            }
            else {
                ad = ((function () { var ae = _this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
            }
            var ae = !m || (m && ad[1] > 0);
            var af = ad[0];
            if (!j || !isNaN_(ad[0])) {
                aa.add(ad);
                if (g && i) {
                    if (h != null) {
                        aa.add(h);
                    }
                }
                if (d && ae) {
                    var ag = ac * a.h;
                    var ah = ag;
                    if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                        ag = a.d.i$b._inner[ag];
                    }
                    var ai = new Array(ad.length);
                    ai[0] = ad[0];
                    ai[1] = ad[1];
                    ai[2] = ad[2];
                    if (n && ag < b.e) {
                        ai = new Array(ad.length);
                        ai[0] = af;
                        this_1.z(b, ag, true, a.e);
                        ai[1] = b.c;
                        ai[2] = b.d;
                    }
                    p.add(ai);
                    q.add(a.a.f.count - 1);
                    r.add(ag);
                }
            }
            out_ac_1 = ac;
        };
        var this_1 = this, out_ac_1;
        for (var ac = y; ac <= z; ++ac) {
            _loop_1(ac);
            ac = out_ac_1;
        }
        if (ab != null) {
            ab.ResetTimeCursor();
        }
        this.y(a, c, j, w, x, e, d);
        if (d) {
            var aj = p.count;
            var ak = void 0;
            for (var al = 0; al < aj; al++) {
                ak = p._inner[al];
                if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                    ++f;
                }
            }
        }
        return f;
    };
    CategoryFramePreparerBase.prototype.k = function () {
        if (typeCast(Series.$, this.h) !== null) {
            return this.h.cj;
        }
        return false;
    };
    CategoryFramePreparerBase.prototype.f = function (a, b, c, d, e, f, g) {
        var h;
        f = null;
        e = false;
        var i = typeCast(CategorySeries.$, this.h);
        var j = a.l;
        var k = a.m;
        var l = a.k;
        var m = new ScalerParams(0, k, j, a.b.j$a, l);
        var n = new ScalerParams(0, k, j, a.c.j$a, l);
        var o = a.e;
        if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        if (i != null && i.bz != null && i.bz.count < a.d.i$b.count) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        var p = a.d.i$b._inner[b];
        var q = a.d.i$d(p);
        var r = q;
        this.z(c, p, false, o);
        while (b < a.j) {
            p = a.d.i$b._inner[b + 1];
            r = a.d.i$d(p);
            this.z(c, p, true, o);
            if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                if (e) {
                    var s = a.d.i$b._inner[b];
                    this.z(c, s, true, o);
                    f = [a.b.j$b(q, m), c.c, c.d];
                }
                break;
            }
            if (!e && this.k()) {
                var t = a.d.i$b._inner[b];
                this.z(c, t, true, o);
                var u = [a.b.j$b(q, m), c.c, c.d];
                if (!isNaN_(u[0])) {
                    if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                        if (a.d != null) {
                            u[0] = u[0] + g;
                        }
                        a.a.f.add(u);
                        e = true;
                    }
                    else {
                        break;
                    }
                }
            }
            b++;
            this.u(c, p, o);
        }
        var v = NaN;
        if (!isNaN_(q)) {
            v = a.b.j$b(q, m);
        }
        h = this.e(v, c);
        return {
            ret: h,
            p1: b,
            p4: e,
            p5: f
        };
    };
    CategoryFramePreparerBase.prototype.y = function (a, b, c, d, e, f, g) {
        var h = a.h;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.o;
        var l = k.count;
        if (f) {
            var m = a.c.j$b(a.c.j6, e);
            a.c.j$e(a.a.k, 0, a.a.k.count, e);
            var n = a.a.k;
            var o = n.count;
            for (var p = 0; p < n.count; p++) {
                n._inner[p] = Math.abs(n._inner[p] - m);
            }
        }
    };
    CategoryFramePreparerBase.prototype.w = function (a, b, c) {
    };
    CategoryFramePreparerBase.$t = markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
    return CategoryFramePreparerBase;
}(FramePreparer));
export { CategoryFramePreparerBase };
var CategoryFramePreparer = /** @class */ (function (_super) {
    tslib_1.__extends(CategoryFramePreparer, _super);
    function CategoryFramePreparer(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    var d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        var f = d[0];
                        var g = d[1];
                        var h = d[2];
                        var i = d[3];
                        var j = d[4];
                        _this = _super.call(this, 1, f, g, h, i, j) || this;
                        _this.aa = null;
                        _this.ab = null;
                        _this.aa = new DefaultCategoryTrendlineHost();
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            _this.aa = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        _this.ab = new DefaultSingleValueProvider();
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            _this.ab = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                    _this.aa = null;
                    _this.ab = null;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    var g = _rest[4];
                    _this = _super.call(this, 1, c, d, e, f, g) || this;
                    _this.aa = null;
                    _this.ab = null;
                    _this.aa = new DefaultCategoryTrendlineHost();
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        _this.aa = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    _this.ab = new DefaultSingleValueProvider();
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        _this.ab = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
        return _this;
    }
    CategoryFramePreparer.prototype.l = function (a, b, c, d, e, f) {
        var g = b[0];
        var h = b[1];
        var i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    };
    CategoryFramePreparer.prototype.j = function (a) {
        var b = new SingleValuesHolder();
        var c = this.ab.valueColumn;
        b.f = c;
        return b;
    };
    CategoryFramePreparer.prototype.x = function (a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$b(b[0], e) + c;
        }
        b[1] = a.c.j$b(b[1], f);
        if (a.h > 1 || d) {
            b[2] = a.c.j$b(b[2], f);
        }
        else {
            b[2] = b[1];
        }
    };
    CategoryFramePreparer.prototype.y = function (a, b, c, d, e, f, g) {
        _super.prototype.y.call(this, a, b, c, d, e, f, g);
        var h = a.h;
        var i = a.a.f.count;
        var j = a.a.f;
        var k = this.q;
        var l = k.count;
        var m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        var n = new List$1(Number_$type, 0);
        n.add(1);
        if (c || h > 1) {
            n.add(2);
        }
        a.b.j$d(j, m, 0, i, d);
        a.c.j$d(j, n, 0, i, e);
        for (var o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (h == 1 && !c) {
            for (var p = 0; p < i; p++) {
                j._inner[p][2] = j._inner[p][1];
            }
        }
        if (g) {
            a.b.j$d(k, m, 0, l, d);
            a.c.j$d(k, n, 0, l, e);
            for (var q = 0; q < l; q++) {
                k._inner[q][0] = k._inner[q][0] + b;
            }
            if (h == 1 && !c) {
                for (var r = 0; r < l; r++) {
                    k._inner[r][2] = k._inner[r][1];
                }
            }
        }
    };
    CategoryFramePreparer.prototype.w = function (a, b, c) {
        if (this.aa.trendLineType == 0 || this.aa.trendlinePreparer == null || this.aa.trendLinePeriod < 1) {
            return;
        }
        this.aa.trendlinePreparer.prepareLine(this.aa, a, b, c);
    };
    CategoryFramePreparer.prototype.z = function (a, b, c, d) {
        var e = a;
        var f = e.f;
        var g = f.item(b);
        var h = g;
        if (d) {
            var i = this.g.getBucket(b);
            g = i[1];
            h = i[1];
        }
        if (c) {
            e.c = g;
            e.d = h;
        }
        else {
            e.a = g;
            e.b = h;
        }
    };
    CategoryFramePreparer.prototype.u = function (a, b, c) {
        var d = a;
        var e = d.f;
        if (b < e.count) {
            var f = void 0;
            if (c) {
                var g = this.g.getBucket(b);
                f = g[1];
            }
            else {
                f = e.item(b);
            }
            d.a = Math.min(d.a, f);
            d.b = Math.max(d.b, f);
        }
    };
    CategoryFramePreparer.prototype.e = function (a, b) {
        var c = b;
        return [a, c.a, c.b];
    };
    CategoryFramePreparer.$t = markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
    return CategoryFramePreparer;
}(CategoryFramePreparerBase));
export { CategoryFramePreparer };
var CategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(CategorySeries, _super);
    function CategorySeries() {
        var _this = _super.call(this) || this;
        _this.ms = null;
        _this.m5 = null;
        _this.m9 = false;
        _this.m8 = false;
        _this.assigningCategoryStyle = null;
        _this.assigningCategoryMarkerStyle = null;
        _this.m3 = null;
        _this.m4 = null;
        _this.mp = new CategoryFrame(3);
        _this.mr = new CategoryFrame(3);
        _this.mo = new CategoryFrame(3);
        _this.mq = new CategoryFrame(3);
        _this.mv = null;
        _this.mz = null;
        _this.ob = null;
        _this.mv = new CategorySeriesRenderManager();
        _this.mz = new CategoryTransitionSourceFramePreparer();
        _this.ob = new Rect(0, 0, 0, 1, 1);
        _this.m9 = false;
        _this.m8 = false;
        _this.ab = CategorySeries.$;
        return _this;
    }
    CategorySeries.prototype.bf = function () {
        var a = new CategorySeriesView(this);
        return a;
    };
    Object.defineProperty(CategorySeries.prototype, "m6", {
        get: function () {
            var _this = this;
            if (this.m5 == null) {
                this.m5 = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.m5;
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.ib = function (a) {
        _super.prototype.ib.call(this, a);
        this.mw = a;
    };
    CategorySeries.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(CategorySeries.prototype, "categoryAxis", {
        get: function () {
            return this.mn();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.mn = function () {
        return this.fetchXAxis();
    };
    CategorySeries.prototype.m7 = function () {
        return this.fetchYAxis();
    };
    CategorySeries.prototype.get_ck = function () {
        return true;
    };
    Object.defineProperty(CategorySeries.prototype, "ck", {
        get: function () {
            return this.get_ck();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.ac = function () {
        _super.prototype.ac.call(this);
        this.mw.cl.g(this.ek);
    };
    CategorySeries.prototype.ng = function () {
        return (this.assigningCategoryStyle != null && this.m9) || this.ct;
    };
    CategorySeries.prototype.nh = function () {
        return (this.assigningCategoryMarkerStyle != null && this.m8) || this.ct;
    };
    CategorySeries.prototype.n3 = function (a) {
        if (this.assigningCategoryStyle != null && this.m9) {
            this.assigningCategoryStyle(this, a);
        }
    };
    CategorySeries.prototype.n2 = function (a) {
        if (this.assigningCategoryMarkerStyle != null && this.m8) {
            this.assigningCategoryMarkerStyle(this, a);
        }
    };
    CategorySeries.prototype.mh = function (a, b) {
        return null;
    };
    CategorySeries.prototype.hf = function (a, b) {
        _super.prototype.hf.call(this, a, b);
        if (a) {
            this.nx(b);
        }
    };
    CategorySeries.prototype.a8 = function () {
        var a = _super.prototype.a8.call(this);
        return a;
    };
    CategorySeries.prototype.hu = function () {
        _super.prototype.hu.call(this);
        var a = this.fetchXAxis();
        if (a != null) {
            a.gz(false);
        }
        var b = this.fetchYAxis();
        if (b != null) {
            b.gz(false);
        }
    };
    CategorySeries.prototype.ja = function (a, b) {
        _super.prototype.ja.call(this, a, b);
        this.mw.cl.g(this.ek);
        this.iv(false);
    };
    CategorySeries.prototype.i9 = function (a, b) {
        if (this.dj && this.ep < 0.05 && (this.bs == null || !this.bs.c2())) {
            this.dk = true;
        }
        _super.prototype.i9.call(this, a, b);
        this.mw.cl.g(this.ek);
        this.iv(false);
    };
    CategorySeries.prototype.ih = function (a, b, c, d) {
        _super.prototype.ih.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                var e = this.fetchYAxis();
                var f = this.fetchXAxis();
                if (c != null && d == null) {
                    this.hj(f);
                    this.hj(e);
                }
                if (c == null && d != null) {
                    this.im(f);
                    this.im(e);
                }
                this.mw.cl.g(this.ek);
                this.iv(false);
                break;
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.mw.cl.g(this.ek);
                }
                this.iv(false);
                break;
            case "TransitionProgress":
                this.mr.c(this.ep, this.mp, this.mo);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ep == 1) {
                    this.mo.v();
                    this.n4(this.mo, this.mw);
                    if (this.dj) {
                        this.dj = false;
                        this.hg();
                        this.bt.r = truncate(this.eh());
                        this.bt.b = this.bu;
                    }
                }
                else {
                    this.n4(this.mr, this.mw);
                }
                break;
            case "ErrorBarSettings":
                this.h2();
                break;
            case CategorySeries.$$p[4]:
                this.iv(false);
                break;
            case CategorySeries.$$p[1]:
                this.m9 = this.nb();
                this.iv(false);
                break;
            case CategorySeries.$$p[0]:
                this.m8 = this.na();
                this.iv(false);
                break;
        }
    };
    CategorySeries.prototype.nb = function () {
        return this.ne;
    };
    CategorySeries.prototype.na = function () {
        return this.nd;
    };
    CategorySeries.prototype.nm = function (a) {
        return this.d5(a, this.fetchXAxis());
    };
    CategorySeries.prototype.get_c0 = function () {
        return typeCast(ISortingAxis_$type, this.mn()) !== null;
    };
    Object.defineProperty(CategorySeries.prototype, "c0", {
        get: function () {
            return this.get_c0();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.ap = function () {
        return this.mn();
    };
    CategorySeries.prototype.e0 = function (a) {
        return this.m6.b$d(this, a);
    };
    CategorySeries.prototype.ff = function (a) {
        return this.m6.b$f(this, a);
    };
    CategorySeries.prototype.ey = function (a) {
        var b = truncate(Math.round(this.d3(a)));
        return b;
    };
    CategorySeries.prototype.d3 = function (a) {
        return this.m6.b$c(this, a);
    };
    CategorySeries.prototype.get_nc = function () {
        return false;
    };
    Object.defineProperty(CategorySeries.prototype, "nc", {
        get: function () {
            return this.get_nc();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.au = function (a, b) {
        var c = this.m2(a, b, this.m4);
        this.m4 = c;
        return c;
    };
    CategorySeries.prototype.get_cu = function () {
        return true;
    };
    Object.defineProperty(CategorySeries.prototype, "cu", {
        get: function () {
            return this.get_cu();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.at = function (a, b) {
        if (this.nc) {
            var c = this.m1(a, b, this.m3);
            this.m3 = c;
            return c;
        }
        else {
            var d = this.m0(a, b, this.m3);
            this.m3 = d;
            return d;
        }
    };
    CategorySeries.prototype.nl = function () {
        return this.mw.co.a;
    };
    CategorySeries.prototype.m2 = function (a, b, c) {
        if (!this.lk()) {
            return null;
        }
        var d = this.mo;
        if (this.ca()) {
            d = this.mr;
        }
        var e = this.nl();
        return this.m6.b$b(this, e, d.f, a, b, c);
    };
    CategorySeries.prototype.m1 = function (a, b, c) {
        var d = this.mw.cl.e;
        var e = this.mw.cl.f;
        var f = this.mw.cl.d;
        var g = this.mo;
        if (this.ca()) {
            g = this.mr;
        }
        return this.m6.b$a(this, g.f, d, e, f, a, b, c);
    };
    CategorySeries.prototype.m0 = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.bz.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    };
    CategorySeries.prototype.nz = function (a, b, c, d, e, f) {
        var g = this.b9;
        this.mv.ab(a, b, c, d, e, f, g);
        var h = this.mv.b;
        var i = null;
        var j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, true);
            h.b = i;
        }
        h.f = f;
        this.n2(h);
        this.mv.z(i, f, g);
    };
    CategorySeries.prototype.n0 = function (a, b, c, d, e, f) {
        var g = this.b9;
        this.mv.ac(a, b, c, d, e, f, g);
        var h = this.mv.c;
        var i = null;
        var j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.n3(h);
        this.mv.aa(i, f, g);
    };
    CategorySeries.prototype.dt = function (a, b, c) {
        var d = _super.prototype.dt.call(this, a, b, c);
        d = d && this.nk(this.fetchXAxis());
        d = d && this.nk(this.fetchYAxis());
        var e = c;
        if (!c.l() || b.isEmpty || a.isEmpty || this.bz == null) {
            d = false;
        }
        if (!d) {
            e.cl.d = 0;
        }
        return d;
    };
    CategorySeries.prototype.nk = function (a) {
        if (a == null || a.bf == null) {
            return false;
        }
        var b = typeCast(CategoryAxisBase.$, a);
        if (b != null) {
            if (b.itemsSource == null) {
                return false;
            }
            if (b.jq < 1) {
                return false;
            }
        }
        else {
            var c = typeCast(NumericAxisBase.$, a);
            if (c != null) {
                return c.jw != c.jv;
            }
        }
        return true;
    };
    CategorySeries.prototype.c9 = function () {
        return this.nf;
    };
    CategorySeries.prototype.mx = function () {
        return 12;
    };
    CategorySeries.prototype.hg = function () {
        _super.prototype.hg.call(this);
        this.mp.v();
        this.mo.v();
        this.mr.v();
    };
    CategorySeries.prototype.iw = function (a) {
        _super.prototype.iw.call(this, a);
        this.mw.cl.g(this.ek);
        if (this.cc(this.bi)) {
            this.mo.y();
            this.mr.y();
            this.mp.y();
            return;
        }
        if (this.db) {
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.n4(this.mr, this.mw);
            }
            else {
                this.n4(this.mo, this.mw);
            }
            return;
        }
        if (this.c7(a)) {
            var b = this.mp;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.mp = this.mr;
                this.mr = b;
            }
            else {
                this.mp = this.mo;
                this.mo = b;
            }
            this.n1(this.mo, this.mw);
            if (this.dl) {
                this.bt.w();
                this.bt.r = truncate(this.ei());
                this.bt.b = this.bv != null ? this.bv : this.bu;
                this.mz.p(this.mp, this.mo, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.my, this.mx(), this.bp, this.bo(), runOn(this, this.nn), this.mw.bp);
            }
            this.hc();
            this.i3();
            if (this.dl) {
                this.dk = false;
                this.dj = true;
            }
        }
        else {
            this.n1(this.mo, this.mw);
            this.n4(this.mo, this.mw);
        }
    };
    CategorySeries.prototype.bo = function () {
        return 3;
    };
    CategorySeries.prototype.nn = function () {
        if (this.isVertical) {
            return this.lf.left;
        }
        return this.lf.bottom;
    };
    CategorySeries.prototype.nq = function () {
        var a = 0;
        var b = this.fetchXAxis();
        try {
            for (var _a = tslib_1.__values(fromEnum(this.bs.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                if (c == this) {
                    return a;
                }
                var d = typeCast(CategorySeries.$, c);
                if (d != null) {
                    var e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
                    if (e == b && d.preferredCategoryMode(e) == 2) {
                        a++;
                    }
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return -1;
        var e_1, _c;
    };
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsXAxis", {
        get: function () {
            return this.fetchXAxis();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CategorySeries.prototype, "GetErrorBarsYAxis", {
        get: function () {
            return this.fetchYAxis();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.ny = function (a, b) {
        this.mv.w(this, this.nh(), runOn(this, this.mh), this.no(a), this.np(a));
        var c = this.mv.b;
        var d = c != null;
        var e = this.mn();
        if (e == null) {
            return;
        }
        var f = this.getEffectiveViewport1(a);
        var g = new ScalerParams(0, a.bq, a.bp, e.b8, f);
        var h = this.bz == null ? 0 : this.bz.count;
        var i = a;
        var j = b.f;
        var k = i.cl.e;
        var l = i.cl.f;
        var m = i.cl.d;
        var n = k * m;
        for (var o = 0; o < a.co.count; o++) {
            var p = a.co.item(o);
            var q = p.content;
            if (d) {
                var r = p.al;
                this.nz(j, r, h, e, g, a.n);
            }
            this.mv.ad(p, q);
        }
    };
    CategorySeries.prototype.n4 = function (a, b) {
        this.k6 = a.aa;
        b.ar();
    };
    Object.defineProperty(CategorySeries.prototype, "oc", {
        get: function () {
            return this.ob;
        },
        enumerable: true,
        configurable: true
    });
    CategorySeries.prototype.n1 = function (a, b) {
        a.u();
    };
    CategorySeries.prototype.no = function (a) {
        return a.cl.d;
    };
    CategorySeries.prototype.np = function (a) {
        return a.cl.e;
    };
    CategorySeries.prototype.nx = function (a) {
        var b = a;
        b.co.count = 0;
    };
    CategorySeries.prototype.ix = function (a, b) {
        _super.prototype.ix.call(this, a, b);
        if (!this.di) {
            this.bi.az(b);
            return;
        }
        var c = typeCast(CategorySeriesView.$, this.bh);
        c.cl.g(this.ek);
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        this.n5();
        this.di = false;
    };
    CategorySeries.prototype.n5 = function () {
        var a = typeCast(CategorySeriesView.$, this.bh);
        if (!this.dc) {
            this.n1(this.mq, a);
        }
        this.dc = false;
        this.n4(this.mq, a);
    };
    CategorySeries.prototype.mt = function (a) {
        var b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.n) {
            if (b.m) {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cl);
            }
            else {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.bs.bk.m, this, b.cl);
            }
        }
        else {
            return this.ms;
        }
    };
    CategorySeries.prototype.am = function (a) {
        if (this.fetchXAxis() == a) {
            return this.fetchYAxis();
        }
        if (this.fetchYAxis() == a) {
            return this.fetchXAxis();
        }
        return null;
    };
    CategorySeries.prototype.ag = function () {
        return [this.fetchXAxis(), this.fetchYAxis()];
    };
    CategorySeries.mi = function (a, b, c, d, e) {
        var f = null;
        if (b > -1 && !d.isEmpty && !c.isEmpty) {
            var g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
            var h = c.bottom + 10;
            var i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
            var j = c.top - 10;
            f = new Clipper(1, g, h, i, j, e);
        }
        return f;
    };
    CategorySeries.$t = markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
    return CategorySeries;
}(MarkerSeries));
export { CategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:nd:n6', [0, false], 'IsCustomCategoryStyleAllowed:ne:n7', [0, false], 'IsTransitionInEnabled:nf:n8', [0, false], 'TransitionInMode:my:n9', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:nj:oa', [0, false]]);
var CategorySeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(CategorySeriesView, _super);
    function CategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cn = null;
        _this.cq = 0;
        _this.cl = null;
        _this.co = null;
        _this.cq = -1;
        _this.cn = a;
        _this.cl = _this.cm();
        _this.co = ((function () {
            var $ret = new Pool$1(Marker.$);
            $ret.create = runOn(_this, _this.bv);
            $ret.activate = runOn(_this, _this.ce);
            $ret.disactivate = runOn(_this, _this.cg);
            $ret.destroy = runOn(_this, _this.cf);
            return $ret;
        })());
        return _this;
    }
    CategorySeriesView.prototype.cp = function (a) {
        if (this.cq != a.t) {
            return true;
        }
        return false;
    };
    CategorySeriesView.prototype.cs = function (a) {
        this.cq = a.t;
    };
    CategorySeriesView.prototype.updateMarkerTemplate = function (a, b, c) {
        if (!this.bw.lm) {
            var d = this.co.item(a);
            var e = d.content;
            e.item = this.e.bz.item(b);
            d.ak = b;
            d.al = c;
        }
    };
    CategorySeriesView.prototype.cm = function () {
        return new CategoryBucketCalculator(this);
    };
    Object.defineProperty(CategorySeriesView.prototype, "shouldDisplayMarkers", {
        get: function () {
            return this.cn.lk();
        },
        enumerable: true,
        configurable: true
    });
    CategorySeriesView.prototype.updateMarkerCount = function (a) {
        this.co.count = a;
    };
    CategorySeriesView.prototype.ca = function (a) {
        this.co.c(a);
    };
    CategorySeriesView.prototype.cr = function () {
    };
    CategorySeriesView.$t = markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);
    return CategorySeriesView;
}(MarkerSeriesView));
export { CategorySeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.CategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategorySeries" />*/
//# sourceMappingURL=CategoryBucketCalculator_combined.js.map