import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IndicatorDisplayType } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-angular-core/ES5/DependencyProperty";
import { TrendLineType } from "igniteui-angular-core/ES5/TrendLineType";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { PenLineCap } from "igniteui-angular-core/ES5/PenLineCap";
import { DoubleCollection } from "igniteui-angular-core/ES5/DoubleCollection";
import { List$1 } from "igniteui-angular-core/ES5/List$1";
import { AxisRange } from "./AxisRange";
import { SeriesView } from "./SeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { Axis } from "./Axis";
import { Point, IList$1, Type } from "igniteui-angular-core/ES5/type";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES5/FastItemsSourceEventAction";
import { ITrendLineManager } from "./ITrendLineManager";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Clipper } from "igniteui-angular-core/ES5/Clipper";
import { Path } from "igniteui-angular-core/ES5/Path";
import { RenderingContext } from "igniteui-angular-core/ES5/RenderingContext";
export declare abstract class FinancialIndicator extends FinancialSeries implements ITrendLineSeries {
    protected bf(): SeriesView;
    ib(a: SeriesView): void;
    oy: FinancialIndicatorView;
    constructor();
    pa(a: boolean): void;
    protected o2(a: Point, b: Point, c: boolean): boolean;
    protected bd(): SeriesHitTestMode;
    lb(a: Point): Rect;
    de(a: Point, b: boolean): boolean;
    protected hi(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    oz: IndicatorDisplayType;
    o5: number;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    pn: Brush;
    static readonly pd: DependencyProperty;
    trendLineThickness: number;
    pp: PenLineCap;
    po: DoubleCollection;
    trendLinePeriod: number;
    protected o7(): number;
    o6: number;
    private _indicatorColumn;
    indicatorColumn: List$1<number>;
    protected ox: AxisRange;
    protected abstract o0(a: number, b: number): boolean;
    protected abstract o3(a: number, b: number): IList$1<string>;
    protected ih(a: any, b: string, c: any, d: any): void;
    ee(a: Point, b: boolean, c: boolean): number;
    e4(a: Point, b: boolean): number;
    e2(a: Point, b: boolean): number;
    protected get_ds(): boolean;
    readonly ds: boolean;
    private o1(a, b, c);
    private pc(a, b, c);
    an(a: Axis): AxisRange;
    c6(a: any): boolean;
    dt(a: Rect, b: Rect, c: SeriesView): boolean;
    od(a: CategoryFrame, b: FinancialSeriesView): void;
    hf(a: boolean, b: SeriesView): void;
    protected ly(): CategoryTransitionInMode;
    of(a: CategoryFrame, b: FinancialSeriesView): void;
    protected i6(): void;
    protected pb(): void;
    protected ho(a: any): void;
    static $$p: string[];
    static $t: Type;
}
export declare class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
    constructor(a: FinancialSeriesView);
    protected f: FinancialIndicatorView;
    getBucket(a: number): number[];
    static $t: Type;
}
export declare class FinancialIndicatorView extends FinancialSeriesView {
    by: FinancialIndicator;
    constructor(a: FinancialIndicator);
    protected bt(): FinancialBucketCalculator;
    ap(): void;
    private readonly b1;
    private cb();
    private b4(a);
    cp: Path;
    cl: Path;
    cq: Path;
    cm: Path;
    cr: Path;
    cn: Path;
    co: Path;
    ck: Path;
    private bz;
    b0: ITrendLineManager;
    readonly b2: boolean;
    b3(a: boolean): void;
    b9(): void;
    b7(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: Clipper): void;
    b5(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number, f: Clipper): void;
    b6(a: number, b: (arg1: number) => number, c: (arg1: number) => number, d: boolean, e: number): void;
    ca(): void;
    private ch;
    private cj;
    private ci;
    private cg;
    private cd;
    private cf;
    private ce;
    private cc;
    protected a9(): void;
    protected a3(a: RenderingContext, b: boolean): void;
    protected a2(a: RenderingContext, b: boolean): void;
    ai(a: any): void;
    b8(): void;
    static $t: Type;
}
