import { ITrackThumbVisual } from "./ITrackThumbVisual";
import { ITrackRangeVisual } from "./ITrackRangeVisual";
import { ITrackBarVisual } from "./ITrackBarVisual";
import { ITrackShadeVisual } from "./ITrackShadeVisual";
import { ITrackThumbCalloutVisual } from "./ITrackThumbCalloutVisual";
import { Point, Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-angular-core/ES5/type";
import { FontInfo } from "igniteui-angular-core/ES5/FontInfo";
import { Rect } from "igniteui-angular-core/ES5/Rect";
import { TextBlock } from "igniteui-angular-core/ES5/TextBlock";
import { DoubleAnimator } from "igniteui-angular-core/ES5/DoubleAnimator";
import { Size } from "igniteui-angular-core/ES5/Size";
import { ITrackOwner } from "./ITrackOwner";
import { TrackThumb } from "./TrackThumb";
import { TrackThumbRange } from "./TrackThumbRange";
import { ZoomSliderVisualArea } from "./ZoomSliderVisualArea";
import { ZoomSliderOrientation } from "./ZoomSliderOrientation";
import { Brush } from "igniteui-angular-core/ES5/Brush";
import { ZoomSliderResolvingAxisValueEventArgs } from "./ZoomSliderResolvingAxisValueEventArgs";
import { RectChangedEventArgs } from "igniteui-angular-core/ES5/RectChangedEventArgs";
export declare class ZoomSliderView extends Base {
    constructor(a: ZoomSlider);
    private p;
    i: ITrackThumbVisual;
    h: ITrackThumbVisual;
    c: ITrackRangeVisual;
    b: ITrackBarVisual;
    e: ITrackShadeVisual;
    d: ITrackShadeVisual;
    g: ITrackThumbCalloutVisual;
    f: ITrackThumbCalloutVisual;
    j: ZoomSlider;
    ak(): void;
    ah(): void;
    private au();
    private ap();
    private ar(a);
    private aq(a);
    private at(a, b, c);
    private as(a, b, c);
    private u;
    private v;
    private o;
    private s;
    private q;
    private x;
    private w;
    private m;
    private a;
    aj(): void;
    private t;
    an(a: any): void;
    private ae(a, b);
    private af(a, b);
    private ag(a, b);
    private z();
    ao(): void;
    al(): void;
    ai(): void;
    n(): FontInfo;
    private l;
    private y;
    private r;
    av(a: TextBlock, b: string, c: FontInfo): void;
    private k;
    ab(): void;
    ad(): void;
    aa(): void;
    ac(): void;
    aw(a: TextBlock): Size;
    am(): void;
    static $t: Type;
}
export declare class ZoomSlider extends Base implements ITrackOwner, INotifyPropertyChanged {
    protected b: TrackThumb;
    protected a: TrackThumb;
    protected c: TrackThumbRange;
    protected g: ZoomSliderView;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private bq;
    br: number;
    private ay;
    bj: number;
    private a0;
    bl: number;
    private ah;
    a5: number;
    resolvingAxisValue: (sender: any, args: ZoomSliderResolvingAxisValueEventArgs) => void;
    dl(a: number, b: number, c: number, d: number): void;
    ee(): void;
    private fo;
    private x;
    fs: Rect;
    private ef();
    private ag;
    private dn(a, b);
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private i;
    private h;
    private fn;
    private fm;
    df(a: Point): void;
    private c7();
    private c6();
    dh(a: Point, b: number): void;
    af(a: Point): boolean;
    private ae(a, b);
    private dq(a);
    private dv(a, b);
    private ad(a);
    private y(a);
    dg(a: Point): void;
    private c8();
    private dk(a);
    private d4(a);
    private dt(a, b, c);
    private d9(a);
    private ft;
    private fu();
    private du(a, b, c);
    private n();
    private db(a);
    dd(a: Point): void;
    de(a: Point): void;
    j(a: Point): ZoomSliderVisualArea;
    private s(a);
    private v(a, b, c);
    private u(a, b);
    private t(a, b);
    private w(a, b, c);
    fr: Rect;
    fp: Rect;
    fq: Rect;
    private eb(a, b);
    private d2(a);
    private d7(a);
    private dx(a);
    private ed(a, b);
    private d0(a, b);
    private dz(a, b);
    private bs();
    private bt();
    private az;
    bk: number;
    private a2;
    bn: number;
    private am;
    a8: number;
    private a4;
    bp: number;
    private a3;
    bo: number;
    private ai;
    a6: number;
    private d;
    e: ZoomSliderOrientation;
    private ev;
    fg: Brush;
    private aw;
    bh: number;
    private aq;
    bc: number;
    private en;
    e8: Brush;
    private ew;
    fh: Brush;
    private eo;
    e9: Brush;
    private ex;
    fi: Brush;
    private ep;
    fa: Brush;
    private ax;
    bi: number;
    private ar;
    bd: number;
    private av;
    bg: number;
    private ap;
    bb: number;
    private et;
    fe: Brush;
    private eu;
    ff: Brush;
    destroy(): void;
    private au;
    bf: number;
    private el;
    e6: Brush;
    private em;
    e7: Brush;
    private ao;
    ba: number;
    private eg;
    e1: Brush;
    private eh;
    e2: Brush;
    private aj;
    a7: number;
    private ey;
    fj: Brush;
    private ez;
    fk: Brush;
    private a1;
    bm: number;
    private e0;
    fl: Brush;
    private eq;
    fb: Brush;
    private es;
    fd: Brush;
    private er;
    fc: Brush;
    private at;
    be: number;
    private ei;
    e3: Brush;
    private ek;
    e5: Brush;
    private ej;
    e4: Brush;
    private an;
    a9: number;
    readonly ac: boolean;
    readonly aa: boolean;
    readonly z: boolean;
    readonly ab: boolean;
    r: boolean;
    private m;
    o: FontInfo;
    protected dj(a: string, b: any, c: any): void;
    private dr(a, b, c);
    private dy();
    private d6();
    private d1();
    private ea();
    private ec();
    private d8();
    private d3();
    private d5();
    private dm();
    private dp();
    private dc();
    private di();
    provideContainer(a: any): void;
    notifySizeChanged(): void;
    readonly l: DoubleAnimator;
    private k;
    private al;
    private ak;
    private as;
    constructor();
    private dw(a);
    private c4();
    private c3(a, b);
    c9(): void;
    private q;
    trackDirty(): void;
    static $t: Type;
}
