import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { AverageTrueRangeIndicator } from "./AverageTrueRangeIndicator";
/**
 * Represents a IgxDataChartComponent Average True Range indicator series.
 * Default required members: High, Low, Close
*/
export var IgxAverageTrueRangeIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }];
var IgxAverageTrueRangeIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxAverageTrueRangeIndicatorComponent, _super);
    function IgxAverageTrueRangeIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxAverageTrueRangeIndicatorComponent.prototype.createImplementation = function () {
        return new AverageTrueRangeIndicator();
    };
    Object.defineProperty(IgxAverageTrueRangeIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAverageTrueRangeIndicatorComponent.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
         * The typical, and initial, value for AverageTrueRange periods is 14.
        */
        get: /**
             * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
             * The typical, and initial, value for AverageTrueRange periods is 14.
            */
        function () {
            return this.i.qc;
        },
        set: function (v) {
            this.i.qc = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxAverageTrueRangeIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-average-true-range-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxAverageTrueRangeIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxAverageTrueRangeIndicatorComponent.ctorParameters = function () { return []; };
    IgxAverageTrueRangeIndicatorComponent.propDecorators = {
        "period": [{ type: Input },],
    };
    return IgxAverageTrueRangeIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxAverageTrueRangeIndicatorComponent };
//# sourceMappingURL=igx-average-true-range-indicator-component.js.map