import { TemplateRef, EventEmitter, Output, Input } from '@angular/core';
import { HorizontalAlignment, HorizontalAlignment_$type } from "igniteui-angular-core/ES5/HorizontalAlignment";
import { UnknownValuePlotting, UnknownValuePlotting_$type } from "igniteui-angular-core/ES5/UnknownValuePlotting";
import { TrendLineType, TrendLineType_$type } from "igniteui-angular-core/ES5/TrendLineType";
import { ChartSeriesEventArgs } from './igx-chart-series-event-args';
import { brushToString, stringToBrush, toBrushCollection, fromBrushCollection, fromRect, toRect, ensureBool, ensureEnum } from "igniteui-angular-core/ES5/componentUtil";
import { delegateCombine } from "igniteui-angular-core/ES5/type";
import { DomainChartSeriesPointerEventArgs } from './igx-domain-chart-series-pointer-event-args';
import { MarkerTypeCollection as MarkerTypeCollection_internal } from './MarkerTypeCollection';
import { MarkerTypeCollection } from './igx-marker-type-collection';
export var IgxDomainChartComponent_PROVIDERS = [];
var IgxDomainChartComponent = /** @class */ (function () {
    function IgxDomainChartComponent() {
        this._markerTypes = null;
        this._seriesAdded = null;
        this._seriesRemoved = null;
        this._seriesPointerEnter = null;
        this._seriesPointerLeave = null;
        this._seriesPointerMove = null;
        this._seriesPointerDown = null;
        this._seriesPointerUp = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxDomainChartComponent.prototype.createImplementation = function () {
        return null;
    };
    IgxDomainChartComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxDomainChartComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxDomainChartComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxDomainChartComponent.prototype, "tooltipTemplate", {
        /**
        * Sets or gets the template reference to use for tooltips for all the series.
        *
        *
        */
        get: /**
            * Sets or gets the template reference to use for tooltips for all the series.
            *
            *
            */
        function () {
            return this.i.tooltipTemplate;
        },
        set: function (v) {
            this.i.tooltipTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "tooltipTemplates", {
        /**
        * Sets or gets the template references to use for tooltips for all the series, in order.
        *
        *
        */
        get: /**
            * Sets or gets the template references to use for tooltips for all the series, in order.
            *
            *
            */
        function () {
            var ret = [];
            if (this.i.tooltipTemplates) {
                for (var ii = 0; ii < this.i.tooltipTemplates.count; ii++) {
                    ret.push(this.i.tooltipTemplates.item(ii));
                }
            }
            return ret;
        },
        set: function (v) {
            this.i.tooltipTemplates.clear();
            if (v) {
                for (var ii = 0; ii < v.length; ii++) {
                    this.i.tooltipTemplates.add(v[ii]);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "legend", {
        get: function () {
            if (this.i.legend != null)
                return this.i.legend.externalObject;
        },
        set: function (v) {
            if (v != undefined && v != null)
                this.i.legend = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "pixelScalingRatio", {
        /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
        get: /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
        function () {
            return this.i.bx;
        },
        set: function (v) {
            this.i.bx = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "titleLeftMargin", {
        /**
         * Gets or sets the left margin of chart title
        */
        get: /**
             * Gets or sets the left margin of chart title
            */
        function () {
            return this.i.b6;
        },
        set: function (v) {
            this.i.b6 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "titleRightMargin", {
        /**
         * Gets or sets the right margin of chart title
        */
        get: /**
             * Gets or sets the right margin of chart title
            */
        function () {
            return this.i.b7;
        },
        set: function (v) {
            this.i.b7 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "titleTopMargin", {
        /**
         * Gets or sets the top margin of chart title
        */
        get: /**
             * Gets or sets the top margin of chart title
            */
        function () {
            return this.i.b8;
        },
        set: function (v) {
            this.i.b8 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "titleBottomMargin", {
        /**
         * Gets or sets the bottom margin of chart title
        */
        get: /**
             * Gets or sets the bottom margin of chart title
            */
        function () {
            return this.i.b5;
        },
        set: function (v) {
            this.i.b5 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleLeftMargin", {
        /**
         * Gets or sets the left margin of chart subtitle
        */
        get: /**
             * Gets or sets the left margin of chart subtitle
            */
        function () {
            return this.i.b1;
        },
        set: function (v) {
            this.i.b1 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleTopMargin", {
        /**
         * Gets or sets the top margin of chart subtitle
        */
        get: /**
             * Gets or sets the top margin of chart subtitle
            */
        function () {
            return this.i.b3;
        },
        set: function (v) {
            this.i.b3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleRightMargin", {
        /**
         * Gets or sets the right margin of chart subtitle
        */
        get: /**
             * Gets or sets the right margin of chart subtitle
            */
        function () {
            return this.i.b2;
        },
        set: function (v) {
            this.i.b2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleBottomMargin", {
        /**
         * Gets or sets the bottom margin of chart subtitle
        */
        get: /**
             * Gets or sets the bottom margin of chart subtitle
            */
        function () {
            return this.i.b0;
        },
        set: function (v) {
            this.i.b0 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleTextColor", {
        /**
         * Gets or sets color of chart subtitle
        */
        get: /**
             * Gets or sets color of chart subtitle
            */
        function () {
            return brushToString(this.i.ge);
        },
        set: function (v) {
            this.i.ge = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "titleTextColor", {
        /**
         * Gets or sets color of chart title
        */
        get: /**
             * Gets or sets color of chart title
            */
        function () {
            return brushToString(this.i.gf);
        },
        set: function (v) {
            this.i.gf = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "leftMargin", {
        /**
         * Gets or sets the left margin of the chart content.
        */
        get: /**
             * Gets or sets the left margin of the chart content.
            */
        function () {
            return this.i.bw;
        },
        set: function (v) {
            this.i.bw = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "topMargin", {
        /**
         * Gets or sets the top margin of the chart content.
        */
        get: /**
             * Gets or sets the top margin of the chart content.
            */
        function () {
            return this.i.b9;
        },
        set: function (v) {
            this.i.b9 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "rightMargin", {
        /**
         * Gets or sets the right margin of the chart content.
        */
        get: /**
             * Gets or sets the right margin of the chart content.
            */
        function () {
            return this.i.bz;
        },
        set: function (v) {
            this.i.bz = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "bottomMargin", {
        /**
         * Gets or sets the bottom margin around the chart content.
        */
        get: /**
             * Gets or sets the bottom margin around the chart content.
            */
        function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "transitionDuration", {
        /**
         * Gets or sets the duration used for animating series plots when the data is changing
        */
        get: /**
             * Gets or sets the duration used for animating series plots when the data is changing
            */
        function () {
            return this.i.ci;
        },
        set: function (v) {
            this.i.ci = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "transitionEasingFunction", {
        /**
         * Gets or sets the easing function used for animating series plots when the data is changing.
         * This can be set to one of the known values "linear" or "cubic," or it can be set to an easing function which takes a single numeric parameter and returns a number.
        */
        get: /**
             * Gets or sets the easing function used for animating series plots when the data is changing.
             * This can be set to one of the known values "linear" or "cubic," or it can be set to an easing function which takes a single numeric parameter and returns a number.
            */
        function () {
            return this.i.ao;
        },
        set: function (v) {
            this.i.ao = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleTextStyle", {
        /**
         * Gets or sets CSS font property for the chart subtitle
        */
        get: /**
             * Gets or sets CSS font property for the chart subtitle
            */
        function () {
            return this.i.dt;
        },
        set: function (v) {
            this.i.dt = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "titleTextStyle", {
        /**
         * Gets or sets CSS font property for the chart title
        */
        get: /**
             * Gets or sets CSS font property for the chart title
            */
        function () {
            return this.i.d4;
        },
        set: function (v) {
            this.i.d4 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "includedProperties", {
        /**
         * Gets or sets a set of property paths that should be included for consideration by the category chart, leaving the remainder excluded. If null, all properties will be considered.
        */
        get: /**
             * Gets or sets a set of property paths that should be included for consideration by the category chart, leaving the remainder excluded. If null, all properties will be considered.
            */
        function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "excludedProperties", {
        /**
         * Gets or sets a set of property paths that should be excluded from consideration by the category chart.
        */
        get: /**
             * Gets or sets a set of property paths that should be excluded from consideration by the category chart.
            */
        function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "brushes", {
        /**
         * Gets or sets the palette of brushes to use for coloring the chart series.
         * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
        */
        get: /**
             * Gets or sets the palette of brushes to use for coloring the chart series.
             * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
            */
        function () {
            return fromBrushCollection(this.i.j);
        },
        set: function (v) {
            this.i.j = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "outlines", {
        /**
         * Gets or sets the palette of brushes to use for outlines on the chart series.
         * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
        */
        get: /**
             * Gets or sets the palette of brushes to use for outlines on the chart series.
             * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
            */
        function () {
            return fromBrushCollection(this.i.n);
        },
        set: function (v) {
            this.i.n = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "isHorizontalZoomEnabled", {
        /**
         * Gets or sets whether the chart can be horizontally zoomed through user interactions.
        */
        get: /**
             * Gets or sets whether the chart can be horizontally zoomed through user interactions.
            */
        function () {
            return this.i.ay;
        },
        set: function (v) {
            this.i.ay = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "isVerticalZoomEnabled", {
        /**
         * Gets or sets whether the chart can be vertically zoomed through user interactions.
        */
        get: /**
             * Gets or sets whether the chart can be vertically zoomed through user interactions.
            */
        function () {
            return this.i.a3;
        },
        set: function (v) {
            this.i.a3 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "windowRect", {
        /**
         * Gets or sets the rectangle representing the current scroll and zoom state of the chart.
         * WindowRect is expressed as a Rectangle with coordinates and sizes between 0 and 1.
        */
        get: /**
             * Gets or sets the rectangle representing the current scroll and zoom state of the chart.
             * WindowRect is expressed as a Rectangle with coordinates and sizes between 0 and 1.
            */
        function () {
            return fromRect(this.i.gj);
        },
        set: function (v) {
            this.i.gj = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "viewport", {
        /**
         * Gets a rectangle representing the bounds of the plot area.
        */
        get: /**
             * Gets a rectangle representing the bounds of the plot area.
            */
        function () {
            return fromRect(this.i.gi);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "chartTitle", {
        /**
         * Gets or sets text to display above the plot area.
        */
        get: /**
             * Gets or sets text to display above the plot area.
            */
        function () {
            return this.i.dx;
        },
        set: function (v) {
            this.i.dx = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "subtitle", {
        /**
         * Gets or sets text to display below the Title, above the plot area.
        */
        get: /**
             * Gets or sets text to display below the Title, above the plot area.
            */
        function () {
            return this.i.dl;
        },
        set: function (v) {
            this.i.dl = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "titleAlignment", {
        /**
         * Gets or sets horizontal alignment which determines the title position, relative to the left and right edges of the control.
        */
        get: /**
             * Gets or sets horizontal alignment which determines the title position, relative to the left and right edges of the control.
            */
        function () {
            return this.i.f7;
        },
        set: function (v) {
            this.i.f7 = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "subtitleAlignment", {
        /**
         * Gets or sets horizontal alignment which determines the subtitle position, relative to the left and right edges of the control.
        */
        get: /**
             * Gets or sets horizontal alignment which determines the subtitle position, relative to the left and right edges of the control.
            */
        function () {
            return this.i.f6;
        },
        set: function (v) {
            this.i.f6 = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "unknownValuePlotting", {
        /**
         * Gets or sets the behavior that determines how unknown values will be plotted on the chart.
         * Null and Double.NaN are two examples of unknown values.
        */
        get: /**
             * Gets or sets the behavior that determines how unknown values will be plotted on the chart.
             * Null and Double.NaN are two examples of unknown values.
            */
        function () {
            return this.i.ak;
        },
        set: function (v) {
            this.i.ak = ensureEnum(UnknownValuePlotting_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "resolution", {
        /**
         * Gets or sets the rendering resolution for all series in this chart.
         * Where n = Resolution, for every n horizontal pixels, combine all items into a single datapoint.  When Resolution = 0, all datapoints will be rendered as graphical objects.  Charts with a higher resolution will have faster performance.
        */
        get: /**
             * Gets or sets the rendering resolution for all series in this chart.
             * Where n = Resolution, for every n horizontal pixels, combine all items into a single datapoint.  When Resolution = 0, all datapoints will be rendered as graphical objects.  Charts with a higher resolution will have faster performance.
            */
        function () {
            return this.i.by;
        },
        set: function (v) {
            this.i.by = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "thickness", {
        /**
         * Gets or sets the thickness for all series in this chart. Depending on the ChartType, this can be the main brush used, or just the outline.
        */
        get: /**
             * Gets or sets the thickness for all series in this chart. Depending on the ChartType, this can be the main brush used, or just the outline.
            */
        function () {
            return this.i.b4;
        },
        set: function (v) {
            this.i.b4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "markerTypes", {
        /**
         * Gets or sets the marker shapes used for indicating location of data points in this chart.
         * This property applies only to these chart types: point, line, spline, bubble, and polygon
        */
        get: /**
             * Gets or sets the marker shapes used for indicating location of data points in this chart.
             * This property applies only to these chart types: point, line, spline, bubble, and polygon
            */
        function () {
            if (this._markerTypes === null) {
                var coll = new MarkerTypeCollection();
                var innerColl = this.i.af;
                var wasNull = false;
                if (!innerColl) {
                    wasNull = true;
                    innerColl = new MarkerTypeCollection_internal();
                }
                this._markerTypes = coll._fromInner(innerColl);
                if (wasNull) {
                    this.i.af = innerColl;
                }
            }
            return this._markerTypes;
        },
        set: function (v) {
            var coll = new MarkerTypeCollection();
            this._markerTypes = coll._fromOuter(v);
            var innerColl = new MarkerTypeCollection_internal();
            var va = typeof v == 'string' ? coll._splitOuter(v) : v;
            innerColl._inner = va.map(function (item) { return coll._ensureOuter(item); });
            this.i.af = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "markerBrushes", {
        /**
         * Gets or sets the palette of brushes used for rendering fill area of data point markers.
         * This property applies only to these chart types: point, line, spline, bubble, and polygon
        */
        get: /**
             * Gets or sets the palette of brushes used for rendering fill area of data point markers.
             * This property applies only to these chart types: point, line, spline, bubble, and polygon
            */
        function () {
            return fromBrushCollection(this.i.l);
        },
        set: function (v) {
            this.i.l = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "markerOutlines", {
        /**
         * Gets or sets the palette of brushes used for rendering outlines of data point markers.
         * This property applies only to these chart types: point, line, spline, bubble, and polygon
        */
        get: /**
             * Gets or sets the palette of brushes used for rendering outlines of data point markers.
             * This property applies only to these chart types: point, line, spline, bubble, and polygon
            */
        function () {
            return fromBrushCollection(this.i.m);
        },
        set: function (v) {
            this.i.m = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "markerMaxCount", {
        /**
         * Gets or sets the maximum number of markers displyed in the plot area of the chart.
        */
        get: /**
             * Gets or sets the maximum number of markers displyed in the plot area of the chart.
            */
        function () {
            return this.i.ch;
        },
        set: function (v) {
            this.i.ch = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "animateSeriesWhenAxisRangeChanges", {
        /**
         * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
        */
        get: /**
             * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
            */
        function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "trendLineBrushes", {
        /**
         * Gets or sets the palette of brushes to used for coloring trend lines in this chart.
         * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
        */
        get: /**
             * Gets or sets the palette of brushes to used for coloring trend lines in this chart.
             * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
            */
        function () {
            return fromBrushCollection(this.i.o);
        },
        set: function (v) {
            this.i.o = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "trendLineType", {
        /**
         * Gets or sets the formula used for calculating trend lines in this chart.
         * This property applies only to these chart types: point, line, spline, and bubble
        */
        get: /**
             * Gets or sets the formula used for calculating trend lines in this chart.
             * This property applies only to these chart types: point, line, spline, and bubble
            */
        function () {
            return this.i.ai;
        },
        set: function (v) {
            this.i.ai = ensureEnum(TrendLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "trendLineThickness", {
        /**
         * Gets or sets the thickness of the trend lines in this chart.
         * This property applies only to these chart types: point, line, spline, and bubble
        */
        get: /**
             * Gets or sets the thickness of the trend lines in this chart.
             * This property applies only to these chart types: point, line, spline, and bubble
            */
        function () {
            return this.i.ca;
        },
        set: function (v) {
            this.i.ca = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "alignsGridLinesToPixels", {
        /**
         * Gets or sets a value indicating whether grid and tick lines are aligned to device pixels.
        */
        get: /**
             * Gets or sets a value indicating whether grid and tick lines are aligned to device pixels.
            */
        function () {
            return this.i.au;
        },
        set: function (v) {
            this.i.au = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "trendLinePeriod", {
        get: function () {
            return this.i.cj;
        },
        set: function (v) {
            this.i.cj = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Provides a container for this control

*/
    /**
         * Provides a container for this control
        
        */
    IgxDomainChartComponent.prototype.provideContainer = /**
         * Provides a container for this control
        
        */
    function (container) {
        this.i.provideContainer(container);
    };
    /**
     * Destroy this control
    
    */
    /**
         * Destroy this control
        
        */
    IgxDomainChartComponent.prototype.destroy = /**
         * Destroy this control
        
        */
    function () {
        this.i.destroy();
    };
    /**
     * Called when the control has been resized.
    
    */
    /**
         * Called when the control has been resized.
        
        */
    IgxDomainChartComponent.prototype.notifyResized = /**
         * Called when the control has been resized.
        
        */
    function () {
        this.i.notifyResized();
    };
    IgxDomainChartComponent.prototype.notifyVisualPropertiesChanged = function () {
        this.i.fd();
    };
    /**
     * Forces any pending refresh to the chart to be finished.
    
    */
    /**
         * Forces any pending refresh to the chart to be finished.
        
        */
    IgxDomainChartComponent.prototype.flush = /**
         * Forces any pending refresh to the chart to be finished.
        
        */
    function () {
        this.i.ep();
    };
    /**
     * Hides the active main tooltip, if displayed.
    
    */
    /**
         * Hides the active main tooltip, if displayed.
        
        */
    IgxDomainChartComponent.prototype.hideToolTip = /**
         * Hides the active main tooltip, if displayed.
        
        */
    function () {
        this.i.es();
    };
    IgxDomainChartComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.fc(source_, index, oldItem, newItem);
    };
    /**
     * Used to manually notify the chart that the data source has reset or cleared its items.
    
    */
    /**
         * Used to manually notify the chart that the data source has reset or cleared its items.
        
        */
    IgxDomainChartComponent.prototype.notifyClearItems = /**
         * Used to manually notify the chart that the data source has reset or cleared its items.
        
        */
    function (source_) {
        this.i.e8(source_);
    };
    IgxDomainChartComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.e9(source_, index, newItem);
    };
    IgxDomainChartComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.fa(source_, index, oldItem);
    };
    Object.defineProperty(IgxDomainChartComponent.prototype, "seriesAdded", {
        get: /**
             * Event raised when a series is initialized and added to this chart.
            */
        function () {
            var _this = this;
            if (this._seriesAdded == null) {
                this._seriesAdded = new EventEmitter();
                this.i.seriesAdded = delegateCombine(this.i.seriesAdded, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new ChartSeriesEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesAdded.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesAdded;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "seriesRemoved", {
        get: /**
             * Event raised when a series is removed from this chart.
            */
        function () {
            var _this = this;
            if (this._seriesRemoved == null) {
                this._seriesRemoved = new EventEmitter();
                this.i.seriesRemoved = delegateCombine(this.i.seriesRemoved, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new ChartSeriesEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesRemoved.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesRemoved;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerEnter", {
        get: /**
             * Occurs when the pointer enters a Series.
            */
        function () {
            var _this = this;
            if (this._seriesPointerEnter == null) {
                this._seriesPointerEnter = new EventEmitter();
                this.i.seriesPointerEnter = delegateCombine(this.i.seriesPointerEnter, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new DomainChartSeriesPointerEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesPointerEnter.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesPointerEnter;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerLeave", {
        get: /**
             * Occurs when the pointer leaves a Series.
            */
        function () {
            var _this = this;
            if (this._seriesPointerLeave == null) {
                this._seriesPointerLeave = new EventEmitter();
                this.i.seriesPointerLeave = delegateCombine(this.i.seriesPointerLeave, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new DomainChartSeriesPointerEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesPointerLeave.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesPointerLeave;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerMove", {
        get: /**
             * Occurs when the pointer moves over a Series.
            */
        function () {
            var _this = this;
            if (this._seriesPointerMove == null) {
                this._seriesPointerMove = new EventEmitter();
                this.i.seriesPointerMove = delegateCombine(this.i.seriesPointerMove, function (o, e) {
                    var outerArgs = new DomainChartSeriesPointerEventArgs();
                    outerArgs._provideImplementation(e);
                    _this._seriesPointerMove.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._seriesPointerMove;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerDown", {
        get: /**
             * Occurs when the pointer is pressed down over a Series.
            */
        function () {
            var _this = this;
            if (this._seriesPointerDown == null) {
                this._seriesPointerDown = new EventEmitter();
                this.i.seriesPointerDown = delegateCombine(this.i.seriesPointerDown, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new DomainChartSeriesPointerEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesPointerDown.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesPointerDown;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxDomainChartComponent.prototype, "seriesPointerUp", {
        get: /**
             * Occurs when the pointer is released over a Series.
            */
        function () {
            var _this = this;
            if (this._seriesPointerUp == null) {
                this._seriesPointerUp = new EventEmitter();
                this.i.seriesPointerUp = delegateCombine(this.i.seriesPointerUp, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new DomainChartSeriesPointerEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesPointerUp.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesPointerUp;
        },
        enumerable: true,
        configurable: true
    });
    IgxDomainChartComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxDomainChartComponent.propDecorators = {
        "tooltipTemplate": [{ type: Input },],
        "tooltipTemplates": [{ type: Input },],
        "legend": [{ type: Input },],
        "pixelScalingRatio": [{ type: Input },],
        "titleLeftMargin": [{ type: Input },],
        "titleRightMargin": [{ type: Input },],
        "titleTopMargin": [{ type: Input },],
        "titleBottomMargin": [{ type: Input },],
        "subtitleLeftMargin": [{ type: Input },],
        "subtitleTopMargin": [{ type: Input },],
        "subtitleRightMargin": [{ type: Input },],
        "subtitleBottomMargin": [{ type: Input },],
        "subtitleTextColor": [{ type: Input },],
        "titleTextColor": [{ type: Input },],
        "leftMargin": [{ type: Input },],
        "topMargin": [{ type: Input },],
        "rightMargin": [{ type: Input },],
        "bottomMargin": [{ type: Input },],
        "transitionDuration": [{ type: Input },],
        "transitionEasingFunction": [{ type: Input },],
        "subtitleTextStyle": [{ type: Input },],
        "titleTextStyle": [{ type: Input },],
        "includedProperties": [{ type: Input },],
        "excludedProperties": [{ type: Input },],
        "brushes": [{ type: Input },],
        "outlines": [{ type: Input },],
        "isHorizontalZoomEnabled": [{ type: Input },],
        "isVerticalZoomEnabled": [{ type: Input },],
        "windowRect": [{ type: Input },],
        "chartTitle": [{ type: Input },],
        "subtitle": [{ type: Input },],
        "titleAlignment": [{ type: Input },],
        "subtitleAlignment": [{ type: Input },],
        "unknownValuePlotting": [{ type: Input },],
        "resolution": [{ type: Input },],
        "thickness": [{ type: Input },],
        "markerTypes": [{ type: Input },],
        "markerBrushes": [{ type: Input },],
        "markerOutlines": [{ type: Input },],
        "markerMaxCount": [{ type: Input },],
        "animateSeriesWhenAxisRangeChanges": [{ type: Input },],
        "trendLineBrushes": [{ type: Input },],
        "trendLineType": [{ type: Input },],
        "trendLineThickness": [{ type: Input },],
        "alignsGridLinesToPixels": [{ type: Input },],
        "trendLinePeriod": [{ type: Input },],
        "seriesAdded": [{ type: Output },],
        "seriesRemoved": [{ type: Output },],
        "seriesPointerEnter": [{ type: Output },],
        "seriesPointerLeave": [{ type: Output },],
        "seriesPointerMove": [{ type: Output },],
        "seriesPointerDown": [{ type: Output },],
        "seriesPointerUp": [{ type: Output },],
    };
    return IgxDomainChartComponent;
}());
export { IgxDomainChartComponent };
//# sourceMappingURL=igx-domain-chart-component.js.map