import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { FullStochasticOscillatorIndicator } from "./FullStochasticOscillatorIndicator";
/**
 * Represents a IgxDataChartComponent Full Stochastic Oscillator indicator series.
 * Default required members: High, Low, Close
*/
export var IgxFullStochasticOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }];
var IgxFullStochasticOscillatorIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxFullStochasticOscillatorIndicatorComponent, _super);
    function IgxFullStochasticOscillatorIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxFullStochasticOscillatorIndicatorComponent.prototype.createImplementation = function () {
        return new FullStochasticOscillatorIndicator();
    };
    Object.defineProperty(IgxFullStochasticOscillatorIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFullStochasticOscillatorIndicatorComponent.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current FullStochasticOscillatorIndicator object.
         * The typical, and initial, value for FullStochasticOscillatorIndicator periods is 14.
        */
        get: /**
             * Gets or sets the moving average period for the current FullStochasticOscillatorIndicator object.
             * The typical, and initial, value for FullStochasticOscillatorIndicator periods is 14.
            */
        function () {
            return this.i.qc;
        },
        set: function (v) {
            this.i.qc = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFullStochasticOscillatorIndicatorComponent.prototype, "smoothingPeriod", {
        /**
         * Gets or sets the moving average SmoothingPeriod for the current FullStochasticOscillatorIndicator object.
         * The typical, and initial, value for FullStochasticOscillatorIndicator SmoothingPeriod is 3.
        */
        get: /**
             * Gets or sets the moving average SmoothingPeriod for the current FullStochasticOscillatorIndicator object.
             * The typical, and initial, value for FullStochasticOscillatorIndicator SmoothingPeriod is 3.
            */
        function () {
            return this.i.smoothingPeriod;
        },
        set: function (v) {
            this.i.smoothingPeriod = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxFullStochasticOscillatorIndicatorComponent.prototype, "triggerPeriod", {
        /**
         * Gets or sets the moving average TriggerPeriod for the current FullStochasticOscillatorIndicator object.
         * The typical, and initial, value for FullStochasticOscillatorIndicator TriggerPeriod is 3.
        */
        get: /**
             * Gets or sets the moving average TriggerPeriod for the current FullStochasticOscillatorIndicator object.
             * The typical, and initial, value for FullStochasticOscillatorIndicator TriggerPeriod is 3.
            */
        function () {
            return this.i.qe;
        },
        set: function (v) {
            this.i.qe = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxFullStochasticOscillatorIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-full-stochastic-oscillator-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxFullStochasticOscillatorIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxFullStochasticOscillatorIndicatorComponent.ctorParameters = function () { return []; };
    IgxFullStochasticOscillatorIndicatorComponent.propDecorators = {
        "period": [{ type: Input },],
        "smoothingPeriod": [{ type: Input },],
        "triggerPeriod": [{ type: Input },],
    };
    return IgxFullStochasticOscillatorIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxFullStochasticOscillatorIndicatorComponent };
//# sourceMappingURL=igx-full-stochastic-oscillator-indicator-component.js.map