/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { IgxCategoryAxisBaseComponent } from './igx-category-axis-base-component';
import { IgxNumericYAxisComponent } from './igx-numeric-y-axis-component';
import { IgxAnchoredCategorySeriesComponent } from './igx-anchored-category-series-component';
import { IgxCategorySeriesComponent } from './igx-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { toPoint, fromPoint, fromRect } from "igniteui-angular-core/ES5/componentUtil";
export var IgxHorizontalAnchoredCategorySeriesComponent_PROVIDERS = [{ provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(function () { return IgxHorizontalAnchoredCategorySeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxHorizontalAnchoredCategorySeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxHorizontalAnchoredCategorySeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxHorizontalAnchoredCategorySeriesComponent; }) }];
/**
 * Base class for anchored category series with a category x-axis and a numeric y-axis.
*/
var IgxHorizontalAnchoredCategorySeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxHorizontalAnchoredCategorySeriesComponent, _super);
    function IgxHorizontalAnchoredCategorySeriesComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxHorizontalAnchoredCategorySeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHorizontalAnchoredCategorySeriesComponent.prototype, "xAxis", {
        /**
     * Gets or sets the effective x-axis for this series.
    */
        get: /**
             * Gets or sets the effective x-axis for this series.
            */
        function () {
            if (this.i.xAxis == null) {
                return null;
            }
            return this.i.xAxis.externalObject;
        },
        set: function (v) {
            v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHorizontalAnchoredCategorySeriesComponent.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for this series.
        */
        get: /**
             * Gets or sets the effective y-axis for this series.
            */
        function () {
            if (this.i.yAxis == null) {
                return null;
            }
            if (!this.i.yAxis.externalObject) {
                var e = new IgxNumericYAxisComponent();
                e._implementation = this.i.yAxis;
                this.i.yAxis.externalObject = e;
            }
            return this.i.yAxis.externalObject;
        },
        set: function (v) {
            v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.

* @param world  * The world coordinates for which to get a value marker bounding box for
*/
    /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
    IgxHorizontalAnchoredCategorySeriesComponent.prototype.getSeriesValueMarkerBoundingBox = /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
    function (world) {
        var iv = this.i.ld(toPoint(world));
        return fromRect(iv);
    };
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    /**
         * Returns the offset value for this series if grouped on a category axis.
        
        */
    IgxHorizontalAnchoredCategorySeriesComponent.prototype.getOffsetValue = /**
         * Returns the offset value for this series if grouped on a category axis.
        
        */
    function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    /**
         * Returns the width of the category grouping this series is in.
        
        */
    IgxHorizontalAnchoredCategorySeriesComponent.prototype.getCategoryWidth = /**
         * Returns the width of the category grouping this series is in.
        
        */
    function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    IgxHorizontalAnchoredCategorySeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ee(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxHorizontalAnchoredCategorySeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.e4(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgxHorizontalAnchoredCategorySeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.e2(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgxHorizontalAnchoredCategorySeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.k2(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        */
    IgxHorizontalAnchoredCategorySeriesComponent.prototype.canUseAsXAxis = /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        */
    function (axis) {
        var iv = this.i.pn(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        */
    IgxHorizontalAnchoredCategorySeriesComponent.prototype.canUseAsYAxis = /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        */
    function (axis) {
        var iv = this.i.po(axis);
        return (iv);
    };
    IgxHorizontalAnchoredCategorySeriesComponent.propDecorators = {
        "xAxis": [{ type: Input },],
        "yAxis": [{ type: Input },],
    };
    return IgxHorizontalAnchoredCategorySeriesComponent;
}(IgxAnchoredCategorySeriesComponent));
export { IgxHorizontalAnchoredCategorySeriesComponent };
//# sourceMappingURL=igx-horizontal-anchored-category-series-component.js.map