import * as tslib_1 from "tslib";
import { forwardRef } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
/**
 * Financial indicator base class for doing calculating an itemwize indicator.
 * An itemwise indicator's individual values don't depend on any other values in the
 * collection so can always be independently recalculated. Also, because of this, the
 * base class handles all the looping logic and inheritors only need to provide the
 * actual calculation.
*/
export var IgxItemwiseStrategyBasedIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxItemwiseStrategyBasedIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxItemwiseStrategyBasedIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxItemwiseStrategyBasedIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxItemwiseStrategyBasedIndicatorComponent; }) }];
var IgxItemwiseStrategyBasedIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxItemwiseStrategyBasedIndicatorComponent, _super);
    function IgxItemwiseStrategyBasedIndicatorComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxItemwiseStrategyBasedIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgxItemwiseStrategyBasedIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxItemwiseStrategyBasedIndicatorComponent };
//# sourceMappingURL=igx-itemwise-strategy-based-indicator-component.js.map