import { EventEmitter, Output, Input } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core/ES5/type";
import { LabelsPosition, LabelsPosition_$type } from "./LabelsPosition";
import { Visibility, Visibility_$type } from "igniteui-angular-core/ES5/Visibility";
import { LeaderLineType, LeaderLineType_$type } from "./LeaderLineType";
import { OthersCategoryType, OthersCategoryType_$type } from "./OthersCategoryType";
import { IndexCollection } from "./igx-index-collection";
import { SweepDirection, SweepDirection_$type } from "igniteui-angular-core/ES5/SweepDirection";
import { SliceSelectionMode, SliceSelectionMode_$type } from "./SliceSelectionMode";
import { LabelClickEventArgs } from "./igx-label-click-event-args";
import { SelectedItemChangingEventArgs } from "./igx-selected-item-changing-event-args";
import { SelectedItemsChangingEventArgs } from "./igx-selected-items-changing-event-args";
import { SelectedItemChangedEventArgs } from "./igx-selected-item-changed-event-args";
import { SelectedItemsChangedEventArgs } from "./igx-selected-items-changed-event-args";
import { SliceClickEventArgs } from "./igx-slice-click-event-args";
import { ensureEnum, brushToString, stringToBrush, ensureBool, toBrushCollection, fromBrushCollection, toPoint } from "igniteui-angular-core/ES5/componentUtil";
import { IndexCollection as IndexCollection_internal } from "./IndexCollection";
/**
 * Represents the base class for the pie chart.
*/
export var IgxPieChartBaseComponent_PROVIDERS = [];
var IgxPieChartBaseComponent = /** @class */ (function () {
    function IgxPieChartBaseComponent() {
        this._explodedSlices = null;
        this._labelClick = null;
        this._selectedItemChanging = null;
        this._selectedItemsChanging = null;
        this._selectedItemChanged = null;
        this._selectedItemsChanged = null;
        this._sliceClick = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxPieChartBaseComponent.prototype.createImplementation = function () {
        return null;
    };
    IgxPieChartBaseComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxPieChartBaseComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "innerExtent", {
        /**
         * Gets or sets the amount of space between the center and the start of the arc. This property should be set between 0 and 1.
         * If InnerExtent is set to a value greater than 1, it will be interpreted as a percentage, effectively divided by 100.
        */
        get: /**
             * Gets or sets the amount of space between the center and the start of the arc. This property should be set between 0 and 1.
             * If InnerExtent is set to a value greater than 1, it will be interpreted as a percentage, effectively divided by 100.
            */
        function () {
            return this.i.cl;
        },
        set: function (v) {
            this.i.cl = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "valueMemberPath", {
        /**
         * Gets or Sets the property name that contains the values.
        */
        get: /**
             * Gets or Sets the property name that contains the values.
            */
        function () {
            return this.i.eg;
        },
        set: function (v) {
            this.i.eg = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelMemberPath", {
        /**
         * Gets or sets the property name that contains the labels.
        */
        get: /**
             * Gets or sets the property name that contains the labels.
            */
        function () {
            return this.i.di;
        },
        set: function (v) {
            this.i.di = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendLabelMemberPath", {
        /**
         * Gets or sets the property name that contains the legend labels.
        */
        get: /**
             * Gets or sets the property name that contains the legend labels.
            */
        function () {
            return this.i.dv;
        },
        set: function (v) {
            this.i.dv = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelsPosition", {
        /**
         * Gets or sets the position of chart labels.
        */
        get: /**
             * Gets or sets the position of chart labels.
            */
        function () {
            return this.i.ao;
        },
        set: function (v) {
            this.i.ao = ensureEnum(LabelsPosition_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelOuterColor", {
        /**
         * Gets or sets the color for labels rendered outside of the pie chart.
        */
        get: /**
             * Gets or sets the color for labels rendered outside of the pie chart.
            */
        function () {
            return brushToString(this.i.gw);
        },
        set: function (v) {
            this.i.gw = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelInnerColor", {
        /**
         * Gets or sets the color for labels rendered inside of the pie chart.
        */
        get: /**
             * Gets or sets the color for labels rendered inside of the pie chart.
            */
        function () {
            return brushToString(this.i.gv);
        },
        set: function (v) {
            this.i.gv = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "leaderLineVisibility", {
        /**
         * Gets or sets whether the leader lines are visible.
        */
        get: /**
             * Gets or sets whether the leader lines are visible.
            */
        function () {
            return this.i.g8;
        },
        set: function (v) {
            this.i.g8 = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "leaderLineType", {
        /**
         * Gets or sets what type of leader lines will be used for the outside end labels.
        */
        get: /**
             * Gets or sets what type of leader lines will be used for the outside end labels.
            */
        function () {
            return this.i.ap;
        },
        set: function (v) {
            this.i.ap = ensureEnum(LeaderLineType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "leaderLineMargin", {
        /**
         * Gets or sets the margin between a label and the end of its leader line. The default is 6 pixels.
        */
        get: /**
             * Gets or sets the margin between a label and the end of its leader line. The default is 6 pixels.
            */
        function () {
            return this.i.cn;
        },
        set: function (v) {
            this.i.cn = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "toolTip", {
        /**
         * Gets or sets the ToolTip for the chart.
        */
        get: /**
             * Gets or sets the ToolTip for the chart.
            */
        function () {
            return this.i.c0;
        },
        set: function (v) {
            this.i.c0 = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryThreshold", {
        /**
         * Gets or sets the threshold value that determines if slices are grouped into the Others slice.
        */
        get: /**
             * Gets or sets the threshold value that determines if slices are grouped into the Others slice.
            */
        function () {
            return this.i.co;
        },
        set: function (v) {
            this.i.co = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryType", {
        /**
         * Gets or sets whether to use numeric or percent-based threshold value.
        */
        get: /**
             * Gets or sets whether to use numeric or percent-based threshold value.
            */
        function () {
            return this.i.aq;
        },
        set: function (v) {
            this.i.aq = ensureEnum(OthersCategoryType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "othersCategoryText", {
        /**
         * Gets or sets the label of the Others slice.
        */
        get: /**
             * Gets or sets the label of the Others slice.
            */
        function () {
            return this.i.dz;
        },
        set: function (v) {
            this.i.dz = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "explodedRadius", {
        /**
         * Determines how much the exploded slice is offset from the center. Value between 0 and 1.
        */
        get: /**
             * Determines how much the exploded slice is offset from the center. Value between 0 and 1.
            */
        function () {
            return this.i.cg;
        },
        set: function (v) {
            this.i.cg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "radiusFactor", {
        /**
         * Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
        */
        get: /**
             * Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
            */
        function () {
            return this.i.cr;
        },
        set: function (v) {
            this.i.cr = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "allowSliceSelection", {
        /**
         * Gets or sets whether the slices can be selected.
        */
        get: /**
             * Gets or sets whether the slices can be selected.
            */
        function () {
            return this.i.bq;
        },
        set: function (v) {
            this.i.bq = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "allowSliceExplosion", {
        /**
         * Gets or sets whether the slices can be exploded.
        */
        get: /**
             * Gets or sets whether the slices can be exploded.
            */
        function () {
            return this.i.bp;
        },
        set: function (v) {
            this.i.bp = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "explodedSlices", {
        /**
         * Gets or sets the collection of exploded slice indices.
        */
        get: /**
             * Gets or sets the collection of exploded slice indices.
            */
        function () {
            if (this._explodedSlices === null) {
                var coll = new IndexCollection();
                var innerColl = this.i.al;
                var wasNull = false;
                if (!innerColl) {
                    wasNull = true;
                    innerColl = new IndexCollection_internal();
                }
                this._explodedSlices = coll._fromInner(innerColl);
                if (wasNull) {
                    this.i.al = innerColl;
                }
            }
            return this._explodedSlices;
        },
        set: function (v) {
            var coll = new IndexCollection();
            this._explodedSlices = coll._fromOuter(v);
            var innerColl = new IndexCollection_internal();
            var va = typeof v == 'string' ? coll._splitOuter(v) : v;
            innerColl._inner = va.map(function (item) { return coll._ensureOuter(item); });
            this.i.al = innerColl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "legend", {
        /**
         * Gets or sets the legend used for the current chart.
        */
        get: /**
             * Gets or sets the legend used for the current chart.
            */
        function () {
            return this.i.ai;
        },
        set: function (v) {
            this.i.ai = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelExtent", {
        /**
         * Gets or sets the pixel amount by which the labels are offset from the edge of the slices.
        */
        get: /**
             * Gets or sets the pixel amount by which the labels are offset from the edge of the slices.
            */
        function () {
            return this.i.cm;
        },
        set: function (v) {
            this.i.cm = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "startAngle", {
        /**
         * Gets or sets the starting angle of the chart.
         * The default zero value is equivalent to 3 o'clock.
        */
        get: /**
             * Gets or sets the starting angle of the chart.
             * The default zero value is equivalent to 3 o'clock.
            */
        function () {
            return this.i.ct;
        },
        set: function (v) {
            this.i.ct = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "sweepDirection", {
        /**
         * Gets or sets the rotational direction of the chart.
        */
        get: /**
             * Gets or sets the rotational direction of the chart.
            */
        function () {
            return this.i.gx;
        },
        set: function (v) {
            this.i.gx = ensureEnum(SweepDirection_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "brushes", {
        /**
         * Gets or sets the palette of brushes to use for coloring the slices.
        */
        get: /**
             * Gets or sets the palette of brushes to use for coloring the slices.
            */
        function () {
            return fromBrushCollection(this.i.ag);
        },
        set: function (v) {
            this.i.ag = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "outlines", {
        /**
         * Gets or sets the palette of brushes to use for outlines on the slices.
        */
        get: /**
             * Gets or sets the palette of brushes to use for outlines on the slices.
            */
        function () {
            return fromBrushCollection(this.i.ah);
        },
        set: function (v) {
            this.i.ah = toBrushCollection(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendItemTemplate", {
        /**
         * Gets or sets the LegendItemTemplate property.
         * The legend item control content is created according to the LegendItemTemplate on-demand by
         * the chart object itself.
        */
        get: /**
             * Gets or sets the LegendItemTemplate property.
             * The legend item control content is created according to the LegendItemTemplate on-demand by
             * the chart object itself.
            */
        function () {
            return this.i.legendItemTemplate;
        },
        set: function (v) {
            this.i.legendItemTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "legendItemBadgeTemplate", {
        /**
         * Gets or sets the LegendItemBadgeTemplate property.
         * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
         * the chart object itself.
        */
        get: /**
             * Gets or sets the LegendItemBadgeTemplate property.
             * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
             * the chart object itself.
            */
        function () {
            return this.i.legendItemBadgeTemplate;
        },
        set: function (v) {
            this.i.legendItemBadgeTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "isSurfaceInteractionDisabled", {
        /**
         * Gets or sets whether all surface interactions with the plot area should be disabled.
        */
        get: /**
             * Gets or sets whether all surface interactions with the plot area should be disabled.
            */
        function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "formatLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
        */
        get: /**
             * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
            */
        function () {
            return this.i.at;
        },
        set: function (v) {
            this.i.at = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "formatLegendLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart's legend.
        */
        get: /**
             * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart's legend.
            */
        function () {
            return this.i.au;
        },
        set: function (v) {
            this.i.au = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
        function () {
            return this.i.cq;
        },
        set: function (v) {
            this.i.cq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "actualPixelScalingRatio", {
        /**
         * Resolved pixel scaling ratio. Unless explicitly overridden by the PieChartBase.PixelScalingRatio property,
         * this one returns the default ratio enforced by device. High resolution devices will initialize this property
         * to a higher value.
        */
        get: /**
             * Resolved pixel scaling ratio. Unless explicitly overridden by the PieChartBase.PixelScalingRatio property,
             * this one returns the default ratio enforced by device. High resolution devices will initialize this property
             * to a higher value.
            */
        function () {
            return this.i.cd;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectionMode", {
        /**
         * Gets or sets which mode to use for selecting slices.
        */
        get: /**
             * Gets or sets which mode to use for selecting slices.
            */
        function () {
            return this.i.a3;
        },
        set: function (v) {
            this.i.a3 = ensureEnum(SliceSelectionMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItem", {
        /**
         * Gets or sets the currently selected data item.  If a different data item is provided the pie chart
         * will select the slice associated with the new item.
        */
        get: /**
             * Gets or sets the currently selected data item.  If a different data item is provided the pie chart
             * will select the slice associated with the new item.
            */
        function () {
            return this.i.selectedItem;
        },
        set: function (v) {
            this.i.selectedItem = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "textStyle", {
        /**
         * Manually overrides the style to use for the labels.
        */
        get: /**
             * Manually overrides the style to use for the labels.
            */
        function () {
            return this.i.eb;
        },
        set: function (v) {
            this.i.eb = v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Returns the chart visuals expressed as a serialized string.
    
    */
    /**
         * Returns the chart visuals expressed as a serialized string.
        
        */
    IgxPieChartBaseComponent.prototype.exportSerializedVisualData = /**
         * Returns the chart visuals expressed as a serialized string.
        
        */
    function () {
        var iv = this.i.c8();
        return (iv);
    };
    /**
     * Simulates a mouse click action at the specified point.
    
    * @param point  * The point to click at.
    */
    /**
         * Simulates a mouse click action at the specified point.
        
        * @param point  * The point to click at.
        */
    IgxPieChartBaseComponent.prototype.simulateLeftClick = /**
         * Simulates a mouse click action at the specified point.
        
        * @param point  * The point to click at.
        */
    function (point) {
        this.i.fl(toPoint(point));
    };
    /**
     * Invoked by the containing object to provide reference to the container.
    
    * @param container  * Reference to the container.
    */
    /**
         * Invoked by the containing object to provide reference to the container.
        
        * @param container  * Reference to the container.
        */
    IgxPieChartBaseComponent.prototype.provideContainer = /**
         * Invoked by the containing object to provide reference to the container.
        
        * @param container  * Reference to the container.
        */
    function (container) {
        this.i.provideContainer(container);
    };
    /**
     * Notification from the containing object that the container has been resized.
    
    */
    /**
         * Notification from the containing object that the container has been resized.
        
        */
    IgxPieChartBaseComponent.prototype.notifyContainerResized = /**
         * Notification from the containing object that the container has been resized.
        
        */
    function () {
        this.i.notifyContainerResized();
    };
    /**
     * Invoked when the instance is being destroyed.
    
    */
    /**
         * Invoked when the instance is being destroyed.
        
        */
    IgxPieChartBaseComponent.prototype.destroy = /**
         * Invoked when the instance is being destroyed.
        
        */
    function () {
        this.i.destroy();
    };
    /**
     * Use to force the pie chart to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the pie chart needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the pie chart.
    
    */
    /**
         * Use to force the pie chart to finish any deferred work before printing or evaluating its visual.
         * This should only be called if the visual of the pie chart needs to be synchronously saved or evaluated.
         * Calling this method too often will hinder the performance of the pie chart.
        
        */
    IgxPieChartBaseComponent.prototype.flush = /**
         * Use to force the pie chart to finish any deferred work before printing or evaluating its visual.
         * This should only be called if the visual of the pie chart needs to be synchronously saved or evaluated.
         * Calling this method too often will hinder the performance of the pie chart.
        
        */
    function () {
        this.i.el();
    };
    IgxPieChartBaseComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.eu(source_, index, oldItem, newItem);
    };
    /**
     * Manually notifies the pie chart's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the pie chart is bound to is already observable.
    
    * @param source_  * The data source.
    */
    /**
         * Manually notifies the pie chart's data source that the data it has bound to has been cleared and needs to be re-examined.
         * This should not be called if the data that the pie chart is bound to is already observable.
        
        * @param source_  * The data source.
        */
    IgxPieChartBaseComponent.prototype.notifyClearItems = /**
         * Manually notifies the pie chart's data source that the data it has bound to has been cleared and needs to be re-examined.
         * This should not be called if the data that the pie chart is bound to is already observable.
        
        * @param source_  * The data source.
        */
    function (source_) {
        this.i.eq(source_);
    };
    IgxPieChartBaseComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.es(source_, index, newItem);
    };
    IgxPieChartBaseComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.et(source_, index, oldItem);
    };
    /**
     * Assigns data source for the items.
    
    * @param source_  * Array of the data source items.
    */
    /**
         * Assigns data source for the items.
        
        * @param source_  * Array of the data source items.
        */
    IgxPieChartBaseComponent.prototype.setWidgetLevelDataSource = /**
         * Assigns data source for the items.
        
        * @param source_  * Array of the data source items.
        */
    function (source_) {
        this.i.fk(source_);
    };
    /**
     * Resets items data source.
    
    */
    /**
         * Resets items data source.
        
        */
    IgxPieChartBaseComponent.prototype.removeWidgetLevelDataSource = /**
         * Resets items data source.
        
        */
    function () {
        this.i.fb();
    };
    /**
     * Invoked when style is updated.
    
    */
    /**
         * Invoked when style is updated.
        
        */
    IgxPieChartBaseComponent.prototype.styleUpdated = /**
         * Invoked when style is updated.
        
        */
    function () {
        this.i.fp();
    };
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "labelClick", {
        get: /**
             * Raised when the slice's label is clicked.
            */
        function () {
            var _this = this;
            if (this._labelClick == null) {
                this._labelClick = new EventEmitter();
                this.i.labelClick = delegateCombine(this.i.labelClick, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new LabelClickEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._labelClick.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._labelClick;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItemChanging", {
        get: /**
             * Raised when the SelectedItem property is changing.  This event is cancelable.
            */
        function () {
            var _this = this;
            if (this._selectedItemChanging == null) {
                this._selectedItemChanging = new EventEmitter();
                this.i.selectedItemChanging = delegateCombine(this.i.selectedItemChanging, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new SelectedItemChangingEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._selectedItemChanging.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._selectedItemChanging;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItemsChanging", {
        get: /**
             * Raised when the SelectedItems collection is changing.  This event is cancelable.
            */
        function () {
            var _this = this;
            if (this._selectedItemsChanging == null) {
                this._selectedItemsChanging = new EventEmitter();
                this.i.selectedItemsChanging = delegateCombine(this.i.selectedItemsChanging, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new SelectedItemsChangingEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._selectedItemsChanging.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._selectedItemsChanging;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItemChanged", {
        get: /**
             * Raised when the SelectedItem property has changed.
            */
        function () {
            var _this = this;
            if (this._selectedItemChanged == null) {
                this._selectedItemChanged = new EventEmitter();
                this.i.selectedItemChanged = delegateCombine(this.i.selectedItemChanged, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new SelectedItemChangedEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._selectedItemChanged.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._selectedItemChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "selectedItemsChanged", {
        get: /**
             * Raised when the SelectedItems collection has changed.
            */
        function () {
            var _this = this;
            if (this._selectedItemsChanged == null) {
                this._selectedItemsChanged = new EventEmitter();
                this.i.selectedItemsChanged = delegateCombine(this.i.selectedItemsChanged, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new SelectedItemsChangedEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._selectedItemsChanged.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._selectedItemsChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxPieChartBaseComponent.prototype, "sliceClick", {
        get: /**
             * Raised when the slice is clicked.
            */
        function () {
            var _this = this;
            if (this._sliceClick == null) {
                this._sliceClick = new EventEmitter();
                this.i.sliceClick = delegateCombine(this.i.sliceClick, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new SliceClickEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._sliceClick.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._sliceClick;
        },
        enumerable: true,
        configurable: true
    });
    IgxPieChartBaseComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxPieChartBaseComponent.propDecorators = {
        "innerExtent": [{ type: Input },],
        "valueMemberPath": [{ type: Input },],
        "labelMemberPath": [{ type: Input },],
        "legendLabelMemberPath": [{ type: Input },],
        "labelsPosition": [{ type: Input },],
        "labelOuterColor": [{ type: Input },],
        "labelInnerColor": [{ type: Input },],
        "leaderLineVisibility": [{ type: Input },],
        "leaderLineType": [{ type: Input },],
        "leaderLineMargin": [{ type: Input },],
        "toolTip": [{ type: Input },],
        "othersCategoryThreshold": [{ type: Input },],
        "othersCategoryType": [{ type: Input },],
        "othersCategoryText": [{ type: Input },],
        "explodedRadius": [{ type: Input },],
        "radiusFactor": [{ type: Input },],
        "allowSliceSelection": [{ type: Input },],
        "allowSliceExplosion": [{ type: Input },],
        "explodedSlices": [{ type: Input },],
        "legend": [{ type: Input },],
        "labelExtent": [{ type: Input },],
        "startAngle": [{ type: Input },],
        "sweepDirection": [{ type: Input },],
        "brushes": [{ type: Input },],
        "outlines": [{ type: Input },],
        "legendItemTemplate": [{ type: Input },],
        "legendItemBadgeTemplate": [{ type: Input },],
        "isSurfaceInteractionDisabled": [{ type: Input },],
        "formatLabel": [{ type: Input },],
        "formatLegendLabel": [{ type: Input },],
        "pixelScalingRatio": [{ type: Input },],
        "selectionMode": [{ type: Input },],
        "selectedItem": [{ type: Input },],
        "textStyle": [{ type: Input },],
        "labelClick": [{ type: Output },],
        "selectedItemChanging": [{ type: Output },],
        "selectedItemsChanging": [{ type: Output },],
        "selectedItemChanged": [{ type: Output },],
        "selectedItemsChanged": [{ type: Output },],
        "sliceClick": [{ type: Output },],
    };
    return IgxPieChartBaseComponent;
}());
export { IgxPieChartBaseComponent };
//# sourceMappingURL=igx-pie-chart-base-component.js.map