import { EventEmitter, Output, Input } from '@angular/core';
import { delegateCombine } from "igniteui-angular-core/ES5/type";
import { ChartHitTestMode, ChartHitTestMode_$type } from "./ChartHitTestMode";
import { WindowResponse, WindowResponse_$type } from "./WindowResponse";
import { Visibility, Visibility_$type } from "igniteui-angular-core/ES5/Visibility";
import { InteractionState, InteractionState_$type } from "igniteui-angular-core/ES5/InteractionState";
import { ModifierKeys, ModifierKeys_$type } from "igniteui-angular-core/ES5/ModifierKeys";
import { HorizontalAlignment, HorizontalAlignment_$type } from "igniteui-angular-core/ES5/HorizontalAlignment";
import { ChartCursorEventArgs } from "./igx-chart-cursor-event-args";
import { DataChartMouseButtonEventArgs } from "./igx-data-chart-mouse-button-event-args";
import { ChartMouseEventArgs } from "./igx-chart-mouse-event-args";
import { RectChangedEventArgs } from "igniteui-angular-core/ES5/igx-rect-changed-event-args";
import { fromPoint, toPoint, ensureBool, fromRect, toRect, ensureEnum, brushToString, stringToBrush } from "igniteui-angular-core/ES5/componentUtil";
import { SyncSettings } from "./SyncSettings";
/**
 * Represents a control for viewing series objects.
*/
export var IgxSeriesViewerComponent_PROVIDERS = [];
var IgxSeriesViewerComponent = /** @class */ (function () {
    function IgxSeriesViewerComponent() {
        this._seriesCursorMouseMove = null;
        this._seriesMouseLeftButtonDown = null;
        this._seriesMouseLeftButtonUp = null;
        this._seriesMouseMove = null;
        this._seriesMouseEnter = null;
        this._seriesMouseLeave = null;
        this._windowRectChanged = null;
        this._sizeChanged = null;
        this._gridAreaRectChanged = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgxSeriesViewerComponent.prototype.createImplementation = function () {
        return null;
    };
    IgxSeriesViewerComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesViewerComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "crosshairPoint", {
        /**
         * Gets or sets the cross hair point (in world coordinates)
         * Either or both of the crosshair point's X and Y may be set to double.NaN, in which
         * case the relevant crosshair line is hidden.
        */
        get: /**
             * Gets or sets the cross hair point (in world coordinates)
             * Either or both of the crosshair point's X and Y may be set to double.NaN, in which
             * case the relevant crosshair line is hidden.
            */
        function () {
            return fromPoint(this.i.mc);
        },
        set: function (v) {
            this.i.mc = toPoint(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "animateSeriesWhenAxisRangeChanges", {
        /**
         * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
        */
        get: /**
             * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
            */
        function () {
            return this.i.ca;
        },
        set: function (v) {
            this.i.ca = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "viewportRect", {
        /**
         * Gets the viewport rectangle associated with the SeriesViewer, the physical dimensions of the plot area.
        */
        get: /**
             * Gets the viewport rectangle associated with the SeriesViewer, the physical dimensions of the plot area.
            */
        function () {
            return fromRect(this.i.mx);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "effectiveViewport", {
        /**
         * Gets the EffectiveViewport rectangle, representing the effective viewport area after margins have been subtracted.
        */
        get: /**
             * Gets the EffectiveViewport rectangle, representing the effective viewport area after margins have been subtracted.
            */
        function () {
            return fromRect(this.i.mo);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "contentViewport", {
        /**
         * Represents the subset area within the viewport into which content should be mapped.
         * This is the projection of the current EffectiveViewport into the viewport at current zoom level.
        */
        get: /**
             * Represents the subset area within the viewport into which content should be mapped.
             * This is the projection of the current EffectiveViewport into the viewport at current zoom level.
            */
        function () {
            return fromRect(this.i.mn);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRect", {
        /**
         * A rectangle representing the portion of the SeriesViewer currently in view.
         * A rectangle at X=0, Y=0 with a Height and Width of 1 implies the entire plotting area is in view.  A Height and Width of .5 would imply that the view is halfway zoomed in.
        */
        get: /**
             * A rectangle representing the portion of the SeriesViewer currently in view.
             * A rectangle at X=0, Y=0 with a Height and Width of 1 implies the entire plotting area is in view.  A Height and Width of .5 would imply that the view is halfway zoomed in.
            */
        function () {
            return fromRect(this.i.my);
        },
        set: function (v) {
            this.i.my = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "useTiledZooming", {
        /**
         * Gets or sets whether the series viewer should use cached tiles during zooms rather than the default live content.
        */
        get: /**
             * Gets or sets whether the series viewer should use cached tiles during zooms rather than the default live content.
            */
        function () {
            return this.i.dg;
        },
        set: function (v) {
            this.i.dg = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "preferHigherResolutionTiles", {
        /**
         * Gets or sets whether the series viewer should prefer selecting higher resolution tiles over lower resolution tiles when performing tile zooming. Setting this to true will lower performance but increase quality.
        */
        get: /**
             * Gets or sets whether the series viewer should prefer selecting higher resolution tiles over lower resolution tiles when performing tile zooming. Setting this to true will lower performance but increase quality.
            */
        function () {
            return this.i.c8;
        },
        set: function (v) {
            this.i.c8 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "zoomTileCacheSize", {
        /**
         * Gets or sets the maximum number of zoom tiles that the series viewer should cache while in tiled zooming mode.
        */
        get: /**
             * Gets or sets the maximum number of zoom tiles that the series viewer should cache while in tiled zooming mode.
            */
        function () {
            return this.i.e3;
        },
        set: function (v) {
            this.i.e3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "highlightingTransitionDuration", {
        /**
         * Gets or sets the duration the highlighting/de-highlighting effects.
        */
        get: /**
             * Gets or sets the duration the highlighting/de-highlighting effects.
            */
        function () {
            return this.i.e2;
        },
        set: function (v) {
            this.i.e2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "isPagePanningAllowed", {
        /**
         * Gets or sets the whether the series viewer can allow the page to pan if a control pan is not possible in the requested direction.
        */
        get: /**
             * Gets or sets the whether the series viewer can allow the page to pan if a control pan is not possible in the requested direction.
            */
        function () {
            return this.i.cv;
        },
        set: function (v) {
            this.i.cv = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "contentHitTestMode", {
        /**
         * Determines the method of hit testing used when mousing over elements in the chart.
        */
        get: /**
             * Determines the method of hit testing used when mousing over elements in the chart.
            */
        function () {
            return this.i.ap;
        },
        set: function (v) {
            this.i.ap = ensureEnum(ChartHitTestMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualContentHitTestMode", {
        /**
         * Resolved method of hit testing used when the pointer is over elements in the chart.
        */
        get: /**
             * Resolved method of hit testing used when the pointer is over elements in the chart.
            */
        function () {
            return this.i.ao;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "isSurfaceInteractionDisabled", {
        /**
         * Gets or sets whether all surface interactions with the plot area should be disabled.
        */
        get: /**
             * Gets or sets whether all surface interactions with the plot area should be disabled.
            */
        function () {
            return this.i.cw;
        },
        set: function (v) {
            this.i.cw = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "isMap", {
        get: function () {
            return this.i.cu;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowResponse", {
        /**
         * The response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.  The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
        */
        get: /**
             * The response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.  The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
            */
        function () {
            return this.i.ba;
        },
        set: function (v) {
            this.i.ba = ensureEnum(WindowResponse_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRectMinWidth", {
        /**
         * Sets or gets the minimum width that the window rect is allowed to reach before being clamped.
         * Decrease this value if you want to allow for further zooming into the viewer.
         * If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
        */
        get: /**
             * Sets or gets the minimum width that the window rect is allowed to reach before being clamped.
             * Decrease this value if you want to allow for further zooming into the viewer.
             * If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
            */
        function () {
            return this.i.eu;
        },
        set: function (v) {
            this.i.eu = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "syncChannel", {
        /**
         * Sets or gets the Synchronization channel to use for the SeriesViewer.
        */
        get: /**
             * Sets or gets the Synchronization channel to use for the SeriesViewer.
            */
        function () {
            return this.i.gk;
        },
        set: function (v) {
            this.i.gk = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "overviewPlusDetailPaneVisibility", {
        /**
         * The visibility of the OverviewPlusDetailPane.
        */
        get: /**
             * The visibility of the OverviewPlusDetailPane.
            */
        function () {
            return this.i.m2;
        },
        set: function (v) {
            this.i.m2 = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "crosshairVisibility", {
        /**
         * Gets or sets the current SeriesViewer's crosshair visibility override.
        */
        get: /**
             * Gets or sets the current SeriesViewer's crosshair visibility override.
            */
        function () {
            return this.i.m1;
        },
        set: function (v) {
            this.i.m1 = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "plotAreaBackground", {
        /**
         * Gets or sets the brush used as the background for the current SeriesViewer object's plot area.
        */
        get: /**
             * Gets or sets the brush used as the background for the current SeriesViewer object's plot area.
            */
        function () {
            return brushToString(this.i.l7);
        },
        set: function (v) {
            this.i.l7 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "defaultInteraction", {
        /**
         * Gets or sets the DefaultInteraction property.
         * The default interaction state defines the SeriesViewer's response to mouse events.
        */
        get: /**
             * Gets or sets the DefaultInteraction property.
             * The default interaction state defines the SeriesViewer's response to mouse events.
            */
        function () {
            return this.i.bc;
        },
        set: function (v) {
            this.i.bc = ensureEnum(InteractionState_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "dragModifier", {
        /**
         * Gets or sets the current SeriesViewer's DragModifier property.
        */
        get: /**
             * Gets or sets the current SeriesViewer's DragModifier property.
            */
        function () {
            return this.i.lu;
        },
        set: function (v) {
            this.i.lu = ensureEnum(ModifierKeys_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "panModifier", {
        /**
         * Gets or sets the current SeriesViewer's PanModifier property.
        */
        get: /**
             * Gets or sets the current SeriesViewer's PanModifier property.
            */
        function () {
            return this.i.lv;
        },
        set: function (v) {
            this.i.lv = ensureEnum(ModifierKeys_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "previewRect", {
        /**
         * Gets or sets the preview rectangle.
         * The preview rectangle may be set to Rect.Empty, in which case the visible preview
         * strokePath is hidden.
        */
        get: /**
             * Gets or sets the preview rectangle.
             * The preview rectangle may be set to Rect.Empty, in which case the visible preview
             * strokePath is hidden.
            */
        function () {
            return fromRect(this.i.mt);
        },
        set: function (v) {
            this.i.mt = toRect(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowPositionHorizontal", {
        /**
         * A number between 0 and 1 determining the position of the horizontal scroll.
         * This property is effectively a shortcut to the X position of the WindowRect property.
        */
        get: /**
             * A number between 0 and 1 determining the position of the horizontal scroll.
             * This property is effectively a shortcut to the X position of the WindowRect property.
            */
        function () {
            return this.i.es;
        },
        set: function (v) {
            this.i.es = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowPositionVertical", {
        /**
         * A number between 0 and 1 determining the position of the vertical scroll.
         * This property is effectively a shortcut to the Y position of the WindowRect property.
        */
        get: /**
             * A number between 0 and 1 determining the position of the vertical scroll.
             * This property is effectively a shortcut to the Y position of the WindowRect property.
            */
        function () {
            return this.i.et;
        },
        set: function (v) {
            this.i.et = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "chartTitle", {
        /**
         * Text to display above the plot area.
        */
        get: /**
             * Text to display above the plot area.
            */
        function () {
            return this.i.gm;
        },
        set: function (v) {
            this.i.gm = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleHorizontalAlignment", {
        /**
         * Gets or sets the TitleHorizontalAlignment property.
        */
        get: /**
             * Gets or sets the TitleHorizontalAlignment property.
            */
        function () {
            return this.i.lt;
        },
        set: function (v) {
            this.i.lt = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleHorizontalAlignment", {
        /**
         * Gets or sets the SubtitleHorizontalAlignment property.
        */
        get: /**
             * Gets or sets the SubtitleHorizontalAlignment property.
            */
        function () {
            return this.i.ls;
        },
        set: function (v) {
            this.i.ls = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleTextStyle", {
        get: function () {
            return this.i.gt;
        },
        set: function (v) {
            this.i.gt = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleTextStyle", {
        get: function () {
            return this.i.gh;
        },
        set: function (v) {
            this.i.gh = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleTextColor", {
        /**
         * Gets or sets the Color used for the Title Text.
        */
        get: /**
             * Gets or sets the Color used for the Title Text.
            */
        function () {
            return brushToString(this.i.ma);
        },
        set: function (v) {
            this.i.ma = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleTextColor", {
        /**
         * Gets or sets the Color used for the Subtitle Text.
        */
        get: /**
             * Gets or sets the Color used for the Subtitle Text.
            */
        function () {
            return brushToString(this.i.l9);
        },
        set: function (v) {
            this.i.l9 = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleTopMargin", {
        /**
         * Margin applied above the title.
        */
        get: /**
             * Margin applied above the title.
            */
        function () {
            return this.i.eq;
        },
        set: function (v) {
            this.i.eq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleLeftMargin", {
        /**
         * Margin applied to the left of the title.
        */
        get: /**
             * Margin applied to the left of the title.
            */
        function () {
            return this.i.eo;
        },
        set: function (v) {
            this.i.eo = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleRightMargin", {
        /**
         * Margin applied to the right of the title.
        */
        get: /**
             * Margin applied to the right of the title.
            */
        function () {
            return this.i.ep;
        },
        set: function (v) {
            this.i.ep = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "titleBottomMargin", {
        /**
         * Margin applied below the title.
        */
        get: /**
             * Margin applied below the title.
            */
        function () {
            return this.i.en;
        },
        set: function (v) {
            this.i.en = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleTopMargin", {
        /**
         * Margin applied above the subtitle.
        */
        get: /**
             * Margin applied above the subtitle.
            */
        function () {
            return this.i.em;
        },
        set: function (v) {
            this.i.em = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleLeftMargin", {
        /**
         * Margin applied to the left of the subtitle.
        */
        get: /**
             * Margin applied to the left of the subtitle.
            */
        function () {
            return this.i.ek;
        },
        set: function (v) {
            this.i.ek = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleRightMargin", {
        /**
         * Margin applied to the right of the subtitle.
        */
        get: /**
             * Margin applied to the right of the subtitle.
            */
        function () {
            return this.i.el;
        },
        set: function (v) {
            this.i.el = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitleBottomMargin", {
        /**
         * Margin applied below the subtitle.
        */
        get: /**
             * Margin applied below the subtitle.
            */
        function () {
            return this.i.ej;
        },
        set: function (v) {
            this.i.ej = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "subtitle", {
        /**
         * Gets or sets the Subtitle property.
         * The Title property defines the Subtitle of the chart
        */
        get: /**
             * Gets or sets the Subtitle property.
             * The Title property defines the Subtitle of the chart
            */
        function () {
            return this.i.ga;
        },
        set: function (v) {
            this.i.ga = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "SyncChannel", {
        /**
         * Gets or sets the channel with which to synchronize.
        */
        get: /**
             * Gets or sets the channel with which to synchronize.
            */
        function () {
            return this.i.a9 ? this.i.a9.ae : null;
        },
        set: function (v) {
            this.ensureSyncSettings();
            this.i.a9.ae = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "SynchronizeVertically", {
        /**
         * Gets or sets the bool used to display the window preview shadow.
        */
        get: /**
             * Gets or sets the bool used to display the window preview shadow.
            */
        function () {
            return this.i.a9 ? this.i.a9.ad : false;
        },
        set: function (v) {
            this.ensureSyncSettings();
            this.i.a9.ad = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "SynchronizeHorizontally", {
        /**
         * Gets or sets the bool used to display the window preview shadow.
        */
        get: /**
             * Gets or sets the bool used to display the window preview shadow.
            */
        function () {
            return this.i.a9 ? this.i.a9.ac : false;
        },
        set: function (v) {
            this.ensureSyncSettings();
            this.i.a9.ac = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesViewerComponent.prototype.ensureSyncSettings = function () {
        if (this.i.a9) {
            return;
        }
        this.i.a9 = new SyncSettings();
    };
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "topMargin", {
        /**
         * Sets or gets the top margin to use around the chart content.
        */
        get: /**
             * Sets or gets the top margin to use around the chart content.
            */
        function () {
            return this.i.er;
        },
        set: function (v) {
            this.i.er = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "leftMargin", {
        /**
         * Sets or gets the left margin to use around the chart content.
        */
        get: /**
             * Sets or gets the left margin to use around the chart content.
            */
        function () {
            return this.i.eg;
        },
        set: function (v) {
            this.i.eg = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "rightMargin", {
        /**
         * Sets or gets the right margin to use around the chart content.
        */
        get: /**
             * Sets or gets the right margin to use around the chart content.
            */
        function () {
            return this.i.ei;
        },
        set: function (v) {
            this.i.ei = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "bottomMargin", {
        /**
         * Sets or gets the bottom margin to use around the chart content.
        */
        get: /**
             * Sets or gets the bottom margin to use around the chart content.
            */
        function () {
            return this.i.ec;
        },
        set: function (v) {
            this.i.ec = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "autoMarginWidth", {
        /**
         * Sets or gets the automatic width to add when automatically adding margins to the chart.
        */
        get: /**
             * Sets or gets the automatic width to add when automatically adding margins to the chart.
            */
        function () {
            return this.i.eb;
        },
        set: function (v) {
            this.i.eb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "autoMarginHeight", {
        /**
         * Sets or gets the automatic height to add when automatically adding margins to the chart.
        */
        get: /**
             * Sets or gets the automatic height to add when automatically adding margins to the chart.
            */
        function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "isAntiAliasingEnabledDuringInteraction", {
        /**
         * Gets or sets the IsAntiAliasingEnabledDuringInteraction property.
        */
        get: /**
             * Gets or sets the IsAntiAliasingEnabledDuringInteraction property.
            */
        function () {
            return this.i.cm;
        },
        set: function (v) {
            this.i.cm = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "pixelScalingRatio", {
        /**
         * Gets or sets the scaling value used to affect the pixel density of the control.
         * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
         * to appear blurry.
        */
        get: /**
             * Gets or sets the scaling value used to affect the pixel density of the control.
             * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
             * to appear blurry.
            */
        function () {
            return this.i.eh;
        },
        set: function (v) {
            this.i.eh = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "interactionPixelScalingRatio", {
        /**
         * Method of pixel scaling to use during end user interaction with the chart.
        */
        get: /**
             * Method of pixel scaling to use during end user interaction with the chart.
            */
        function () {
            return this.i.ef;
        },
        set: function (v) {
            this.i.ef = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "overviewPlusDetailPaneBackgroundImageUri", {
        /**
         * Uri for the background image to display behind the overview plus detail pane.
        */
        get: /**
             * Uri for the background image to display behind the overview plus detail pane.
            */
        function () {
            return this.i.fy;
        },
        set: function (v) {
            this.i.fy = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualPixelScalingRatio", {
        /**
         * Gets the resolved pixel scaling ratio.
        */
        get: /**
             * Gets the resolved pixel scaling ratio.
            */
        function () {
            return this.i.d7;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualInteractionPixelScalingRatio", {
        /**
         * Resolved method of pixel scaling to use during end user interaction with the chart.
        */
        get: /**
             * Resolved method of pixel scaling to use during end user interaction with the chart.
            */
        function () {
            return this.i.d6;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowRect", {
        /**
         * Gets the actual value of the window rectangle, which represents the current zoom level.
        */
        get: /**
             * Gets the actual value of the window rectangle, which represents the current zoom level.
            */
        function () {
            return fromRect(this.i.mk);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowPositionHorizontal", {
        /**
         * A number between 0 and 1 determining the position of the horizontal scroll.
         * This property is effectively a shortcut to the Left of the ActualWindowRect property.
        */
        get: /**
             * A number between 0 and 1 determining the position of the horizontal scroll.
             * This property is effectively a shortcut to the Left of the ActualWindowRect property.
            */
        function () {
            return this.i.d8;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "actualWindowPositionVertical", {
        /**
         * A number between 0 and 1 determining the position of the vertical scroll.
         * This property is effectively a shortcut to the Top of the ActualWindowRect property.
        */
        get: /**
             * A number between 0 and 1 determining the position of the vertical scroll.
             * This property is effectively a shortcut to the Top of the ActualWindowRect property.
            */
        function () {
            return this.i.d9;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Hides the active main tooltip, if displayed.
    
    */
    /**
         * Hides the active main tooltip, if displayed.
        
        */
    IgxSeriesViewerComponent.prototype.hideToolTip = /**
         * Hides the active main tooltip, if displayed.
        
        */
    function () {
        this.i.hk();
    };
    /**
     * Manually starts a tiled zoom if one isn't already running.
    
    */
    /**
         * Manually starts a tiled zoom if one isn't already running.
        
        */
    IgxSeriesViewerComponent.prototype.startTiledZoomingIfNecessary = /**
         * Manually starts a tiled zoom if one isn't already running.
        
        */
    function () {
        this.i.j2();
    };
    /**
     * Manually ends a tiled zoom if one is running.
    
    */
    /**
         * Manually ends a tiled zoom if one is running.
        
        */
    IgxSeriesViewerComponent.prototype.endTiledZoomingIfRunning = /**
         * Manually ends a tiled zoom if one is running.
        
        */
    function () {
        this.i.hf();
    };
    /**
     * Clears the tile zoom tile cache so that new tiles will be generated. Only applies if the viewer is using a tile based zoom.
    
    */
    /**
         * Clears the tile zoom tile cache so that new tiles will be generated. Only applies if the viewer is using a tile based zoom.
        
        */
    IgxSeriesViewerComponent.prototype.clearTileZoomCache = /**
         * Clears the tile zoom tile cache so that new tiles will be generated. Only applies if the viewer is using a tile based zoom.
        
        */
    function () {
        this.i.g9();
    };
    /**
     * Resets the zoom level to default.
    
    */
    /**
         * Resets the zoom level to default.
        
        */
    IgxSeriesViewerComponent.prototype.resetZoom = /**
         * Resets the zoom level to default.
        
        */
    function () {
        this.i.jw();
    };
    /**
     * Gets actual window scale for horizontal dimension of the control
    
    */
    /**
         * Gets actual window scale for horizontal dimension of the control
        
        */
    IgxSeriesViewerComponent.prototype.getActualWindowScaleHorizontal = /**
         * Gets actual window scale for horizontal dimension of the control
        
        */
    function () {
        var iv = this.i.ed();
        return (iv);
    };
    /**
     * Gets actual window scale for vertical dimension of the control
    
    */
    /**
         * Gets actual window scale for vertical dimension of the control
        
        */
    IgxSeriesViewerComponent.prototype.getActualWindowScaleVertical = /**
         * Gets actual window scale for vertical dimension of the control
        
        */
    function () {
        var iv = this.i.ee();
        return (iv);
    };
    /**
     * Notification from the containing object that the container has been resized.
    
    */
    /**
         * Notification from the containing object that the container has been resized.
        
        */
    IgxSeriesViewerComponent.prototype.notifyContainerResized = /**
         * Notification from the containing object that the container has been resized.
        
        */
    function () {
        this.i.notifyContainerResized();
    };
    /**
     * Attaches the given series to the chart.
    
    * @param s  * The series to attach to the chart.
    */
    /**
         * Attaches the given series to the chart.
        
        * @param s  * The series to attach to the chart.
        */
    IgxSeriesViewerComponent.prototype.attachSeries = /**
         * Attaches the given series to the chart.
        
        * @param s  * The series to attach to the chart.
        */
    function (s) {
        this.i.g7((s == null ? null : s.i));
    };
    IgxSeriesViewerComponent.prototype.notifySetItem = function (source_, index, oldItem, newItem) {
        this.i.hw(source_, index, oldItem, newItem);
    };
    /**
     * Used to manually notify the SeriesViewer that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
    
    * @param source_  * The data source which was cleared or reset.
    */
    /**
         * Used to manually notify the SeriesViewer that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
        
        * @param source_  * The data source which was cleared or reset.
        */
    IgxSeriesViewerComponent.prototype.notifyClearItems = /**
         * Used to manually notify the SeriesViewer that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
        
        * @param source_  * The data source which was cleared or reset.
        */
    function (source_) {
        this.i.hr(source_);
    };
    IgxSeriesViewerComponent.prototype.notifyInsertItem = function (source_, index, newItem) {
        this.i.hu(source_, index, newItem);
    };
    IgxSeriesViewerComponent.prototype.notifyRemoveItem = function (source_, index, oldItem) {
        this.i.hv(source_, index, oldItem);
    };
    /**
     * Release any resources held by the control.
    
    */
    /**
         * Release any resources held by the control.
        
        */
    IgxSeriesViewerComponent.prototype.destroy = /**
         * Release any resources held by the control.
        
        */
    function () {
        this.i.hd();
    };
    /**
     * Use to force the SeriesViewer to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the SeriesViewer needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the SeriesViewer.
    
    */
    /**
         * Use to force the SeriesViewer to finish any deferred work before printing or evaluating its visual.
         * This should only be called if the visual of the SeriesViewer needs to be synchronously saved or evaluated.
         * Calling this method too often will hinder the performance of the SeriesViewer.
        
        */
    IgxSeriesViewerComponent.prototype.flush = /**
         * Use to force the SeriesViewer to finish any deferred work before printing or evaluating its visual.
         * This should only be called if the visual of the SeriesViewer needs to be synchronously saved or evaluated.
         * Calling this method too often will hinder the performance of the SeriesViewer.
        
        */
    function () {
        this.i.flush();
    };
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesCursorMouseMove", {
        get: /**
             * Occurs when the cursors are moved over a series in this SeriesViewer.
            */
        function () {
            var _this = this;
            if (this._seriesCursorMouseMove == null) {
                this._seriesCursorMouseMove = new EventEmitter();
                this.i.seriesCursorMouseMove = delegateCombine(this.i.seriesCursorMouseMove, function (o, e) {
                    var outerArgs = new ChartCursorEventArgs();
                    outerArgs._provideImplementation(e);
                    _this._seriesCursorMouseMove.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._seriesCursorMouseMove;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseLeftButtonDown", {
        get: /**
             * Occurs when the left mouse button is pressed while the mouse pointer is over a Series.
            */
        function () {
            var _this = this;
            if (this._seriesMouseLeftButtonDown == null) {
                this._seriesMouseLeftButtonDown = new EventEmitter();
                this.i.seriesMouseLeftButtonDown = delegateCombine(this.i.seriesMouseLeftButtonDown, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new DataChartMouseButtonEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesMouseLeftButtonDown.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesMouseLeftButtonDown;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseLeftButtonUp", {
        get: /**
             * Occurs when the left mouse button is released while the mouse pointer is over a Series.
            */
        function () {
            var _this = this;
            if (this._seriesMouseLeftButtonUp == null) {
                this._seriesMouseLeftButtonUp = new EventEmitter();
                this.i.seriesMouseLeftButtonUp = delegateCombine(this.i.seriesMouseLeftButtonUp, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new DataChartMouseButtonEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesMouseLeftButtonUp.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesMouseLeftButtonUp;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseMove", {
        get: /**
             * Occurs when the mouse pointer moves while over a Series.
            */
        function () {
            var _this = this;
            if (this._seriesMouseMove == null) {
                this._seriesMouseMove = new EventEmitter();
                this.i.seriesMouseMove = delegateCombine(this.i.seriesMouseMove, function (o, e) {
                    var outerArgs = new ChartMouseEventArgs();
                    outerArgs._provideImplementation(e);
                    _this._seriesMouseMove.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._seriesMouseMove;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseEnter", {
        get: /**
             * Occurs when the mouse pointer enters a Series.
            */
        function () {
            var _this = this;
            if (this._seriesMouseEnter == null) {
                this._seriesMouseEnter = new EventEmitter();
                this.i.seriesMouseEnter = delegateCombine(this.i.seriesMouseEnter, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new ChartMouseEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesMouseEnter.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesMouseEnter;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "seriesMouseLeave", {
        get: /**
             * Occurs when the mouse pointer leaves a Series.
            */
        function () {
            var _this = this;
            if (this._seriesMouseLeave == null) {
                this._seriesMouseLeave = new EventEmitter();
                this.i.seriesMouseLeave = delegateCombine(this.i.seriesMouseLeave, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new ChartMouseEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._seriesMouseLeave.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._seriesMouseLeave;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "windowRectChanged", {
        get: /**
             * Occurs just after the current SeriesViewer's window rectangle is changed.
            */
        function () {
            var _this = this;
            if (this._windowRectChanged == null) {
                this._windowRectChanged = new EventEmitter();
                this.i.windowRectChanged = delegateCombine(this.i.windowRectChanged, function (o, e) {
                    var outerArgs = new RectChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    _this._windowRectChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._windowRectChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "sizeChanged", {
        get: /**
             * Occurs after the size of the series viewer changes.
            */
        function () {
            var _this = this;
            if (this._sizeChanged == null) {
                this._sizeChanged = new EventEmitter();
                this.i.sizeChanged = delegateCombine(this.i.sizeChanged, function (o, e) {
                    var outerArgs = new RectChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    _this._sizeChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._sizeChanged;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesViewerComponent.prototype, "gridAreaRectChanged", {
        get: /**
             * Occurs just after the current SeriesViewer's grid area rectangle is changed.
             * The grid area may change as the result of the SeriesViewer being resized, or
             * of an axis being added or changing size, possibly in another SeriesViewer.
            */
        function () {
            var _this = this;
            if (this._gridAreaRectChanged == null) {
                this._gridAreaRectChanged = new EventEmitter();
                this.i.gridAreaRectChanged = delegateCombine(this.i.gridAreaRectChanged, function (o, e) {
                    var outerArgs = new RectChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    _this._gridAreaRectChanged.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._gridAreaRectChanged;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesViewerComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxSeriesViewerComponent.propDecorators = {
        "crosshairPoint": [{ type: Input },],
        "animateSeriesWhenAxisRangeChanges": [{ type: Input },],
        "windowRect": [{ type: Input },],
        "useTiledZooming": [{ type: Input },],
        "preferHigherResolutionTiles": [{ type: Input },],
        "zoomTileCacheSize": [{ type: Input },],
        "highlightingTransitionDuration": [{ type: Input },],
        "isPagePanningAllowed": [{ type: Input },],
        "contentHitTestMode": [{ type: Input },],
        "isSurfaceInteractionDisabled": [{ type: Input },],
        "windowResponse": [{ type: Input },],
        "windowRectMinWidth": [{ type: Input },],
        "syncChannel": [{ type: Input },],
        "overviewPlusDetailPaneVisibility": [{ type: Input },],
        "crosshairVisibility": [{ type: Input },],
        "plotAreaBackground": [{ type: Input },],
        "defaultInteraction": [{ type: Input },],
        "dragModifier": [{ type: Input },],
        "panModifier": [{ type: Input },],
        "previewRect": [{ type: Input },],
        "windowPositionHorizontal": [{ type: Input },],
        "windowPositionVertical": [{ type: Input },],
        "chartTitle": [{ type: Input },],
        "titleHorizontalAlignment": [{ type: Input },],
        "subtitleHorizontalAlignment": [{ type: Input },],
        "titleTextStyle": [{ type: Input },],
        "subtitleTextStyle": [{ type: Input },],
        "titleTextColor": [{ type: Input },],
        "subtitleTextColor": [{ type: Input },],
        "titleTopMargin": [{ type: Input },],
        "titleLeftMargin": [{ type: Input },],
        "titleRightMargin": [{ type: Input },],
        "titleBottomMargin": [{ type: Input },],
        "subtitleTopMargin": [{ type: Input },],
        "subtitleLeftMargin": [{ type: Input },],
        "subtitleRightMargin": [{ type: Input },],
        "subtitleBottomMargin": [{ type: Input },],
        "subtitle": [{ type: Input },],
        "SyncChannel": [{ type: Input },],
        "SynchronizeVertically": [{ type: Input },],
        "SynchronizeHorizontally": [{ type: Input },],
        "topMargin": [{ type: Input },],
        "leftMargin": [{ type: Input },],
        "rightMargin": [{ type: Input },],
        "bottomMargin": [{ type: Input },],
        "autoMarginWidth": [{ type: Input },],
        "autoMarginHeight": [{ type: Input },],
        "isAntiAliasingEnabledDuringInteraction": [{ type: Input },],
        "pixelScalingRatio": [{ type: Input },],
        "interactionPixelScalingRatio": [{ type: Input },],
        "overviewPlusDetailPaneBackgroundImageUri": [{ type: Input },],
        "seriesCursorMouseMove": [{ type: Output },],
        "seriesMouseLeftButtonDown": [{ type: Output },],
        "seriesMouseLeftButtonUp": [{ type: Output },],
        "seriesMouseMove": [{ type: Output },],
        "seriesMouseEnter": [{ type: Output },],
        "seriesMouseLeave": [{ type: Output },],
        "windowRectChanged": [{ type: Output },],
        "sizeChanged": [{ type: Output },],
        "gridAreaRectChanged": [{ type: Output },],
    };
    return IgxSeriesViewerComponent;
}());
export { IgxSeriesViewerComponent };
//# sourceMappingURL=igx-series-viewer-component.js.map