import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { StandardDeviationIndicator } from "./StandardDeviationIndicator";
/**
 * Represents a IgxDataChartComponent Standard Deviation indicator series.
 * Default required members: High, Low, Close
*/
export var IgxStandardDeviationIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }];
var IgxStandardDeviationIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxStandardDeviationIndicatorComponent, _super);
    function IgxStandardDeviationIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxStandardDeviationIndicatorComponent.prototype.createImplementation = function () {
        return new StandardDeviationIndicator();
    };
    Object.defineProperty(IgxStandardDeviationIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxStandardDeviationIndicatorComponent.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current StandardDeviationIndicator object.
         * The typical, and initial, value for STDEV periods is 20.
        */
        get: /**
             * Gets or sets the moving average period for the current StandardDeviationIndicator object.
             * The typical, and initial, value for STDEV periods is 20.
            */
        function () {
            return this.i.qc;
        },
        set: function (v) {
            this.i.qc = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxStandardDeviationIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-standard-deviation-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxStandardDeviationIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxStandardDeviationIndicatorComponent.ctorParameters = function () { return []; };
    IgxStandardDeviationIndicatorComponent.propDecorators = {
        "period": [{ type: Input },],
    };
    return IgxStandardDeviationIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxStandardDeviationIndicatorComponent };
//# sourceMappingURL=igx-standard-deviation-indicator-component.js.map