import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from "./igx-strategy-based-indicator-component";
import { IgxFinancialIndicatorComponent } from "./igx-financial-indicator-component";
import { IgxFinancialSeriesComponent } from "./igx-financial-series-component";
import { IgxSeriesComponent } from "./igx-series-component";
import { TRIXIndicator } from "./TRIXIndicator";
/**
 * Represents a IgxDataChartComponent TRIX indicator series.
 * Default required members: Close
*/
export var IgxTRIXIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxTRIXIndicatorComponent; }) }];
var IgxTRIXIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxTRIXIndicatorComponent, _super);
    function IgxTRIXIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxTRIXIndicatorComponent.prototype.createImplementation = function () {
        return new TRIXIndicator();
    };
    Object.defineProperty(IgxTRIXIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxTRIXIndicatorComponent.prototype, "period", {
        /**
         * Gets or sets the moving average period for the current TRIXIndicator object.
         * The typical, and initial, value for TRIX periods is 15.
        */
        get: /**
             * Gets or sets the moving average period for the current TRIXIndicator object.
             * The typical, and initial, value for TRIX periods is 15.
            */
        function () {
            return this.i.qc;
        },
        set: function (v) {
            this.i.qc = +v;
        },
        enumerable: true,
        configurable: true
    });
    IgxTRIXIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-trix-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxTRIXIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxTRIXIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxTRIXIndicatorComponent.ctorParameters = function () { return []; };
    IgxTRIXIndicatorComponent.propDecorators = {
        "period": [{ type: Input },],
    };
    return IgxTRIXIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxTRIXIndicatorComponent };
//# sourceMappingURL=igx-trix-indicator-component.js.map